{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit AppDlg;
{$B-}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ColorGrd, ComCtrls, StdCtrls, Buttons, Spin, ExtDlgs, ExtCtrls;

type
  TAppPropsForm = class(TForm)
    OkBitBtn: TBitBtn;
    HelpBitBtn: TBitBtn;
    PageControl: TPageControl;
    DataWindowTabSheet: TTabSheet;
    ImageList: TImageList;
    GeneralTabSheet: TTabSheet;
    LeaderLabel: TLabel;
    LeaderSpinEdit: TSpinEdit;
    InitialViewRadioGroup: TRadioGroup;
    CalTableGroupBox: TGroupBox;
    ShowGroupBox: TGroupBox;
    BackgroundEdit: TEdit;
    BackgroundSpeedButton: TSpeedButton;
    BackgroundCheckBox: TCheckBox;
    OpenDialog: TOpenDialog;
    OpenPictureDialog: TOpenPictureDialog;
    SaveOnExitCheckBox: TCheckBox;
    ShowCoolbarCheckBox: TCheckBox;
    ShowStatusbarCheckBox: TCheckBox;
    ShowWindowToolbarCheckBox: TCheckBox;
    ShowSerieToolbarCheckBox: TCheckBox;
    ShowPlotToolbarCheckBox: TCheckBox;
    CalTableFilenameLabel: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    CalTableColumnLabel: TLabel;
    GeneralGroupBox: TGroupBox;
    CopyPropertiesCheckBox: TCheckBox;
    AutoNameSerieCheckBox: TCheckBox;
    AutoNameAxisCheckBox: TCheckBox;
    BackupCheckBox: TCheckBox;
    UseTabsCheckBox: TCheckBox;
    GroupUndoCheckBox: TCheckBox;
    BkgTileRadioButton: TRadioButton;
    ShowPictureCheckBox: TCheckBox;
    BkgCenterRadioButton: TRadioButton;
    BkgStretchRadioButton: TRadioButton;
    Bevel: TBevel;
    BackgroundLabel: TLabel;
    AutoSaveCheckBox: TCheckBox;
    HomepageLabel: TLabel;
    HomepageEdit: TEdit;
    HomepageSpeedButton: TSpeedButton;
    ScriptLabel: TLabel;
    ScriptSpinEdit: TSpinEdit;
    ScriptCheckBox: TCheckBox;
    ScriptBevel: TBevel;
    TemplateCheckBox: TCheckBox;
    TemplateEdit: TEdit;
    TemplateSpeedButton: TSpeedButton;
    UseMetaBaseCheckBox: TCheckBox;
    ClearDescriptionCheckBox: TCheckBox;
    MetaBaseGroupBox: TGroupBox;
    ProviderPropsSpeedButton: TSpeedButton;
    ProviderComboBox: TComboBox;
    AutoSaveLabel: TLabel;
    AutoSaveSpinEdit: TSpinEdit;
    ShowHintsCheckBox: TCheckBox;
    ShowScaleToolbarCheckBox: TCheckBox;
    ShowEditToolbarCheckBox: TCheckBox;
    MonitorGroupBox: TGroupBox;
    HostNameLabel: TLabel;
    PasswordLabel: TLabel;
    IPPortLabel: TLabel;
    BrowseComputerSpeedButton: TSpeedButton;
    HostNameEdit: TEdit;
    PasswordEdit: TEdit;
    IPPortSpinEdit: TSpinEdit;
    Bevel2: TBevel;
    ViewTabSheet: TTabSheet;
    SpecialWindowsGroupBox: TGroupBox;
    UseTaskbarCheckBox: TCheckBox;
    UseDockingCheckBox: TCheckBox;
    ToolbarBkgPanel: TPanel;
    ToolbarBkgCheckBox: TCheckBox;
    ToolbarBkgEdit: TEdit;
    ToolbarBkgSpeedButton: TSpeedButton;
    ToolbarBkgLabel: TLabel;
    ToolbarBkgLeftRadioButton: TRadioButton;
    ToolbarBkgTileRadioButton: TRadioButton;
    ToolbarBkgStretchRadioButton: TRadioButton;
    SkinGroupBox: TGroupBox;
    SkinLabel: TLabel;
    SkinEdit: TEdit;
    SkinOpenSpeedButton: TSpeedButton;
    SkinSaveSpeedButton: TSpeedButton;
    SkinColorGrid: TColorGrid;
    SkinColorBitBtn: TBitBtn;
    SkinFontBitBtn: TBitBtn;
    SkinListBox: TListBox;
    AutoScaleCheckBox: TCheckBox;
    SaveDialog: TSaveDialog;
    ColorDialog: TColorDialog;
    FontDialog: TFontDialog;
    TemplateLabel: TLabel;
    SkinClearSpeedButton: TSpeedButton;
    procedure AutoSaveCheckBoxClick(Sender: TObject);
    procedure TemplateSpeedButtonClick(Sender: TObject);
    procedure BackgroundCheckBoxClick(Sender: TObject);
    procedure BackgroundSpeedButtonClick(Sender: TObject);
    procedure BackgroundEditChange(Sender: TObject);
    procedure TemplateEditChange(Sender: TObject);
    procedure HomepageSpeedButtonClick(Sender: TObject);
    procedure ProviderPropsSpeedButtonClick(Sender: TObject);
    procedure BkgRadioButtonClick(Sender: TObject);
    procedure ScriptCheckBoxClick(Sender: TObject);
    procedure BrowseComputerSpeedButtonClick(Sender: TObject);
    procedure ToolbarBkgCheckBoxClick(Sender: TObject);
    procedure ToolbarBkgSpeedButtonClick(Sender: TObject);
    procedure SkinOpenSpeedButtonClick(Sender: TObject);
    procedure SkinSaveSpeedButtonClick(Sender: TObject);
    procedure SkinColorBitBtnClick(Sender: TObject);
    procedure SkinFontBitBtnClick(Sender: TObject);
    procedure SkinColorGridChange(Sender: TObject);
    procedure SkinListBoxClick(Sender: TObject);
    procedure SkinClearSpeedButtonClick(Sender: TObject);
  private
    { Private declarations }
    Providers: array[0..15] of string[250];         // keep provider filenames
    ProviderIndex: integer;                    // keep previous provider index
    LockSkinColor: boolean;                       // used when changing colors
    procedure ReadProviders;
  public
    { Public declarations }
    procedure Execute;
  end;

var AppPropsForm: TAppPropsForm;

implementation

uses
  MainWnd, Registry, About, Strings, ShlObj, MDIWallP, NotesWnd, INIFiles;

{$R *.DFM}

{ TAppPropsForm }

procedure TAppPropsForm.Execute;
begin
  CalTableFileNameLabel.Caption:=MainForm.Container.FileName;
  CalTableColumnLabel.Caption:=IntToStr(MainForm.Container.Tag);
  ReadProviders; ShowModal;
  with TRegistry.Create do
  try                     // write ONLY if key exists and provider was CHANGED
    if (ProviderIndex<>ProviderComboBox.ItemIndex) and
    OpenKey(MetaBaseRegKey, false) then
    begin
      WriteString('Provider',Providers[ProviderComboBox.ItemIndex]); CloseKey;
    end;
    if (not SaveOnExitCheckBox.Checked) and   // save immediately! not on exit
    OpenKey(DataMasterRegKey+'\'+Self.ClassName, false) then 
    with SaveOnExitCheckBox do WriteBool(Name, Checked);
  finally
    Free;
  end;
end;

/// event handlers: ///
procedure TAppPropsForm.AutoSaveCheckBoxClick(Sender: TObject);
begin
  if AutoSaveCheckBox.Checked then
  begin AutoSaveSpinEdit.Enabled:=true; AutoSaveLabel.Enabled:=true; end else
  begin
    AutoSaveSpinEdit.Enabled:=false; AutoSaveSpinEdit.Value:=0;
    AutoSaveLabel.Enabled:=false;
  end;
end;

procedure TAppPropsForm.TemplateSpeedButtonClick(Sender: TObject);
begin
  with OpenDialog do
  begin
    FileName:=''; FilterIndex:=1; if Execute then TemplateEdit.Text:=FileName;
  end;
end;

procedure TAppPropsForm.BackgroundCheckBoxClick(Sender: TObject);
begin
  if BackgroundCheckBox.Checked then BackgroundEditChange(Sender) else
  begin MainForm.MDIWallpaper.Bitmap.Assign(nil); BackgroundEdit.Text:='';end;
  InvalidateRect(MainForm.MDIWallpaper.ClientHandle,nil,true);
  BkgTileRadioButton.Enabled:=BackgroundCheckBox.Checked;
  BkgCenterRadioButton.Enabled:=BackgroundCheckBox.Checked;
  BkgStretchRadioButton.Enabled:=BackgroundCheckBox.Checked;
  BackgroundSpeedButton.Enabled:=BackgroundCheckBox.Checked;
end;

procedure TAppPropsForm.BackgroundSpeedButtonClick(Sender: TObject);
begin
  OpenPictureDialog.FileName:=''; if OpenPictureDialog.Execute then
  BackgroundEdit.Text:=OpenPictureDialog.FileName;
end;

procedure TAppPropsForm.BackgroundEditChange(Sender: TObject);
begin
  if BackgroundEdit.Text<>'' then
  begin
    try
      MainForm.MDIWallpaper.Bitmap.LoadFromFile(BackgroundEdit.Text);
    except
      BackgroundCheckBox.Checked:=false; BackgroundCheckBoxClick(Sender);
    end;
    InvalidateRect(MainForm.MDIWallpaper.ClientHandle,nil,true);
  end;
end;

procedure TAppPropsForm.TemplateEditChange(Sender: TObject);
begin
  if TemplateEdit.Text='' then TemplateCheckBox.Checked:=false;
end;

procedure TAppPropsForm.HomepageSpeedButtonClick(Sender: TObject);
begin
  with OpenDialog do
  begin
    FileName:=''; FilterIndex:=2; if Execute then HomepageEdit.Text:=FileName;
  end;
end;

procedure TAppPropsForm.ReadProviders;
var I: integer; s: string;
begin
  with TRegistry.Create do
  try
    if OpenKeyReadOnly(MetaBaseRegKey+'\Providers') then
    begin
      GetValueNames(ProviderComboBox.Items);                 // read providers
      with ProviderComboBox do                         // read their filenames
      for I:=0 to Items.Count-1 do Items[I]:=ReadString(Items[I]);
      CloseKey; OpenKeyReadOnly(MetaBaseRegKey);   // get index of current one
      ProviderIndex:=ProviderComboBox.Items.IndexOf(ReadString('Provider'));
      with ProviderComboBox do for I:=0 to Items.Count-1 do
      begin
        Providers[I]:=Items[I];                                    // remember
        s:=GetVersionString('FileDescription',Items[I]);
        if s<>'' then Items[I]:=s;         // change filenames to descriptions
      end;
      ProviderComboBox.ItemIndex:=ProviderIndex;
    end;
  finally
    Free;
  end;
end;

procedure TAppPropsForm.ProviderPropsSpeedButtonClick(Sender: TObject);
var
  LibH: THandle; Proc: procedure(hDlg: HWND); stdcall;
  PName: array[0..MAX_PATH] of char;
begin
  if ProviderComboBox.ItemIndex<0 then                 // no provider selected
  begin MessageDlg(strNoProvider,mtError,[mbCancel],0); Exit; end;
  MainForm.DisplayHint(strReadingMetabase); Screen.Cursor:=crHourGlass;
  StrPCopy(PName,Providers[ProviderComboBox.ItemIndex]);
  LibH:=LoadLibrary(PName);
  MainForm.DisplayHint(''); Screen.Cursor:=crDefault;
  if LibH<>0 then
  try
    Proc:=GetProcAddress(LibH, 'SetupProvider');
    if Assigned(Proc) then Proc(Handle) else
    MessageDlg(strInvalidProvider,mtError,[mbCancel],0);
  finally
    FreeLibrary(LibH);
  end else MessageDlg(strInvalidProvider,mtError,[mbCancel],0);
end;

procedure TAppPropsForm.BkgRadioButtonClick(Sender: TObject);
begin
  if BkgTileRadioButton.Checked then MainForm.MDIWallPaper.Mode:=wpTile else
  if BkgCenterRadioButton.Checked then MainForm.MDIWallPaper.Mode:=wpCenter
  else if BkgStretchRadioButton.Checked then
  MainForm.MDIWallPaper.Mode:=wpStretch;
end;

procedure TAppPropsForm.ScriptCheckBoxClick(Sender: TObject);
begin
  ScriptSpinEdit.Enabled:=ScriptCheckBox.Checked;
  ScriptLabel.Enabled:=ScriptCheckBox.Checked;
end;

procedure TAppPropsForm.BrowseComputerSpeedButtonClick(Sender: TObject);
var BrowseInfo: TBrowseInfo; Root, Res: PItemIDList;
begin
  FillChar(BrowseInfo,SizeOf(BrowseInfo),0);
  BrowseInfo.hwndOwner:=Handle;
  BrowseInfo.lpszTitle:='Select computer:';
  ShGetSpecialFolderLocation(0, CSIDL_NETWORK, Root);
  BrowseInfo.pidlRoot:=Root;
  BrowseInfo.ulFlags:=BIF_BROWSEFORCOMPUTER;
  GetMem(BrowseInfo.pszDisplayName, MAX_PATH);
  try
    Res:=ShBrowseForFolder(BrowseInfo);
    if Res<>nil then HostNameEdit.Text:=BrowseInfo.pszDisplayName;
{Attention! this code is a "fast and dirty" solution. The correct way is to
use shell memory allocator as in filectrl.SelectDirectory(). It is more
safe and prevents memory leaks (see also help on ShBrowseForFolder).}
  finally
    FreeMem(BrowseInfo.pszDisplayName, MAX_PATH);
  end;
end;

procedure TAppPropsForm.ToolbarBkgCheckBoxClick(Sender: TObject);
var I: integer;
begin
  for I:=0 to ToolbarBkgPanel.ControlCount-1 do
  ToolbarBkgPanel.Controls[I].Enabled:=ToolbarBkgCheckBox.Checked;
  if not ToolbarBkgCheckBox.Checked then ToolbarBkgEdit.Text:='';
end;

procedure TAppPropsForm.ToolbarBkgSpeedButtonClick(Sender: TObject);
begin
  OpenPictureDialog.FileName:=''; if OpenPictureDialog.Execute then
  ToolbarBkgEdit.Text:=OpenPictureDialog.FileName;
end;

procedure TAppPropsForm.SkinColorBitBtnClick(Sender: TObject);
begin
 if ColorDialog.Execute then
 begin
   MainForm.SetSkinColors; LockSkinColor:=true;
   SkinColorGrid.ForegroundIndex:=-1; LockSkinColor:=false;
 end;
end;

procedure TAppPropsForm.SkinColorGridChange(Sender: TObject);
begin
  if LockSkinColor then Exit;
  ColorDialog.Color:=SkinColorGrid.ForegroundColor; MainForm.SetSkinColors;
end;

procedure TAppPropsForm.SkinClearSpeedButtonClick(Sender: TObject);
begin SkinEdit.Text:=''; end;

procedure TAppPropsForm.SkinOpenSpeedButtonClick(Sender: TObject);
begin
  with OpenDialog do
  begin
    FileName:=''; FilterIndex:=3; if Execute then SkinEdit.Text:=FileName;
    MainForm.ApplySkin;
  end;
end;

procedure TAppPropsForm.SkinFontBitBtnClick(Sender: TObject);
begin MainForm.SetSkinFonts; end;

procedure TAppPropsForm.SkinSaveSpeedButtonClick(Sender: TObject);
var INI: TINIFile;
  procedure doFontColor(Sect: shortstring; F: TFont; C: TColor);
  begin
    INI.WriteInteger(Sect, 'BkgColor', C);
    INI.WriteInteger(Sect, 'FntColor', F.Color);
    INI.WriteString(Sect, 'FntName', F.Name);
    INI.WriteInteger(Sect, 'FntSize', F.Size);
    INI.WriteBool(Sect, 'FntBold', fsBold in F.Style);
    INI.WriteBool(Sect, 'FntItalic', fsItalic in F.Style);
  end;
begin
  if not SaveDialog.Execute then Exit;
  INI:=TINIFile.Create(SaveDialog.FileName);
  try
    // menu
    with MainForm.ActionMainMenuBar do doFontColor('Menu',Font,Color);
    // toolbars
    with MainForm.CoolBar do doFontColor('ToolBar',Font,Color);
    INI.WriteString('ToolBar','BkgFile',ToolbarBkgEdit.Text);
    if ToolbarBkgLeftRadioButton.Checked    // as in TMainForm.WriteRegistry()
    then INI.WriteInteger('ToolBar','BkgMode',0) else
    if ToolbarBkgTileRadioButton.Checked
    then INI.WriteInteger('ToolBar','BkgMode',1)
    else INI.WriteInteger('ToolBar','BkgMode',2);
    INI.WriteBool('ToolBar','UseBkg',ToolbarBkgCheckBox.Checked);
    // statusbars
    with MainForm.StatusBar do doFontColor('StatusBar',Font,Color);
    // popups
    with NotesForm.Memo do doFontColor('Popup',Font,Color);
    // main window
    with MainForm do doFontColor('Main',Font,Color);
    INI.WriteString('Main','BkgFile',BackgroundEdit.Text);
    INI.WriteInteger('Main','BkgMode',integer(MainForm.MDIWallPaper.Mode));
    INI.WriteBool('Main','UseBkg',BackgroundCheckBox.Checked);
    // filename remembered in the registry (skin also applied in ReadRegistry)
    SkinEdit.Text:=SaveDialog.FileName;
  finally
    INI.Free;
  end;
end;

procedure TAppPropsForm.SkinListBoxClick(Sender: TObject);
  procedure SetFontCol(F: TFont; C: TColor);
  begin ColorDialog.Color:=C; FontDialog.Font:=F; end;
begin
  LockSkinColor:=true;
  SkinColorGrid.ForegroundIndex:=-1; LockSkinColor:=false;
  case SkinListBox.ItemIndex of
    0: SetFontCol(MainForm.ActionMainMenuBar.Font,MainForm.MenuPanel.Color);
    1: SetFontCol(MainForm.CoolBar.Font,MainForm.CoolBar.Color);
    2: SetFontCol(MainForm.StatusBar.Font,MainForm.StatusBar.Color);
    3: SetFontCol(NotesForm.Memo.Font,NotesForm.Memo.Color);
    4: SetFontCol(MainForm.Font,MainForm.Color);
  end;
end;

end.
