{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit FCopyDlg;
{$B-}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, Grids, WorkGrid, Data;

type
  TFunctionCopyForm = class(TForm)
    HelpBitBtn: TBitBtn;
    PrevBitBtn: TBitBtn;
    NextBitBtn: TBitBtn;
    CancelBitBtn: TBitBtn;
    Notebook: TNotebook;
    Bevel: TBevel;
    FuncImage: TImage;
    Container: TContainer;
    DstImage: TImage;
    SrcImage: TImage;
    SrcLabel: TLabel;
    SrcXColLabel: TLabel;
    SrcYColLabel: TLabel;
    SrcFirstLineLabel: TLabel;
    SrcLastLineLabel: TLabel;
    SrcXColStaticText: TStaticText;
    SrcYColStaticText: TStaticText;
    SrcFirstLineStaticText: TStaticText;
    SrcLastLineStaticText: TStaticText;
    SrcWindowStaticText: TStaticText;
    SrcWindowLabel: TLabel;
    DstLabel: TLabel;
    DstWindowLabel: TLabel;
    DstWindowStaticText: TStaticText;
    DstXColLabel: TLabel;
    DstXColStaticText: TStaticText;
    DstFirstLineLabel: TLabel;
    DstFirstLineStaticText: TStaticText;
    DstLastLineLabel: TLabel;
    DstLastLineStaticText: TStaticText;
    FuncLabel: TLabel;
    DstYColLabel: TLabel;
    FuncExpressionLabel: TLabel;
    FuncComboBox: TComboBox;
    FuncSpeedButton: TSpeedButton;
    SrcLabel1: TLabel;
    DstLabel1: TLabel;
    FinishBitBtn: TBitBtn;
    FuncSrcLabel: TLabel;
    FuncDstLabel: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure NextBitBtnClick(Sender: TObject);
    procedure PrevBitBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CancelBitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FinishBitBtnClick(Sender: TObject);
    function ContainerCompare(Sender: TObject; I1,
      I2: TData): TCompareResult;
    procedure FuncSpeedButtonClick(Sender: TObject);
  private
    { Private declarations }
    SrcData, DstData: TContainer;              // use tags to remember x,y,f,l
  end;

procedure CopyFunction;

implementation

uses DataWnd, MainWnd, Strings, Common, CalcDlg, TextDlg;

{$R *.dfm}

procedure CopyFunction;
begin                                // note: window destroyed by FormClose()!
  with TFunctionCopyForm.Create(Application) do
  begin
    HelpBitBtn.OnClick:=MainForm.HelpButtonClick; Show;
    FuncComboBox.Items.Assign(CalculatorForm.ExpressionComboBox.Items);
  end;
end;

{ TFunctionCopyForm }

procedure TFunctionCopyForm.FormCreate(Sender: TObject);
begin Tag:=ClientHeight; end;

procedure TFunctionCopyForm.FormActivate(Sender: TObject);
var X,Y,F,L: integer; SX,SY,SF,SL,Win: TCaption; C: TContainer;
begin
  ClientHeight:=Tag;
  with MainForm.ActiveDataForm do if ActiveControl=PlotPanel then
  begin
    X:=Plot.ThisSerie.XColumn; SX:=char(byte('A')+X-1)+' ['+
    (Plot.ThisSerie.Container.Owner as TDataForm).Labels[X]+']';
    Y:=Plot.ThisSerie.YColumn; SY:=char(byte('A')+Y-1)+' ['+
    (Plot.ThisSerie.Container.Owner as TDataForm).Labels[Y]+']';
    F:=Plot.ThisSerie.FirstLine; SF:=IntToStr(F)+' ';
    L:=Plot.ThisSerie.LastLine; SL:=IntToStr(L)+' ';
    C:=Plot.ThisSerie.Container; Win:=MainForm.GetContainerName(C,true);
  end else
  begin
    X:=XColumn; SX:=char(byte('A')+X-1)+' ['+Labels[X]+']';
    Y:=YColumn; SY:=char(byte('A')+Y-1)+' ['+Labels[Y]+']';
    F:=Worksheet.Selection.Top-Worksheet.FixedRows; SF:=IntToStr(F)+' ';
    L:=Worksheet.Selection.Bottom;
    if L=Worksheet.RowCount-1 then L:=Worksheet.RowCount-2;
    L:=L-Worksheet.FixedRows; SL:=IntToStr(L)+' ';
    C:=Container; Win:=MainForm.GetContainerName(C,true);
  end;
  if Notebook.PageIndex=0 then
  begin
    SrcXColStaticText.Caption:=SX; SrcXColStaticText.Tag:=X;
    SrcYColStaticText.Caption:=SY; SrcYColStaticText.Tag:=Y;
    SrcFirstLineStaticText.Caption:=SF; SrcFirstLineStaticText.Tag:=F;
    SrcLastLineStaticText.Caption:=SL; SrcLastLineStaticText.Tag:=L;
    SrcData:=C; SrcWindowStaticText.Caption:=Win;
  end else if Notebook.PageIndex=1 then
  begin
    DstXColStaticText.Caption:=SX; DstXColStaticText.Tag:=X;
    DstFirstLineStaticText.Caption:=SF; DstFirstLineStaticText.Tag:=F;
    DstLastLineStaticText.Caption:=SL; DstLastLineStaticText.Tag:=L;
    DstData:=C; DstWindowStaticText.Caption:=Win;
  end;
end;

procedure TFunctionCopyForm.FormDeactivate(Sender: TObject);
begin Tag:=ClientHeight; ClientHeight:=0; end;

procedure TFunctionCopyForm.NextBitBtnClick(Sender: TObject);
begin
  if Notebook.PageIndex=0 then                                   // src -> dst
  begin
    Notebook.PageIndex:=1; PrevBitBtn.Enabled:=true;
  end else if Notebook.PageIndex=1 then                         // dst -> func
  begin
    if (not Assigned(SrcData)) or (not Assigned(DstData)) or   // check ranges
       (SrcXColStaticText.Tag<1) or (SrcYColStaticText.Tag<1) or
       (SrcFirstLineStaticText.Tag<0) or (SrcLastLineStaticText.Tag<0) or
       (SrcLastLineStaticText.Tag-SrcFirstLineStaticText.Tag<
        MainForm.CopyFunctionAction.Tag) or
       (DstFirstLineStaticText.Tag<0) or (DstLastLineStaticText.Tag<0) or
       (DstLastLineStaticText.Tag-DstFirstLineStaticText.Tag<
        MainForm.CopyFunctionAction.Tag) or
       (DstXColStaticText.Tag<1) then
    begin             // note: if user closes windows, range become invalid!!!
      Application.NormalizeTopMosts;
      MessageDlg(strInvalidDataRange,mtError,[mbCancel],0);
      Application.RestoreTopMosts; Exit;
    end;
    Hide;
    FormStyle:=fsNormal;                // need to invoke any modal dialog box
    Notebook.PageIndex:=2;
    NextBitBtn.Visible:=false; PrevBitBtn.Visible:=false;
    FinishBitBtn.Visible:=true;
    FuncSrcLabel.Caption:=FuncSrcLabel.Caption+
    SrcWindowStaticText.Caption+#10+
    SrcXColLabel.Caption+SrcXColStaticText.Caption+#10+
    SrcYColLabel.Caption+SrcYColStaticText.Caption;
    FuncDstLabel.Caption:=FuncDstLabel.Caption+
    DstWindowStaticText.Caption+#10+
    DstXColLabel.Caption+DstXColStaticText.Caption;
    ShowModal;
  end;
end;

procedure TFunctionCopyForm.PrevBitBtnClick(Sender: TObject);
begin PrevBitBtn.Enabled:=false; Notebook.PageIndex:=0; end;

procedure TFunctionCopyForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin Action:=caFree; end;

procedure TFunctionCopyForm.CancelBitBtnClick(Sender: TObject);
begin Close; end;

procedure TFunctionCopyForm.FinishBitBtnClick(Sender: TObject);
var
  srcB,srcE,srcX,srcY,dstB,dstE,dstX,dstY,srcPos,dstPos,I: integer;
  D1,D2: TFunction; D3: TRealData; X1,X2,X3,Y1,Y2,Res: TReal; S: string;
begin
  MainForm.StatusImageList.Tag:=8; MainForm.DisplayHint(strWorking);
  Screen.Cursor:=crHourGlass;
  try
    // step 1 - initialize data range variables
    srcX:=SrcXColStaticText.Tag; srcY:=SrcYColStaticText.Tag;
    srcB:=SrcFirstLineStaticText.Tag; srcE:=SrcLastLineStaticText.Tag;
    dstX:=DstXColStaticText.Tag; dstY:=(DstData.Owner as TDataForm).YColumn;
    dstB:=DstFirstLineStaticText.Tag; dstE:=DstLastLineStaticText.Tag;
    // step 2 - prepare sorted array of source data in the Container
    for srcPos:=srcB to srcE do
    begin
      SrcData.ShowProgress(Round((srcPos-srcB)/(srcE-srcB)*100));
      D1:=Container.InitItem as TFunction;
      D3:=SrcData.Items[srcPos];
      D1.X:=D3.RData[srcX]; D1.Y:=D3.RData[srcY];
      Container.Items.Add(D1);
    end;
    // step 3 - sort Container
    Container.Sort(0,Container.Items.Count-1,false);
    // step 4 - save undo info and sort destination range
    (DstData.Owner as TDataForm).SaveUndoInfo(MainForm.CopyFunctionAction);
    MainForm.StatusImageList.Tag:=8; MainForm.DisplayHint(strWorking);
    DstData.Sort(dstB,dstE,false); // sort and automatically set Modified=true
    Screen.Cursor:=crHourGlass;    // update progress after SaveUndo  and Sort
    // step 5 - calculate function with interpolation as in old version
    dstPos:=dstB; srcB:=0; srcE:=Container.Items.Count; S:=FuncComboBox.Text;
    for srcPos:=srcB to srcE-2{!} do
    begin
      SrcData.ShowProgress(Round((srcPos-srcB)/(srcE-srcB)*100));
      D1:=Container.Items[srcPos];                 {fix source interval X1-X2}
      D2:=Container.Items[srcPos+1];
      X1:=D1.X; X2:=D2.X; Y1:=D1.Y; Y2:=D2.Y;
      repeat
        D3:=DstData.Items[dstPos]; X3:=D3.RData[dstX]; Inc(dstPos);
        if (X3>=X1) and (X3<=X2) then        {if destpos.x within interval...}
        begin
          with CalculatorForm do
          begin
            for I:=1 to MaxCols do Parameters[I]:=1.0;
            D3.GetRData(Parameters);
            X:=X3; Y:=LineInterpolate(X1,X2,Y1,Y2,X3);
            Res:=Parser.Parse(S);
          end;
          if MainForm.Insert then D3.InsItem(Res) else D3.RData[dstY]:=Res;
        end;
      until (X3>X2) or (dstPos>dstE);
      if X3>=X2 then Dec(dstPos);                            {correct destpos}
      if dstPos>dstE then Break;             {stop FOR cycle on dest.endline!}
    end;
    // step 6 - add expression to the history list
    with FuncComboBox do if (Text<>'') and (Items.IndexOf(Text)=-1)
    then Items.Insert(0, Text);
    CalculatorForm.ExpressionComboBox.Items.Assign(FuncComboBox.Items);
  finally
    MainForm.StatusImageList.Tag:=0; MainForm.DisplayHint('');
    Screen.Cursor:=crDefault; DstData.Modified:=true; // need update once more
  end;
end;

function TFunctionCopyForm.ContainerCompare(Sender: TObject; I1, // sort by X!
  I2: TData): TCompareResult;   
begin
  Result:=crEqual;
  if (I1 as TFunction).X>(I2 as TFunction).X then Result:=crGreater;
  if (I1 as TFunction).X<(I2 as TFunction).X then Result:=crLess;
end;

procedure TFunctionCopyForm.FuncSpeedButtonClick(Sender: TObject);
var S: string;
begin
  S:=FuncComboBox.Text;
  if InputText(S,FuncComboBox) then FuncComboBox.Text:=S;
end;

end.
