{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit MainWnd;
{$B-}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, AppEvnts, StdActns, CustomizeDlg, ActnList, ActnMan,
  ImgList, ActnMenus, ExtCtrls, Buttons, ActnCtrls, ToolWin, StdCtrls,
  Menus, MDIWallp, DdeMan, Common, Data, Parser, DataWnd, Automate, xmldom,
  XMLIntf, msxmldom, XMLDoc, Plot;

// To avoid ActionManager.LinkedActionList corruption when open this form in
// D6 IDE, you MUST open NotesForm, ScriptingForm, MonForm And BrowserForm

type
  TActiveCtrlType=(actBad, actWks, actPlot, actNotes, actScript, actBrowser,
  actSerieMgr);

  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    ProgressBar: TProgressBar;
    BottomSplitter: TSplitter;
    LeftSplitter: TSplitter;
    RightSplitter: TSplitter;
    BottomDockPanel: TPanel;
    CoolBar: TCoolBar;
    WindowActionToolBar: TActionToolBar;
    PlotActionToolBar: TActionToolBar;
    PicturePanel: TPanel;
    MenuPanel: TPanel;
    MinimizeSpeedButton: TSpeedButton;
    RestoreSpeedButton: TSpeedButton;
    CloseSpeedButton: TSpeedButton;
    MenuImage: TImage;
    ActionMainMenuBar: TActionMainMenuBar;
    LeftDockPanel: TPanel;
    RightDockPanel: TPanel;
    ImageList: TImageList;
    ActionManager: TActionManager;
    ApplicationAction: TAction;
    SpeedTestAction: TAction;
    CalculatorAction: TAction;
    DeletePointAction: TAction;
    DeleteAction: TAction;
    ScriptAction: TAction;
    NotesAction: TAction;
    BrowserAction: TAction;
    CalTableAction: TAction;
    WorksheetAction: TAction;
    PlotAction: TAction;
    CopyAction: TAction;
    PasteAction: TAction;
    InsertAction: TAction;
    CutAction: TAction;
    SelectAllAction: TAction;
    SortAction: TAction;
    SwapAction: TAction;
    MovePointAction: TAction;
    InplaceEditorAction: TAction;
    TranslationAction: TAction;
    UndoAction: TAction;
    BothAction: TAction;
    DifferentiationAction: TAction;
    IntegrationAction: TAction;
    SmoothAction: TAction;
    InterpolationAction: TAction;
    CalculationAction: TAction;
    CopyFunctionAction: TAction;
    TransformationAction: TAction;
    BaseLineAction: TAction;
    DigitizeAction: TAction;
    LinearFittingAction: TAction;
    LMFittingAction: TAction;
    LorentzFittingAction: TAction;
    PlotLinesAction: TAction;
    SelectLinesAction: TAction;
    ClearSerieAction: TAction;
    ScrollerAction: TAction;
    CascadeAction: TWindowCascade;
    TileHorizontalAction: TWindowTileHorizontal;
    TileVerticalAction: TWindowTileVertical;
    MinimizeAllAction: TWindowMinimizeAll;
    ArrangeAction: TWindowArrange;
    CloseAllAction: TAction;
    CloseAction: TWindowClose;
    PlotCalculatorAction: TAction;
    RulerAction: TAction;
    GotoLineAction: TAction;
    WorksheetCalculatorAction: TAction;
    PlotColorAction: TAction;
    AddSerieAction: TAction;
    PlotSelectAction: TAction;
    NewPlotAction: TAction;
    TopicSearchAction: THelpTopicSearch;
    HowToAction: TAction;
    WebHomepageAction: TAction;
    AboutAction: TAction;
    XAxisPropertiesAction: TAction;
    YAxisPropertiesAction: TAction;
    ScaleX1Action: TAction;
    ScaleX2Action: TAction;
    ScaleY1Action: TAction;
    ScaleY2Action: TAction;
    ZoomAction: TAction;
    UnZoomAction: TAction;
    UndoZoomAction: TAction;
    RescaleAction: TAction;
    RescaleXAction: TAction;
    RescaleYAction: TAction;
    ChangeTicksAction: TAction;
    AutoZoomAction: TAction;
    SeriePropertiesAction: TAction;
    WorksheetPropertiesAction: TAction;
    NewAction: TAction;
    OpenAction: TFileOpen;
    SaveAction: TAction;
    SaveAsAction: TFileSaveAs;
    MinimizeAction: TAction;
    RestoreAction: TAction;
    RenameAction: TAction;
    PrintSetupAction: TFilePrintSetup;
    PageSetupAction: TAction;
    PrintAction: TAction;
    FilePropertiesAction: TAction;
    ExitAction: TFileExit;
    ApplicationEvents: TApplicationEvents;
    SeriePanel: TPanel;
    SerieActionToolBar: TActionToolBar;
    SerieComboPanel: TPanel;
    Bevel: TBevel;
    SerieUpDown: TUpDown;
    SerieComboBox: TComboBox;
    SeparatorAction: TAction;
    Container: TContainer;
    Timer: TTimer;
    DdeServerConv: TDdeServerConv;
    MDIWallpaper: TMDIWallpaper;
    PicturePaintBox: TPaintBox;
    WorksheetPopupMenu: TPopupMenu;
    GotoItem: TMenuItem;
    NewPlotLinesItem: TMenuItem;
    CopyWorksheetItem: TMenuItem;
    PasteWorksheetItem: TMenuItem;
    CutWorksheetItem: TMenuItem;
    DeleteWorksheetItem: TMenuItem;
    N21: TMenuItem;
    WorksheetCalculatorItem: TMenuItem;
    InplaceEditorItem: TMenuItem;
    N16: TMenuItem;
    WorksheetPropertiesLocalItem: TMenuItem;
    PlotPopupMenu: TPopupMenu;
    RescaleXItem: TMenuItem;
    RescaleYItem: TMenuItem;
    N17: TMenuItem;
    PlotSelectItem: TMenuItem;
    CopyPlotItem: TMenuItem;
    PastePlotItem: TMenuItem;
    CutPlotItem: TMenuItem;
    DeletePlotItem: TMenuItem;
    N18: TMenuItem;
    PlotColorItem: TMenuItem;
    ChangeTicksItem: TMenuItem;
    AddSerieItem: TMenuItem;
    PlotCalculatorItem: TMenuItem;
    N19: TMenuItem;
    PlotPropertiesItem: TMenuItem;
    StatusImageList: TImageList;
    SaveDesktopAction: TFileSaveAs;
    ColorDialog: TColorDialog;
    MDIWindowPopupMenu: TPopupMenu;
    RestoreItem: TMenuItem;
    MoveItem: TMenuItem;
    SizeItem: TMenuItem;
    MinimizeItem: TMenuItem;
    MaximizeItem: TMenuItem;
    N1: TMenuItem;
    CloseItem: TMenuItem;
    N2: TMenuItem;
    NextItem: TMenuItem;
    NextAction: TAction;
    SelectWindowAction: TAction;
    MDIWindowAction0: TAction;
    MDIWindowAction1: TAction;
    MDIWindowAction7: TAction;
    MDIWindowAction2: TAction;
    MDIWindowAction3: TAction;
    MDIWindowAction4: TAction;
    MDIWindowAction5: TAction;
    MDIWindowAction6: TAction;
    ScaleActionToolBar: TActionToolBar;
    EditActionToolBar: TActionToolBar;
    ShowCoolbarAction: TAction;
    ShowStatusbarAction: TAction;
    ShowHintsAction: TAction;
    ShowWindowToolbarAction: TAction;
    ShowScaleToolbarAction: TAction;
    ShowPictureAction: TAction;
    ShowPlotToolbarAction: TAction;
    ShowSerieToolbarAction: TAction;
    ShowEditToolbarAction: TAction;
    ReopenAction1: TAction;
    ReopenAction2: TAction;
    ReopenAction3: TAction;
    ReopenAction0: TAction;
    ReopenAction4: TAction;
    ReopenAction5: TAction;
    ReopenAction6: TAction;
    ReopenAction7: TAction;
    MonitorAction: TAction;
    SelectSerieAction: TAction;
    DuplicateAction: TAction;
    SetupAction: TAction;
    CustomizeDlg: TCustomizeDlg;
    CustomizeActionBarsAction: TAction;
    SerieMgrAction: TAction;
    HelpContentsAction: TAction;
    CheckUpdatesAction: TAction;
    XMLDocument: TXMLDocument;
    procedure DockPanelDockDrop(Sender: TObject;
      Source: TDragDockObject; X, Y: Integer);
    procedure DockPanelDockOver(Sender: TObject;
      Source: TDragDockObject; X, Y: Integer; State: TDragState;
      var Accept: Boolean);
    procedure DockPanelUnDock(Sender: TObject; Client: TControl;
      NewTarget: TWinControl; var Allow: Boolean);
    procedure MinimizeActionExecute(Sender: TObject);
    procedure RestoreActionExecute(Sender: TObject);
    procedure MenuImageClick(Sender: TObject);
    procedure ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
    procedure ApplicationEventsHint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure ActionToolBarGetControlClass(
      Sender: TCustomActionBar; AnItem: TActionClient;
      var ControlClass: TCustomActionControlClass);
    procedure ActionExecuteStub(Sender: TObject);
    procedure ApplicationEventsException(Sender: TObject; E: Exception);
    procedure ApplicationEventsShowHint(var HintStr: String;
      var CanShow: Boolean; var HintInfo: THintInfo);
    procedure ContainerProgress(Sender: TObject; P: Integer);
    procedure TimerTimer(Sender: TObject);
    procedure DdeServerConvExecuteMacro(Sender: TObject;
      Msg: TStrings);
    procedure PicturePaintBoxPaint(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure SerieComboBoxChange(Sender: TObject);
    procedure SerieComboBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure SerieUpDownChangingEx(Sender: TObject;
      var AllowChange: Boolean; NewValue: Smallint;
      Direction: TUpDownDirection);
    procedure PlotPopupMenuPopup(Sender: TObject);
    procedure AboutActionExecute(Sender: TObject);
    procedure ApplicationActionExecute(Sender: TObject);
    procedure NotesActionExecute(Sender: TObject);
    procedure ScriptActionExecute(Sender: TObject);
    procedure BrowserActionExecute(Sender: TObject);
    procedure CalculatorActionExecute(Sender: TObject);
    procedure NotesActionUpdate(Sender: TObject);
    procedure ScriptActionUpdate(Sender: TObject);
    procedure BrowserActionUpdate(Sender: TObject);
    procedure CalculatorActionUpdate(Sender: TObject);
    procedure SpeedTestActionExecute(Sender: TObject);
    procedure WebHomepageActionExecute(Sender: TObject);
    procedure HowToActionExecute(Sender: TObject);
    procedure CalTableActionExecute(Sender: TObject);
    procedure NewActionExecute(Sender: TObject);
    procedure OpenActionAccept(Sender: TObject);
    procedure SaveActionExecute(Sender: TObject);
    procedure SaveAsActionAccept(Sender: TObject);
    procedure SaveDesktopActionAccept(Sender: TObject);
    procedure PrintActionExecute(Sender: TObject);
    procedure FilePropertiesActionExecute(Sender: TObject);
    procedure SaveActionUpdate(Sender: TObject);
    procedure PageSetupActionExecute(Sender: TObject);
    procedure SaveAsActionBeforeExecute(Sender: TObject);
    procedure OpenActionBeforeExecute(Sender: TObject);
    procedure PrintActionUpdate(Sender: TObject);
    procedure DataFormActionUpdate(Sender: TObject);
    procedure RenameActionExecute(Sender: TObject);
    procedure CloseAllActionExecute(Sender: TObject);
    procedure InsDelActionExecute(Sender: TObject);
    procedure WorksheetActionUpdate(Sender: TObject);
    procedure PlotToolActionExecute(Sender: TObject);
    procedure PlotToolActionUpdate(Sender: TObject);
    procedure DeleteActionExecute(Sender: TObject);
    procedure CopyDeleteCutActionUpdate(Sender: TObject);
    procedure PlotActionUpdate(Sender: TObject);
    procedure CopyActionExecute(Sender: TObject);
    procedure PasteActionUpdate(Sender: TObject);
    procedure CutActionExecute(Sender: TObject);
    procedure SelectAllActionExecute(Sender: TObject);
    procedure SelectAllActionUpdate(Sender: TObject);
    procedure SortActionExecute(Sender: TObject);
    procedure ProcessActionUpdate(Sender: TObject);
    procedure SwapActionExecute(Sender: TObject);
    procedure InplaceEditorActionExecute(Sender: TObject);
    procedure InplaceEditorActionUpdate(Sender: TObject);
    procedure UndoActionExecute(Sender: TObject);
    procedure UndoActionUpdate(Sender: TObject);
    procedure DifferentiationActionExecute(Sender: TObject);
    procedure IntegrationActionExecute(Sender: TObject);
    procedure SmoothActionExecute(Sender: TObject);
    procedure InterpolationActionExecute(Sender: TObject);
    procedure CalculationActionExecute(Sender: TObject);
    procedure CopyFunctionActionExecute(Sender: TObject);
    procedure TransformationActionExecute(Sender: TObject);
    procedure SerieActionUpdate(Sender: TObject);
    procedure BaseLineActionExecute(Sender: TObject);
    procedure DigitizeActionExecute(Sender: TObject);
    procedure LinearFittingActionExecute(Sender: TObject);
    procedure LMFittingActionExecute(Sender: TObject);
    procedure LorentzFittingActionExecute(Sender: TObject);
    procedure ViewStateActionExecute(Sender: TObject);
    procedure ViewStateActionUpdate(Sender: TObject);
    procedure PlotLinesActionExecute(Sender: TObject);
    procedure SelectLinesActionExecute(Sender: TObject);
    procedure ClearSerieActionExecute(Sender: TObject);
    procedure GotoLineActionExecute(Sender: TObject);
    procedure WorksheetCalculatorActionExecute(Sender: TObject);
    procedure WorksheetCalculatorActionUpdate(Sender: TObject);
    procedure PlotColorActionExecute(Sender: TObject);
    procedure AddSerieActionExecute(Sender: TObject);
    procedure NewPlotActionExecute(Sender: TObject);
    procedure NewPlotActionUpdate(Sender: TObject);
    procedure AxisPropertiesActionExecute(Sender: TObject);
    procedure SeriePropertiesActionExecute(Sender: TObject);
    procedure WorksheetPropertiesActionExecute(Sender: TObject);
    procedure ScaleXYActionExecute(Sender: TObject);
    procedure UndoZoomActionExecute(Sender: TObject);
    procedure UndoZoomActionUpdate(Sender: TObject);
    procedure RescaleActionExecute(Sender: TObject);
    procedure RescaleXActionExecute(Sender: TObject);
    procedure RescaleYActionExecute(Sender: TObject);
    procedure ChangeTicksActionExecute(Sender: TObject);
    procedure NextActionExecute(Sender: TObject);
    procedure SelectWindowActionExecute(Sender: TObject);
    procedure MDIWindowActionExecute(Sender: TObject);
    procedure MDIWindowActionUpdate(Sender: TObject);
    procedure ShowToolbarActionExecute(Sender: TObject);
    procedure ShowToolbarActionUpdate(Sender: TObject);
    procedure AppPropsActionExecute(Sender: TObject);
    procedure ReopenActionExecute(Sender: TObject);
    procedure MonitorActionExecute(Sender: TObject);
    procedure MonitorActionUpdate(Sender: TObject);
    procedure SelectSerieActionExecute(Sender: TObject);
    procedure ActionManagerExecute(Action: TBasicAction;
      var Handled: Boolean);
    procedure InsertActionUpdate(Sender: TObject);
    procedure PasteActionExecute(Sender: TObject);
    procedure DuplicateActionExecute(Sender: TObject);
    procedure BottomSplitterCanResize(Sender: TObject;
      var NewSize: Integer; var Accept: Boolean);
    procedure FormResize(Sender: TObject);
    procedure SetupActionExecute(Sender: TObject);
    procedure CustomizeActionBarsActionExecute(Sender: TObject);
    procedure MinimizeActionUpdate(Sender: TObject);
    procedure RestoreActionUpdate(Sender: TObject);
    procedure SerieMgrActionExecute(Sender: TObject);
    procedure SerieMgrActionUpdate(Sender: TObject);
    procedure AddSerieActionUpdate(Sender: TObject);
    procedure ClearSerieSelectLinesActionUpdate(Sender: TObject);
    procedure ApplicationEventsMinimize(Sender: TObject);
    procedure ApplicationEventsRestore(Sender: TObject);
    procedure HelpContentsActionExecute(Sender: TObject);
    function ApplicationEventsHelp(Command: Word; Data: Integer;
      var CallHelp: Boolean): Boolean;
    procedure DdeServerConvClose(Sender: TObject);
    procedure DdeServerConvOpen(Sender: TObject);
    procedure CheckUpdatesActionExecute(Sender: TObject);
    procedure ApplicationEventsMessage(var Msg: tagMSG;
      var Handled: Boolean);
  private
    { Private declarations }
    FInsert: boolean;              // flag used in Worksheet.CopyToClipboard()
    MessageTick: cardinal;      // used to monitor statusbar.simplePanel state
    PictureBitmap: TBitmap;       // keeps Picture (imagelist is bad for 8bpp)
    AutoSaveFN, ToolbarsFN: string;                      // service file names
    MenuBufControl: TWinControl;     // used to repair focus corrupted by menu
    procedure SetInsert(B: boolean);          // display changes in statusline
    function GetActiveDataForm: TDataForm;
    procedure UpdateAxisTitles;            // automatically create axes titles
    procedure wmDropFiles(var M: TWMDropFiles); message WM_DROPFILES;
    function FindReopenMenu: TActionClientItem;  // returns reopen menu or nil
    procedure OpenFile(FN: string);
    procedure DeletePoints;     // used in copy/delete and CUT action handlers
    procedure CopyPoints(AllData: boolean);
    procedure CopyWorksheet;
    procedure HelpCmd(Cmd: integer; Topic: PChar);    // 2 procs for HTML help
    procedure HelpCtx(Pnt: TPoint; Ctx: Integer);
    procedure SetMenuColor(C: TColor);// set color of all submenus of mainmenu
  public
    { Public declarations }
    ExpSettings: string;         // filled by DMApplication, used by CALLBACK!
    LoadingFile,StepProgress: boolean;       // used in Container.OnProgress()
    DMApplication: TDMExternalApp;      // reference to main automation object
    DocksLoaded: boolean; // set in ReadLayout to prevent dock size corruption
    procedure ShowDockPanel(Pan: TPanel; Show: Boolean);
    procedure InitParser(P: TMathParser);  // add Table() function to parser P
    procedure DisplayHint(S: string);             // shows hint in hints panel
    procedure DisplayMessage(S: string);          // show message in statusbar
    procedure UpdatePicture(Index: integer);       // update with image[index]
    procedure Evaluate(R: TRealArray; N: integer; X,Y: TReal);
    function GetContainerName(C: TContainer; Short: boolean): string;
    procedure UpdateSerieComboBox;              // correct SerieCombobox state
    procedure WorksheetComboBoxChange(Sender: TObject);      // updates labels
    property ActiveDataForm: TDataForm read GetActiveDataForm;
    property Insert: boolean read FInsert write SetInsert;
    function CreateDataForm: TDataForm;
    function LoadFile(FName: string): TDataForm;
    procedure ReadParamFiles;             // read files listed in command line
    procedure ReadRegistry;                    // read/write state to registry
    procedure ReadLayout;                                // read docks layouts
    procedure WriteRegistry;
    procedure ReadDesktop(FName: string; Template: boolean);
    procedure RecordPoint(N: integer; R: TRealArray; L: TStrings);
    procedure AddToReopen(FN: string);
    procedure UpdateMDIMenu;
    procedure UpdateWindowList;         // update window list in serie manager
    procedure UpdateSerieList;           // update serie list in serie manager
    function GetActiveCtrlType: TActiveCtrlType;    // used to monitor actions
    procedure HelpButtonClick(Sender: TObject);    // used to invoke html help
    procedure SetSkinColors;        // next 2 procs invoked from AppPropsForm!
    procedure SetSkinFonts;
    procedure SetToolBarBkg;         // set background bitmap for all toolbars
    procedure ApplySkin;          // read skin parameters from file (SkinEdit)
    procedure CheckPlotScale(P: TPlot; X, Y: TReal); // new point rescale plot         
  end;

var MainForm: TMainForm;

const
  DataMasterRegKey='Software\RRR\DM2000\Data Master';
  UseTaskBar: boolean=false;     // if true, special windows have taskbar icon

procedure CheckOldDesktop;      // runs DMW9 if parameter is dmw9 desktop file

{$I PropType.inc}
{because Metabase doesn't use library, common definitions placed in this file}
{$I DMRes.inc}

implementation

uses
  BrwsrWnd, NotesWnd, ScrptWnd, Strings, Registry, CalcDlg, ShellAPI,
  About, SerieDlg, AppDlg, TestDlg, LMOptDlg, PageDlg, Splash, Spin, Printers,
  StrDlg, BaseDlg, DigDlg, LFitDlg, LMFitDlg, AxisDlg, WorksDlg, SelDlg, Math,
  ClipBrd, Process, Grids, IntDlg, TransDlg, LMFit, CommCtrl, ShlObj, ComObj,
  MonWnd, WorkGrid, SHDocVw, MSHTML, ActiveX, SetupDlg, SerieWnd, HTMLHlp,
  FCopyDlg, INIFiles;

{$R *.dfm}
{$R DMRes.res}

//////////////// GLOBAL DEFINITIONS //////////////////////////////////////////

function xTable(var R1,R2: TReal): TReal;
begin with MainForm.Container do Result:=Calibrate(R1,round(R2),Tag); end;

function xTranslate(var R: TReal; var N: integer): TReal;
var ar: TRealArray absolute R; // x1,x2,y1,y2,x,y,a,b,v
begin
  if (ar[5]>=ar[1]) and (ar[5]<=ar[2]) and (ar[6]>=ar[3]) and (ar[6]<=ar[4])
  then Result:=ar[7]*ar[9]+ar[8] else Result:=ar[9];
end;

procedure CheckOldDesktop;
var
  Sign: array[0..SighLen] of char; CMD: array[0..MAX_PATH] of char;
  PI: TProcessInformation; SI: TStartupInfo;
begin
  if (ParamCount=1) and FileExists(ParamStr(1)) then
  begin
    CMD[0]:=#0;
    with TFileStream.Create(ParamStr(1), fmOpenRead) do
    try
      Read(Sign, SizeOf(Sign));
    finally
      Free;
    end;
    if Sign=DSK9Sign then with TRegistry.Create do
    try
      if OpenKeyReadOnly(DataMasterRegKey) and (ReadString('DMW9')<>'')
      then StrPCopy(CMD, ReadString('DMW9')+' "'+ParamStr(1)+'"');
    finally
      Free;
    end;
    if CMD[0]=#0 then Exit;       // command line not created - nothing to do!
    FillChar(SI,SizeOf(SI),0); SI.cb:=SizeOf(SI);  // halt if run successfully
    if CreateProcess(nil,CMD,nil,nil,false,0,nil,nil,SI,PI) then Halt(1);
  end;
end;

type TDMFileType=(dmftData,dmftDesktop,dmftScript,dmftNotes,dmftWebPage);

function GetDMFileType(FN: string):TDMFileType;
var EXT: string;
begin
  EXT:=UpperCase(ExtractFileExt(FN)); Result:=dmftData;
  if EXT='.DMW' then Result:=dmftDesktop;
  if (EXT='.JS') or (EXT='.VBS') then Result:=dmftScript;
  if (EXT='.TXT') then Result:=dmftNotes;
  if (EXT='.HTM') or (EXT='.HTML') then Result:=dmftWebPage;
end;

function GetReopenII(FN: string): integer;
begin
  case GetDMFileType(FN) of
    dmftData: Result:=5;
    dmftDesktop: Result:=26;
    dmftScript: Result:=29;
    dmftNotes: Result:=27;
    dmftWebPage: Result:=28;
  else Result:=-1;
  end;
end;

//////////////// FILE PROPERTY SHEET SUPPORT /////////////////////////////////

var
  psh: TPropSheetHeader;
  hPageA: array[1..MAXPROPPAGES] of HPropSheetPage;
  FileName: array[0..MAX_PATH] of char;
  ExpSettingsBuf: TFileDescription;

function AddPages(HP: HPropSheetPage; LP: LParam): BOOL; stdcall;
begin Inc(psh.nPages); hPageA[psh.nPages]:=HP; Result:=true; end;

function DataPropertySheetDlgProc(hDlg: HWND; uMessage: UINT;
  wParam: WPARAM; lParam: LPARAM): BOOL; stdcall;
var Buf: array[0..MAX_PATH] of char;
    LocalFileTime: TFileTime; WD: WIN32_FIND_DATAA; Handle,DT: cardinal;
begin
  Result:=true;
  case uMessage of
    WM_INITDIALOG:
    begin
      StrPCopy(Buf,ExtractFilePath(FileName));
      SetDlgItemText(hDlg,FolderNameText,Buf);
      Handle:=FindFirstFile(FileName,WD);
      if Handle<>INVALID_HANDLE_VALUE then
      begin
        SetDlgItemText(hDlg,FileNameText,WD.cFileName);
        SetDlgItemText(hDlg,DOSFileNameText,WD.cAlternateFileName);
        StrPCopy(Buf,Format('%f kB (%d bytes)',
          [WD.nFileSizeLow/1024, WD.nFileSizeLow]));           // size < 2^32!
        SetDlgItemText(hDlg,FileSizeText,Buf);
        if (WD.dwFileAttributes and faReadOnly)<>0 then
        SendDlgItemMessage(hDlg,ReadOnlyCheckBox,BM_SETCHECK,BST_CHECKED,0);
        if (WD.dwFileAttributes and faHidden)<>0 then
        SendDlgItemMessage(hDlg,HiddenCheckBox,BM_SETCHECK,BST_CHECKED,0);
        if (WD.dwFileAttributes and faArchive)<>0 then
        SendDlgItemMessage(hDlg,ArchiveCheckBox,BM_SETCHECK,BST_CHECKED,0);
        if (WD.dwFileAttributes and faSysFile)<>0 then
        SendDlgItemMessage(hDlg,SystemCheckBox,BM_SETCHECK,BST_CHECKED,0);
        if FileTimeToLocalFileTime(WD.ftCreationTime, LocalFileTime) and
        FileTimeToDosDateTime(LocalFileTime, LongRec(DT).Hi, LongRec(DT).Lo)
        then begin
          StrPCopy(Buf,DateToStr(FileDateToDateTime(DT))
          +' '+TimeToStr(FileDateToDateTime(DT)));
          SetDlgItemText(hDlg,CreatedText,Buf);
        end;
        if FileTimeToLocalFileTime(WD.ftLastAccessTime, LocalFileTime) and
        FileTimeToDosDateTime(LocalFileTime, LongRec(DT).Hi, LongRec(DT).Lo)
        then begin
          StrPCopy(Buf,DateToStr(FileDateToDateTime(DT)));
          SetDlgItemText(hDlg,OpenedText,Buf);
        end;
        if FileTimeToLocalFileTime(WD.ftLastWriteTime, LocalFileTime) and
        FileTimeToDosDateTime(LocalFileTime, LongRec(DT).Hi, LongRec(DT).Lo)
        then begin
          StrPCopy(Buf,DateToStr(FileDateToDateTime(DT))
          +' '+TimeToStr(FileDateToDateTime(DT)));
          SetDlgItemText(hDlg,ChangedText,Buf);
        end;
        Windows.FindClose(Handle);
      end;
    end;
    WM_HELP: if shortint(PHelpInfo(lParam)^.iCtrlId)<>-1 then
    begin
      StrPCopy(Buf,ExtractFilePath(Application.HelpFile)+'Metabase.hlp');
      WinHelp(hDlg,Buf,HELP_CONTEXTPOPUP,PHelpInfo(lParam)^.iCtrlId);
    end;
  else Result:=False;
  end;{case}
end;

procedure ExpSettingsCB(const DMFPS: IDMFilePropSheet); stdcall;
var Buf: array[0..8000] of char;
begin                    // read expsettings from buffer and write into dialog
  if MainForm.ExpSettings='' then      // empty buffer treated as NO settings!
  begin MessageDlg(strNoExpSettings,mtError,[mbCancel],0); Exit; end;
  StrPLCopy(Buf,MainForm.ExpSettings,SizeOf(Buf)-1);
  DMFPS.SetExpSettings(Buf);
end;

//////////////// TMainForm METHODS ///////////////////////////////////////////

procedure TMainForm.InitParser(P: TMathParser);
begin
  P.addobject(@xTable,'Table',tfp_2real);                 // table calibration
  P.addobject(@xTranslate,'Translate',tfp_nreal);   // used by TranslationForm
end;

procedure TMainForm.DisplayHint(S: string);
begin    // we use last panel for hints. Note: need to be updated immediately!
  StatusBar.Panels[StatusBar.Panels.Count-1].Text:=S;
  StatusBar.Refresh; StatusBar.Invalidate;   // only THIS sequence is correct!
end;

procedure TMainForm.DisplayMessage(S: string);
begin     // messages are more important then hints but less then dialog boxes
  StatusBar.SimpleText:=S; StatusBar.SimplePanel:=true;
  MessageTick:=GetTickCount; UpdatePicture(3); MessageBeep($ffffff);
end;

function TMainForm.GetActiveDataForm: TDataForm;  // slightly reduce code size
begin Result:=TDataForm(ActiveMDIChild); end;

procedure TMainForm.SetInsert(B: boolean);
begin
  if B<>FInsert then
  begin
    FInsert:=B;
    with StatusBar do if FInsert then Panels[Panels.Count-4].Text:='Ins'
    else Panels[Panels.Count-4].Text:='Owr';
  end;
end;

procedure TMainForm.UpdatePicture(Index: integer);
begin
  if PicturePaintBox.Tag<>Index                   // keep current index in Tag
  then begin PicturePaintBox.Tag:=Index; PicturePaintBoxPaint(nil); end;
end;     // note that Paint() instead of Refresh() remarkably reduces flickers

procedure TMainForm.Evaluate(R: TRealArray; N: integer; X,Y: TReal);
var I: integer;
begin                               // do not copy parameters from stringgrid!
  for I:=1 to N do CalculatorForm.Parameters[I]:=R[I];
  CalculatorForm.X:=X; CalculatorForm.Y:=Y;
  CalculatorForm.EvaluateBitBtnClick(nil);
  MessageBeep($FFFFFFFF); UpdatePicture(3);
  with CalculatorForm do DisplayHint(Format(strEvaluateResult,
  [ExpressionComboBox.Text,ResultEdit.Text]));
end;

function TMainForm.GetContainerName(C: TContainer; Short: boolean): string;
var P: integer;           // returns "user-friendly", descriptive name of data
begin
  Result:=''; if not Assigned(C) then Exit;
  P:=Pos('%',strNoname)-1; Result:=C.FileName;
  if Copy(Result,1,P)=Copy(strNoname,1,P) then
  begin        // use form caption instead of "NONAME" if NO PATH in filename!
    Result:=(C.Owner as TForm).Caption;
    if not Short then Result:=Result+' <'+C.FileName+'>';
  end else if Short then Result:=ExtractFilename(Result);
end;

procedure TMainForm.UpdateAxisTitles;                       // set axes titles
var W: TDataForm; I: integer; S: string;
begin
  with ActiveDataForm.Plot do if ThisSerie.Empty then
  begin XAxis.Title:=strEmpty; YAxis.Title:=strEmpty; Exit; end;
  W:=nil;
  for I:=0 to MDIChildCount-1 do if (MDIChildren[I] as TDataForm).Container=
  ActiveDataForm.Plot.ThisSerie.Container then
  begin W:=MDIChildren[I] as TDataForm; Break; end;
  if Assigned(W) then with ActiveDataForm.Plot.ThisSerie do
  begin
    if XExpression='' then S:=char(byte('A')+XColumn-1)+'['+
    W.Labels[XColumn]+']' else S:=XExpression;
    Delete(S, Pos('[]',S), 2); ActiveDataForm.Plot.XAxis.Title:=S;
    if YExpression='' then S:=char(byte('A')+YColumn-1)+'['+
    W.Labels[YColumn]+']' else S:=YExpression;
    Delete(S, Pos('[]',S), 2);
    with ActiveDataForm.Plot do YAxis.Title:=S+' - '+ThisSerie.Text;
  end;
end;

procedure TMainForm.UpdateSerieComboBox;
var I: integer;
begin
  with SerieComboBox do                               // setup series combobox
  if Assigned(ActiveDataForm) then
  begin
    Clear; Enabled:=true;
    with ActiveDataForm do for I:=0 to Plot.Series.Count-1 do
    Items.AddObject(Plot.Series[I].Text, Plot.Series[I]);
    ItemIndex:=ActiveDataForm.Plot.SerieIndex;
  end else begin Clear; Enabled:=false; ItemIndex:=-1; end;
  SerieUpDown.Invalidate;                           // <-problems with UpDown!
end;

procedure TMainForm.WMDropFiles(var M: TWMDropFiles);
var Filename: array[0..MAX_PATH] of Char; Count, I: Integer; P: TPoint;
  procedure ProcessControl;
  var C: TControl;
  begin
    C:=ControlAtPos(P,false,true);
    if Pos('Dock',C.Name)=0 then Exit;           // ignore all but Dock Panels
    P:=C.ParentToClient(P); C:=(C as TPanel).ControlAtPos(P,false,true);
    if C=BrowserForm then BrowserForm.WebBrowser.Navigate(Filename);
    if C=ScriptingForm then ScriptingForm.LoadFile(Filename); 
    if C=NotesForm then NotesForm.LoadFile(Filename);      // any extension!!!
  end;
begin           {this impementation taken from Lishcner's Secrets of Delphi2!}
  try
    Count:=DragQueryFile(M.Drop,Cardinal(-1),nil,0);     {Get number of files}
    for I:=0 to Count-1 do
    begin
      DragQueryFile(M.Drop,I,Filename,SizeOf(Filename));
      if DragQueryPoint(M.Drop,P) and Assigned(ControlAtPos(P,false,true))
      then ProcessControl // dropped in the client area m.b. above docked wnd?
      else OpenFile(Filename);    // unable to find target; default processing
    end;
  finally
    DragFinish(M.Drop);               {Important to tell Windows to clean up.}
  end;
end;

procedure TMainForm.WorksheetComboBoxChange(Sender: TObject);
var I: integer;
begin
  SeriePropsForm.WorksheetComboBoxChange(Sender);   // perform default actions
  with SeriePropsForm.WorksheetComboBox do if (ItemIndex>=0)
  and (Items.Objects[ItemIndex] is TContainer) then
  begin
    SeriePropsForm.XColumnComboBox.Items.Assign(((Items.Objects[ItemIndex] as
    TContainer).Owner as TDataForm).Worksheet.Header);
    with SeriePropsForm.XColumnComboBox do for I:=0 to Items.Count-1 do
    Items[I]:='['+char(byte('A')+I)+']: '+Items[I];
    SeriePropsForm.YColumnComboBox.Items.Assign(
      SeriePropsForm.XColumnComboBox.Items);
   end;
end;

function TMainForm.CreateDataForm: TDataForm;
var F: TDataForm; I: integer;
begin
  if AppPropsForm.TemplateCheckBox.Checked
     and (AppPropsForm.TemplateEdit.Text<>'') then
  begin      // NOTE!!! Template MUST contain one empty but configured window!
    ReadDesktop(AppPropsForm.TemplateEdit.Text,true); Result:=ActiveDataForm;
    case AppPropsForm.InitialViewRadioGroup.ItemIndex of
      0: Result.ViewState:=dfvBoth;
      1: Result.ViewState:=dfvWorksheet;
      2: Result.ViewState:=dfvPlot;
    end;
    Exit;  // that's ALL job!!! Note: no need InitParser (done in ReadDeskTop)
  end;
  F:=ActiveDataForm;                              // BEFORE creating new form!
  Result:=TDataForm.Create(Self);
  InitParser(Result.Plot.Parser);                      // add Table() function
  case AppPropsForm.InitialViewRadioGroup.ItemIndex of
    0: Result.ViewState:=dfvBoth;
    1: Result.ViewState:=dfvWorksheet;
    2: Result.ViewState:=dfvPlot;
  end;
  if AppPropsForm.CopyPropertiesCheckBox.Checked and Assigned(F) then
  begin                 // copy some properties from active window (if exists)
    Result.Worksheet.Color:=F.Worksheet.Color;
    Result.Worksheet.FixedColor:=F.Worksheet.FixedColor;
    Result.Worksheet.BlockColorB:=F.Worksheet.BlockColorB;
    Result.Worksheet.BlockColorF:=F.Worksheet.BlockColorF;
    Result.Worksheet.Header:=F.Worksheet.Header;
    Result.Worksheet.Font:=F.Worksheet.Font;
    Result.Worksheet.AlignRight:=F.Worksheet.AlignRight;
    Result.DataFormat:=F.DataFormat;
    Result.Plot.XAxis:=F.Plot.XAxis;
    Result.Plot.YAxis:=F.Plot.YAxis;
    Result.PlotPanel.Color:=F.PlotPanel.Color;
    for I:=0 to F.Plot.Series.Count-1 do if I<Result.Plot.Series.Count then
    begin                   {copy serie attributes EXCEPT block and container}
      Result.Plot.Series[I].Assign(F.Plot.Series[I]);
      with Result.Plot.Series[I] do begin ClearBlock; IsFunction:=false; end;
      Result.Plot.Series[I].Container:=Result.Container;
    end;
  end;
end;

procedure TMainForm.ReadParamFiles;       // read files listed in command line
var I: integer; S: string;
begin
  for I:=1 to ParamCount do
  begin
    S:=ParamStr(I); if (not (S[1] in ['-','/'])) and FileExists(S) then
    begin     // NOTE: test file existance to prevent error on initialization!
      SplashProgress(Format(strLoadingFile,[ExtractFileName(S)]));OpenFile(S);
    end;
  end;
end;

procedure TMainForm.ReadRegistry;
  procedure ReadForm(F: TForm; R: TRegistry);
  var I: integer;
  begin
    if R.OpenKeyReadOnly(DataMasterRegKey+'\'+F.ClassName) then
    for I:=0 to F.ComponentCount-1 do
    begin
    if F.Components[I] is TEdit then with (F.Components[I] as TEdit) do
       Text:=R.ReadString(Name);                                  // ALL edits
    if F.Components[I] is TComboBox then with (F.Components[I] as TComboBox)
        do Text:=R.ReadString(Name);                             // comboboxes
    if F.Components[I] is TSpinEdit then with(F.Components[I] as TSpinEdit) do
       Value:=R.ReadInteger(Name);                                // spinedits
    if F.Components[I] is TCheckBox then with(F.Components[I] as TCheckBox) do
       Checked:=R.ReadBool(Name);                                // checkboxes
    if F.Components[I] is TRadioGroup then                      // RadioGroups
      with (F.Components[I] as TRadioGroup) do ItemIndex:=R.ReadInteger(Name);
    end;
    R.CloseKey;
  end;
  procedure ReadFormSizePos(F: TForm; R: TRegistry; V: boolean);
  begin
    if R.OpenKeyReadOnly(DataMasterRegKey+'\'+F.ClassName) then
    begin
      F.Width:=R.ReadInteger('Width'); F.Height:=R.ReadInteger('Height');
      F.Top:=R.ReadInteger('Top'); F.Left:=R.ReadInteger('Left');
      if V then F.Visible:=R.ReadBool('Visible');
    end;
    R.CloseKey;
  end;
var R: TRegistry; I: integer; ReopenMenu: TActionClientItem;
const MaxHistLines=50;
  procedure LoadReopenActions;
  var N: integer; S: string; A: TAction;
  begin
    if not R.OpenKeyReadOnly(DataMasterRegKey+'\Reopen') then Exit;
    N:=0;
    repeat
      S:=R.ReadString(IntToStr(N));
      A:=TAction(FindComponent('ReopenAction'+IntToStr(N))); Inc(N);
      if Assigned(A) and (S<>'') then
      begin
        A.Caption:=ExtractFileName(S); A.Hint:=S;A.ImageIndex:=GetReopenII(S);
        with ReopenMenu.Items.Add do
        begin Action:=TContainedAction(A); UsageCount:=-1; end;
      end;
    until (S='') or (N>30) or (not Assigned(A));
    R.CloseKey;
  end;
begin
{ NOTE: we need to initialize toolbars before reading "Reopen" submenu
(and coolbar layout). But AFTER creating all forms...}
  if FileExists(ToolbarsFN) then ActionManager.LoadFromFile(ToolbarsFN);
  {since menu colors remembered in toolbars.bin, we have to correct menupanel}
  MenuPanel.Color:=ActionManager.ActionBars[0].Color;
  ReopenMenu:=FindReopenMenu;    // find menu and reset list loaded from *.bin
  if Assigned(ReopenMenu) then ReopenMenu.Items.Clear;
  R:=TRegistry.Create;
  try
    if R.OpenKey(DataMasterRegKey, false) then
    try
      Insert:=R.ReadBool('Insert');
      MDIWallPaper.Mode:=TWallpaperMode(R.ReadInteger('MDIWallPaperMode'));
      I:=R.ReadInteger('ToolbarBkgMode');
      case I of
        0: AppPropsForm.ToolbarBkgLeftRadioButton.Checked:=true;
        1: AppPropsForm.ToolbarBkgTileRadioButton.Checked:=true;
      else
        AppPropsForm.ToolbarBkgStretchRadioButton.Checked:=true;
      end;
      if R.OpenKeyReadOnly('History') then
      for I:=0 to MaxHistLines-1 do if R.ReadString(IntToStr(I))<>'' then
      CalculatorForm.ExpressionComboBox.Items.Add(R.ReadString(IntToStr(I)));
      R.CloseKey;
      LoadReopenActions;
      ReadFormSizePos(Self,R,false); ReadFormSizePos(BrowserForm,R,true);
      ReadFormSizePos(ScriptingForm,R,true);ReadFormSizePos(NotesForm,R,true);
      ReadFormSizePos(SerieMgrForm,R,true);
      if R.OpenKeyReadOnly(DataMasterRegKey+'\'+SerieMgrForm.ClassName) then
      begin
        with SerieMgrForm.WindowListItem do Checked:=R.ReadBool(Name);
        SerieMgrForm.WindowListItemClick(nil);
        with SerieMgrForm.PasteDataItem do Checked:=R.ReadBool(Name);
        with SerieMgrForm.WindowListView do Width:=R.ReadInteger(Name);
      end;
      R.CloseKey;
      case MDIWallPaper.Mode of
        wpTile: AppPropsForm.BkgTileRadioButton.Checked:=true;
        wpCenter: AppPropsForm.BkgCenterRadioButton.Checked:=true;
        wpStretch: AppPropsForm.BkgStretchRadioButton.Checked:=true;
      end;
      ReadForm(CalculatorForm,R);CalculatorForm.ExpressionComboBoxChange(nil);
      ReadForm(PageSetupForm, R); PageSetupForm.FormCreate(Self);
      ReadForm(AppPropsForm, R);
      if not AppPropsForm.BackgroundCheckBox.Checked  // update background pix
      then AppPropsForm.BackgroundCheckBoxClick(nil);
      ApplySkin; // read skin params (fonts+colors+bkg_pix); fname in skinedit
      ReadForm(NLSFOptionsForm, R);
    except
      on E: ERegistryException do DisplayMessage(E.Message);
    end;
    SetToolBarBkg;                 // update toolbars background pix (always!)
  finally
    R.Free;
  end;
end;

procedure TMainForm.WriteRegistry;
  procedure WriteForm(F: TForm; R: TRegistry);
  var I: integer;
  begin
    R.OpenKey(DataMasterRegKey+'\'+F.ClassName, true);
    for I:=0 to F.ComponentCount-1 do
    begin
    if F.Components[I] is TEdit then with (F.Components[I] as TEdit) do
       R.WriteString(Name,Text);                                  // ALL edits
    if F.Components[I] is TComboBox then with (F.Components[I] as TComboBox)
        do R.WriteString(Name,Text);                             // comboboxes
    if F.Components[I] is TSpinEdit then with(F.Components[I] as TSpinEdit) do
       R.WriteInteger(Name,Value);                                // spinedits
    if F.Components[I] is TCheckBox then with(F.Components[I] as TCheckBox) do
       R.WriteBool(Name,Checked);                                // checkboxes
    if F.Components[I] is TRadioGroup then                      // RadioGroups
      with (F.Components[I] as TRadioGroup) do R.WriteInteger(Name,ItemIndex);
    end;
    R.CloseKey;
  end;
  procedure WriteFormSizePos(F: TForm; R: TRegistry);
  begin
    R.OpenKey(DataMasterRegKey+'\'+F.ClassName, true);
    R.WriteInteger('Width',F.Width); R.WriteInteger('Height',F.Height);
    R.WriteInteger('Top',F.Top); R.WriteInteger('Left',F.Left);
    R.WriteBool('Visible',F.Visible);
    R.CloseKey;
  end;
var R: TRegistry; I: integer;
  procedure SaveReopenActions;
  var N: integer; A: TAction;
  begin
    R.OpenKey(DataMasterRegKey+'\Reopen',true); N:=0;
    repeat
      A:=TAction(FindComponent('ReopenAction'+IntToStr(N))); 
      if Assigned(A) and (A.Hint<>'') then R.WriteString(IntToStr(N),A.Hint);
      Inc(N);
    until (not Assigned(A)) or (A.Hint='') or (N>30);
    R.CloseKey;
  end;
begin
  R:=TRegistry.Create;
  try
    try
      R.OpenKey(DataMasterRegKey, true);
      R.WriteBool('Insert',Insert);
      R.WriteInteger('MDIWallPaperMode',integer(MDIWallPaper.Mode));
      if AppPropsForm.ToolbarBkgLeftRadioButton.Checked
      then R.WriteInteger('ToolbarBkgMode',0) else
      if AppPropsForm.ToolbarBkgTileRadioButton.Checked
      then R.WriteInteger('ToolbarBkgMode',1)
      else R.WriteInteger('ToolbarBkgMode',2);
      R.OpenKey('History',true);
      for I:=0 to CalculatorForm.ExpressionComboBox.Items.Count-1 do
      R.WriteString(IntToStr(I),CalculatorForm.ExpressionComboBox.Items[I]);
      R.CloseKey;
      SaveReopenActions;
      WriteFormSizePos(Self,R); WriteFormSizePos(BrowserForm,R);
      WriteFormSizePos(ScriptingForm,R); WriteFormSizePos(NotesForm,R);
      WriteFormSizePos(SerieMgrForm,R);
      R.OpenKey(DataMasterRegKey+'\'+SerieMgrForm.ClassName, true);
      with SerieMgrForm.WindowListItem do R.WriteBool(Name, Checked);
      with SerieMgrForm.PasteDataItem do R.WriteBool(Name, Checked);
      with SerieMgrForm.WindowListView do R.WriteInteger(Name, Width);
      R.CloseKey;
      WriteForm(CalculatorForm, R);
      WriteForm(PageSetupForm, R);
      WriteForm(AppPropsForm, R);
      WriteForm(NLSFOptionsForm, R);
    except
      on E: Exception do MessageDlg(E.Message, mtError, [mbCancel], 0);
    end;
  finally
    R.Free;
  end;
end;

function TMainForm.LoadFile(FName: string): TDataForm;
var F: TDataForm; I: integer; FD: TFileDescription;
PName: array[0..MAX_PATH] of char; Proc: TGetFileDescription; LibH: THandle;
begin
  Result:=nil;
  try
    F:=CreateDataForm; F.Container.FileName:=FName; Result:=F;
    try
      StatusImageList.Tag:=1; DisplayHint(Format(strLoadingFile,[FName]));
      LoadingFile:=true; F.Container.LoadFromFile;
    finally
      StatusImageList.Tag:=0; LoadingFile:=false; F.Worksheet.UpdateSize;
    end;
    if AppPropsForm.UseMetaBaseCheckBox.Checked then
    begin                           // try to read column labels from metabase
      with TRegistry.Create do                       // read provider filename
      try
        if OpenKey(MetaBaseRegKey, false) and (ReadString('Provider')<>'')
        then StrPCopy(PName, ReadString('Provider'))
        else raise Exception.Create(strNoProvider);
      finally
        Free;
      end;
      DisplayHint(strReadingMetabase); Screen.Cursor:=crHourGlass;
      LibH:=LoadLibrary(PName);
      if LibH<>0 then
      try
        Proc:=GetProcAddress(LibH, 'GetFileDescription');
        StrPCopy(FD.FileName, FName);
        if Assigned(Proc) then
          if Proc(FD) then          // nothing occurs if no description found!
          for I:=1 to MaxCol{NOT MaxCols!} do F.Labels[I]:=FD.Columns[I] else
        else raise Exception.Create(strInvalidProvider);     // GetProcAddress
      finally
        FreeLibrary(LibH);
      end else raise Exception.Create(strInvalidProvider);      // LoadLibrary
    end;
  except     // if not intercepted, DMW crashed when loadfile called from DDE!
    on E: Exception do DisplayMessage(E.Message);
  end;
  DisplayHint(''); Screen.Cursor:=crDefault;
end;

procedure TMainForm.ReadDesktop(FName: string; Template: boolean);
var           // may be called from wmDropFiles, CreateForm or ReadParamFiles!
  Stm: TFileStream; I,J,K,N,TL,Col: longint; Fm: TDataForm; Rd: TReader;
  TagBufLen: longint; TagBuf: PChar; VS: TDataFormView; B: boolean;
  Sign: array[0..SighLen] of char;
  SerieIDs: array[1..100] of record               // no more then 100 windows!
    SerIDs: array[0..100] of TDateTime;                     // AND 100 SERIES!
    Form: TDataForm;
  end;
  procedure ReadSize(Fm: TForm);
  var ws: TWindowState; I,J,K,L: smallint;
  begin
    Rd.Read(ws, Sizeof(ws));
    if ws=wsNormal then
    begin
      Rd.Read(I, Sizeof(I)); Rd.Read(J, Sizeof(I));
      Rd.Read(K, Sizeof(I)); Rd.Read(L, Sizeof(I));
    end;
    if Fm=nil then Exit;    // fm=nil when called from CreateForm() => ignore!
    Fm.WindowState:=ws; if ws<>wsNormal then Exit;   // <= Exit - important!!!
    FM.Left:=I; FM.Top:=J; FM.Width:=K; FM.Height:=L;
  end;
begin
  StatusImageList.Tag:=1; DisplayHint(strLoadingDesktop); StepProgress:=true;
  Stm:=TFileStream.Create(FName, fmOpenRead);
  try
    Rd:=TReader.Create(Stm,1024);
    try
      Rd.Read(Sign, SizeOf(Sign));
      if Sign<>DSK10Sign then
      begin MessageDlg(strDeskTopError, mtError, [mbCancel], 0); Exit; end;
      Rd.Read(TagBufLen, SizeOf(TagBufLen));               {tag buffer length}
      if TagBufLen>0 then
      begin
        GetMem(TagBuf, TagBufLen+1);                {allocate tag text buffer}
        try
          Rd.Read(TagBuf^, TagBufLen); TagBuf[TagBufLen]:=#0;
          if not Template then
          if NotesForm.Memo.Modified then
          begin
            if MessageDlg(Format(strCloseQuery,[NotesForm.FCaptionBuf]),
               mtConfirmation,[mbYes,mbNo],0)=mrYes
            then NotesForm.SaveToolButton.Click;
            NotesForm.Memo.Lines.SetText(TagBuf);
          end else NotesForm.Memo.Lines.SetText(TagBuf);
        finally
          FreeMem(TagBuf, TagBufLen+1);                          {free buffer}
        end;
      end;
      if Template then ReadSize(nil) else       // called from CreateForm()!!!
      begin ReadSize(Self); Refresh; end;
      Rd.Read(N, Sizeof(N)); Rd.Read(TL,SizeOf(TL));
      with ProgressBar do begin Position:=0; Max:=TL; end;
      for I:=1 to N do if I<=100 then                   // check window count!
      begin
        Fm:=TDataForm.CreateNew(Self);
        Rd.ReadRootComponent(Fm);
        InitParser(FM.Plot.Parser);                    // add Table() function
        if Template then ReadSize(nil) else ReadSize(Fm);
        Rd.Read(Col, SizeOf(Fm.XColumn)); Fm.XColumn:=Col;
        Rd.Read(Col, SizeOf(Fm.YColumn)); Fm.YColumn:=Col;
        Rd.Read(Fm.DataFormat, SizeOf(Fm.DataFormat));
        Rd.Read(Fm.FormID, SizeOf(Fm.FormID));
        if Template then Fm.FormID:=Now;  // else all forms will have same ID!
        Rd.Read(VS, SizeOf(VS)); FM.ViewState:=VS;
        FM.DMDocument:=TDMDocument.Create(FM);    // ALL from OnCreate() here!
        with SerieIDs[I] do
        begin                                   {read serie IDs for window[I]}
          Form:=Fm;
          for J:=0 to Fm.Plot.Series.Count-1 do if J<=100 then
          begin
            Rd.Read(SerIDs[J],SizeOf(TDateTime)); Rd.Read(B,SizeOf(B));
            FM.IsRecordingSerie[J]:=B;
          end;
        end;
      end;
      if Template then Exit;   // don't reload table if called from CreateForm
      for I:=1 to N do                       {cycle by ALL series in SerieIDs}
      for J:=0 to SerieIDs[I].Form.Plot.Series.Count-1 do
        for K:=1 to N do                                    {seek for form...}
        if SerieIDs[I].SerIDs[J]=SerieIDs[K].Form.FormID then         {found!}
        SerieIDs[I].Form.Plot.Series[J].Container:=SerieIDs[K].Form.Container;
      ArrangeIcons;                                 {correct iconized windows}
      DisplayHint(strLoadingTable);
      Rd.ReadRootComponent(Container);               // read calibration table
    finally
      Rd.Free; ProgressBar.Max:=100; StepProgress:=false;
    end;
  finally
    Stm.Free; StatusImageList.Tag:=0; DisplayHint('');
  end;
end;

procedure TMainForm.RecordPoint(N: integer; R: TRealArray; L: TStrings);
var                               // N-number of values in R; R-data; L-labels
  I,J: integer; W: TDataForm; D,D0: TRealData; Sel: TGridRect;
  X0,Y0,X,Y: extended; NotFirst: boolean;
begin
  if N=0 then Exit; W:=nil;            // no data from server - nothing to do!
  for I:=0 to MDIChildCount-1 do                  // seek for recording window
  if (MDIChildren[I] as TDataForm).Recording then
  begin W:=(MDIChildren[I] as TDataForm); Break; end;
  if W=nil then Exit;                        // no window to record data flow!
  D:=TRealData(W.Container.InitItem);
  D.SetRData(N,R); W.Container.Items.Add(D);     // add data item to container
  Sel:=W.Worksheet.Selection;           // include it into worksheet selection
  Sel.Bottom:=W.Container.Items.Count-1+W.Worksheet.FixedRows;
  Sel.Left:=W.Worksheet.FixedCols; Sel.Right:=W.Worksheet.ColCount-1;
  W.Worksheet.Selection:=Sel;
  W.Container.Modified:=true; // mark window as modified,update worksheet size
  if (W.ViewState<>dfvPlot) {2001and AppPropsForm.AutoScrollCheckBox.Checked}
  then W.Scroll(W.Container.Items.Count-1);             // show new data point
  if Assigned(L) {2001and AppPropsForm.CopyLabelsCheckBox.Checked}
  {$ifdef RecordColumnNumber}
  then W.Worksheet.Header:=L;   // copy column labels (and set header size!!!)
  {$else}
//then for I:=0 to L.Count-1 do if I<MaxCols then W.Worksheet.Header[I]:=L[I];
  then for I:=0 to N-1 do W.Worksheet.Header[I]:=L[I]; // avoid label multipl.
  {$endif}
/// Registration and worksheet update finished; start to plot point //////////
  for I:=0 to MDIChildCount-1 do                           {update ALL PLOTS!}
  with (MDIChildren[I] as TDataForm) do
  for J:=0 to Plot.Series.Count-1 do with Plot.Series[J] do
  if (Container=W.Container) and IsRecordingSerie[J]
     and (not Empty) and (XColumn<=N) and (YColumn<=N) then
  begin
    NotFirst:=Container.Items.Count>1;
    if NotFirst then   // additional processing need if previous points exists
    begin
      D0:=Container.Items[Container.Items.Count-2];      // get previous point
      if not Plot.GetDataPoint(D0,XColumn,YColumn,XExpression,YExpression,
      X0,Y0) then DrawLeader(X0,Y0) else NotFirst:=false;        {hide leader}
    end;
    Plot.Canvas.Pen:=Pen; Plot.Canvas.Brush:=Brush;        {set drawing tools}
    if not Plot.GetDataPoint(D,XColumn,YColumn,XExpression,YExpression,X,Y)
    then begin                      {try to convert current point; plot if OK}
      if LineVisible and NotFirst then            {draw line & previous point}
      begin
        Plot.DrawLine(X0,Y0,X,Y);                            {ONLY IF VISIBLE}
        if PointVisible then Plot.DrawPoint(X0,Y0,PointType,PointSize);
      end;
      if PointVisible then Plot.DrawPoint(X,Y,PointType,PointSize);  {current}
      DrawLeader(X,Y);                                           {move leader}
    end;
    Locked:=true; LastLine:=Container.Items.Count-1; Locked:=false;
    CheckPlotScale(Plot,X,Y);                 // expand plot scale if required
  end;
end;

procedure TMainForm.ReadLayout;
var
  BSize,I,W,Count: integer; V,B,F,cb: boolean; N: string[63];
  S: TMemoryStream; R: TRegistry; Buf: array[0..10000] of byte;
begin
  R:=TRegistry.Create; BSize:=0;
  try
    if R.OpenKey(DataMasterRegKey, false) and R.ValueExists('Layout') then
    BSize:=R.ReadBinaryData('Layout',Buf,SizeOf(Buf)-1);
    if BSize>0 then
    begin
      S:=TMemoryStream.Create;
      try
        S.Write(Buf,BSize); S.Position:=0;
        // read dockhosts layout
        LeftDockPanel.DockManager.LoadFromStream(S);
        S.ReadBuffer(I,SizeOf(I)); LeftDockPanel.Width:=I;
        RightDockPanel.DockManager.LoadFromStream(S);
        S.ReadBuffer(I,SizeOf(I)); RightDockPanel.Width:=I;
        BottomDockPanel.DockManager.LoadFromStream(S);
        S.ReadBuffer(I,SizeOf(I)); BottomDockPanel.Height:=I;
        // read CoolBar layout
        cb:=CoolBar.Visible; CoolBar.Hide;             // bufferize visibility
        CoolBar.Bands.BeginUpdate;
        S.ReadBuffer(Count,SizeOf(Count));
        CoolBar.Bands.Clear;
        for I:=0 to Count-1 do with CoolBar.Bands.Add do
        begin
          S.ReadBuffer(V,SizeOf(V));
          S.ReadBuffer(B,SizeOf(B));
          S.ReadBuffer(F,SizeOf(F));
          S.ReadBuffer(W,SizeOf(W));
          S.ReadBuffer(N,SizeOf(N));
          FixedSize:=F;
          Visible:=V;
          Break:=B;
          Control:=TWinControl(MainForm.FindComponent(N));
          Width:=W;
        end;
        CoolBar.Bands.EndUpdate;
        CoolBar.Visible:=cb;               // restore value read from registry
      finally
        S.Free;
      end;
    end;
  finally
    R.Free;
  end;
end;

function TMainForm.GetActiveCtrlType: TActiveCtrlType;
var C: TWinControl;
begin
  Result:=actBad; {C:=Screen.ActiveControl;        // WARNING! may be C=nil!!!
  because of TMenuActionBar BUG, we have to use buffer value. Else commands
  work incorrectly when called from menu. The reason is:
  1) User select Command from menu
  2) Focus leaves menu and (wrongly!) moves to memo
  3) ActionMgr calls Command.OnUpdate (now ActiveControl IS MEMO!!!)
  4) if OnUpdate returns false, that's finish! ERROR HERE!!!!!
  5) else ActionManagerExecute fired and focus returned to DataForm
  6) Command executes correctly on DataForm}
  C:=MenuBufControl;
(*  if (C is TWorksheet) {and C.Focused} then Result:=actWks;
  if (C<>nil) and (C.Name='PlotPanel') {and C.Focused} then Result:=actPlot;
  if (C is TMemo) and (C.Owner=NotesForm) and (not NotesForm.Floating)
     and C.Focused then Result:=actNotes;
  if (C is TMemo) and (C.Owner=ScriptingForm) and (not ScriptingForm.Floating)
     and C.Focused then Result:=actScript;
  if (C is TWebBrowser) and (not BrowserForm.Floating)
  then Result:=actBrowser;

  this version cause AV - MenuBufControl may
  point to destructed component!!! see more correct version below*)

  if Assigned(ActiveDataForm) then
  begin
    if C=ActiveDataForm.Worksheet then Result:=actWks;
    if C=ActiveDataForm.PlotPanel then Result:=actPlot;
  end;
  if (C=NotesForm.Memo) and (not NotesForm.Floating)
  then Result:=actNotes;
  if (C=ScriptingForm.Memo) and (not ScriptingForm.Floating)
  then Result:=actScript;
  if (C=BrowserForm.WebBrowser) and (not BrowserForm.Floating)
  then Result:=actBrowser;
  if (C=SerieMgrForm.SerieListView) and (not SerieMgrForm.Floating)
  then Result:=actSerieMgr;
end;

procedure TMainForm.UpdateWindowList;
var I: integer;
begin
  try
    SerieMgrForm.WindowListView.Items.BeginUpdate;
    SerieMgrForm.WindowListView.Clear;
    for I:=0 to MDIChildCount-1 do
    with SerieMgrForm.WindowListView.Items.Add do
    begin
      Caption:=MDIChildren[I].Caption; {ImageIndex:=12;} Data:=MDIChildren[I];
      SubItems.Add((MDIChildren[I] as TDataForm).Container.FileName);
    end;
  finally
    SerieMgrForm.WindowListView.Items.EndUpdate;
  end;
end;

procedure TMainForm.UpdateSerieList;
var I,Idx,Xo,Yo: integer; S: string; BMP: TBitmap; SE: TSerie;
begin
  with SerieMgrForm.SerieListView do
  begin
    Clear; SmallImages.Clear;
    if Assigned(ActiveDataForm) then
    begin
      BMP:=TBitmap.Create;                                // prepare imagelist
      try
        BMP.Height:=SmallImages.Height; BMP.Width:=SmallImages.Width;
        for I:=0 to ActiveDataForm.Plot.Series.Count-1 do
        begin
          SE:=ActiveDataForm.Plot.Series[I];
          if SE.Empty then if SE.IsFunction then Idx:=8 else Idx:=3
          else if ((SE.Collection as TSeries).Plot.Owner as
          TDataForm).IsRecordingSerie[I] then Idx:=4 else Idx:=2;
          BMP.Canvas.Brush.Color:=Color;
          BMP.Canvas.FillRect(Rect(0,0,BMP.Width,BMP.Height));
          StatusImageList.Draw(BMP.Canvas,0,0,Idx);
          BMP.Canvas.Pen.Assign(SE.Pen);
          BMP.Canvas.Brush.Assign(SE.Brush);
          Yo:=BMP.Height div 2;
          if SE.LineVisible then
          BMP.Canvas.PolyLine([Point(StatusImageList.Width,Yo),
          Point(BMP.Width,Yo)]);
          Xo:=StatusImageList.Width+(BMP.Width-StatusImageList.Width) div 2;
          if SE.PointVisible then (SE.Collection as TSeries).Plot.PaintPoint(
          Xo,Yo,SE.PointType,SE.PointSize,BMP.Canvas);
          SmallImages.Add(BMP,nil);
        end;
      finally
        BMP.Free;
      end;
      Items.BeginUpdate;                                // fill listview.items
      try
        with ActiveDataForm do for I:=0 to Plot.Series.Count-1 do
        with Items.Add do
        begin
          Data:=Plot.Series[I]; Caption:=Plot.Series[I].Text; ImageIndex:=I;
          SubItems.BeginUpdate;
          try
            with Plot.Series[I] do
            begin
              if Assigned(Container) then     // Serie.Container may be NIL!!!
              begin
                SubItems.Add((Container.Owner as TForm).Caption);
                if XColumn<=0 then S:=strEmpty
                else S:=char(XColumn+byte('A')-1)
                +' ['+(Container.Owner as TDataForm).Labels[XColumn]+']';
                SubItems.Add(S);
                if YColumn<=0 then S:=strEmpty
                else S:=char(YColumn+byte('A')-1)
                +' ['+(Container.Owner as TDataForm).Labels[YColumn]+']';
                SubItems.Add(S);
              end else
              begin
                SubItems.Add(strEmpty);
                if XColumn<=0 then SubItems.Add(strEmpty)
                else SubItems.Add(char(XColumn+byte('A')-1));
                if YColumn<=0 then SubItems.Add(strEmpty)
                else SubItems.Add(char(YColumn+byte('A')-1));
              end;
              SubItems.Add(Format('%d..%d',[Firstline,Lastline]));
              SubItems.Add(XExpression); SubItems.Add(YExpression);
            end;
          finally
            SubItems.EndUpdate;
          end;
        end;
      finally
        Items.EndUpdate;
      end;
    end; // if
  end; // with
end;

procedure TMainForm.HelpCmd(Cmd: integer; Topic: PChar);
var HFile: array[0..MAX_PATH] of char;
begin
  StrPLCopy(HFile,                       // note: FULL path to help file used!
    ExtractFilePath(Application.ExeName)+Application.HelpFile, MAX_PATH-1);
  if Assigned(Topic) then StrLCat(HFile,Topic,MAX_PATH-1);
  HtmlHelp(0,HFile,Cmd,0);
end;

procedure TMainForm.HelpCtx(Pnt: TPoint; Ctx: Integer);
var Popup: THHPopup; S: string; I: integer; Hi: array[0..1023] of char;
begin
  if not (biHelp in Screen.ActiveForm.BorderIcons) then Exit;
  S:='';
  for I:=0 to Screen.ActiveForm.ComponentCount-1 do
  if (Screen.ActiveForm.Components[I] is TControl)
     and ((Screen.ActiveForm.Components[I] as TControl).HelpContext=Ctx)
     and ((Screen.ActiveForm.Components[I] as TControl).Hint<>'') then
  begin S:=(Screen.ActiveForm.Components[I] as TControl).Hint; Break; end;
  if S='' then Exit;
  StrPLCopy(Hi,S,SizeOf(Hi)-1);
  FillChar(Popup, SizeOf(Popup), 0);
  Popup.cbStruct:=SizeOf(Popup);
  Popup.hinst:=0;
  Popup.idString:=0;
  Popup.pszText:=Hi;
  Popup.pt:=Pnt;
  Popup.clrForeGround:=TColorRef(-1);
  Popup.clrBackground:=TColorRef(-1);
  Popup.rcMargins:=Rect(-1, -1, -1, -1);
  Popup.pszFont:='';
  HtmlHelp(0, nil, HH_DISPLAY_TEXT_POPUP, DWORD(@Popup));
end;

procedure TMainForm.HelpButtonClick(Sender: TObject);
var Buf: array[0..MAX_PATH] of char;
begin               // this handler called by Help buttons of the dialog boxes
 StrPLCopy(Buf,'::/www/'+(Sender as TBitBtn).Owner.Name+'.htm',SizeOf(Buf)-1);
 HelpCmd(HH_DISPLAY_TOPIC,Buf);
end;

procedure TMainForm.SetMenuColor(C: TColor);
var I: integer;
  procedure doActionClientItem(CI: TActionClientItem);
  var I: integer;
  begin
    CI.Color:=C;
    for I:=0 to CI.Items.Count-1 do doActionClientItem(CI.Items[I]);
  end;
begin
  ActionManager.ActionBars[0].Color:=C;
  for I:=0 to ActionManager.ActionBars[0].Items.Count-1 do
  doActionClientItem(ActionManager.ActionBars[0].Items[I]);
end;

procedure TMainForm.SetSkinColors;
begin
  case AppPropsForm.SkinListBox.ItemIndex of
    0: begin
         MenuPanel.Color:=AppPropsForm.ColorDialog.Color;
         SetMenuColor(AppPropsForm.ColorDialog.Color);
       end;
    1: begin
         CoolBar.Color:=AppPropsForm.ColorDialog.Color;
         NotesForm.CoolBar.Color:=CoolBar.Color;
         ScriptingForm.CoolBar.Color:=CoolBar.Color;
         BrowserForm.CoolBar.Color:=CoolBar.Color;
         SerieMgrForm.CoolBar.Color:=CoolBar.Color;
         MonitorForm.CoolBar.Color:=CoolBar.Color;
       end;
    2: begin
         StatusBar.Color:=AppPropsForm.ColorDialog.Color;
         NotesForm.StatusBar.Color:=StatusBar.Color;
         ScriptingForm.StatusBar.Color:=StatusBar.Color;
         BrowserForm.StatusBar.Color:=StatusBar.Color;
       end;
    3: begin
         NotesForm.Memo.Color:=AppPropsForm.ColorDialog.Color;
         ScriptingForm.Memo.Color:=NotesForm.Memo.Color;      // only editors!
       end;
    4: begin
         Color:=AppPropsForm.ColorDialog.Color;
         InvalidateRect(MDIWallpaper.ClientHandle,nil,true);
       end;
  end;
end;

procedure TMainForm.SetSkinFonts;
begin
  if AppPropsForm.FontDialog.Execute then
  case AppPropsForm.SkinListBox.ItemIndex of
    0: ActionMainMenuBar.Font:=AppPropsForm.FontDialog.Font;
    1: begin
         CoolBar.Font:=AppPropsForm.FontDialog.Font;
         NotesForm.CoolBar.Font:=CoolBar.Font;
         ScriptingForm.CoolBar.Font:=CoolBar.Font;
         BrowserForm.CoolBar.Font:=CoolBar.Font;
         SerieMgrForm.CoolBar.Font:=CoolBar.Font;
         MonitorForm.CoolBar.Font:=CoolBar.Font;
       end;
    2: begin
         StatusBar.Font:=AppPropsForm.FontDialog.Font;
         NotesForm.StatusBar.Font:=StatusBar.Font;
         ScriptingForm.StatusBar.Font:=StatusBar.Font;
         BrowserForm.StatusBar.Font:=StatusBar.Font;
       end;
    3: begin
         NotesForm.Memo.Font:=AppPropsForm.FontDialog.Font;
         ScriptingForm.Memo.Font:=NotesForm.Memo.Font;
       end;
  end;
end;

procedure TMainForm.SetToolBarBkg;
var I: integer; 
begin
  if AppPropsForm.ToolbarBkgCheckBox.Checked then
  begin
    if AppPropsForm.ToolbarBkgEdit.Text<>'' then         // load toolbar image
    try
      CoolBar.Bitmap.LoadFromFile(AppPropsForm.ToolbarBkgEdit.Text);
    except
      on E: Exception do DisplayMessage(E.Message);
    end;
    ActionManager.State:=asSuspendedEnabled;
    for I:=1 to 5 do with ActionManager.ActionBars[I] do
    begin
      Background.Assign(Coolbar.Bitmap);
      if AppPropsForm.ToolbarBkgLeftRadioButton.Checked
      then BackgroundLayout:=blNormal else
      if AppPropsForm.ToolbarBkgTileRadioButton.Checked
      then BackgroundLayout:=blTile else BackgroundLayout:=blStretch;
      ActionBar.DesignMode:=true; ActionBar.DesignMode:=false;// correct v-btn
    end;
    ActionManager.State:=asNormal;
    NotesForm.CoolBar.Bitmap.Assign(Coolbar.Bitmap);
    ScriptingForm.CoolBar.Bitmap.Assign(Coolbar.Bitmap);
    BrowserForm.CoolBar.Bitmap.Assign(Coolbar.Bitmap);
    SerieMgrForm.CoolBar.Bitmap.Assign(Coolbar.Bitmap);
    MonitorForm.CoolBar.Bitmap.Assign(Coolbar.Bitmap);
  end else
  begin
    Coolbar.Bitmap:=nil;
    for I:=1 to 5 do with ActionManager.ActionBars[I] do
    begin Background.Graphic:=nil; BackgroundLayout:=blNormal; end;
  end;
end;

procedure TMainForm.ApplySkin;          // called from AppDlg and ReadRegistry
var INI: TINIFile; C: TColor; S: string;
  procedure doFontColor(Sect: shortstring; F: TFont; var C: TColor);
  begin
    C:=INI.ReadInteger(Sect, 'BkgColor', C);
    F.Color:=INI.ReadInteger(Sect, 'FntColor', F.Color);
    F.Name:=INI.ReadString(Sect, 'FntName', F.Name);
    F.Size:=INI.ReadInteger(Sect, 'FntSize', F.Size);
    if INI.ReadBool(Sect, 'FntBold', fsBold in F.Style) then
    F.Style:=F.Style+[fsBold] else F.Style:=F.Style-[fsBold];
    if INI.ReadBool(Sect, 'FntItalic', fsItalic in F.Style) then
    F.Style:=F.Style+[fsItalic] else F.Style:=F.Style-[fsItalic];
  end;
begin
  if not FileExists(AppPropsForm.SkinEdit.Text) then Exit;
  INI:=TINIFile.Create(AppPropsForm.SkinEdit.Text);
  try
    // menu
    C:=MenuPanel.Color;
    doFontColor('Menu',ActionMainMenuBar.Font,C);
    MenuPanel.Color:=C; SetMenuColor(C);
    // toolbars
    C:=CoolBar.Color;
    doFontColor('ToolBar',CoolBar.Font,C);         // notice: read many times!
    doFontColor('ToolBar',NotesForm.CoolBar.Font,C);
    doFontColor('ToolBar',ScriptingForm.CoolBar.Font,C);
    doFontColor('ToolBar',BrowserForm.CoolBar.Font,C);
    doFontColor('ToolBar',SerieMgrForm.CoolBar.Font,C);
    doFontColor('ToolBar',MonitorForm.CoolBar.Font,C);
    CoolBar.Color:=C;
    NotesForm.CoolBar.Color:=C;
    ScriptingForm.CoolBar.Color:=C;
    BrowserForm.CoolBar.Color:=C;
    SerieMgrForm.CoolBar.Color:=C;
    MonitorForm.CoolBar.Color:=C;
    S:=INI.ReadString('ToolBar','BkgFile','');
    if (S<>'') and (ExtractFilePath(S)='')    // correct file path if relative
    then S:=ExtractFilePath(AppPropsForm.SkinEdit.Text)+S;
    if S<>'' then AppPropsForm.ToolbarBkgEdit.Text:=S;
    case INI.ReadInteger('ToolBar', 'BkgMode', -1) of  // -1 means no change!!
      0: AppPropsForm.ToolbarBkgLeftRadioButton.Checked:=true;
      1: AppPropsForm.ToolbarBkgTileRadioButton.Checked:=true;
      2: AppPropsForm.ToolbarBkgStretchRadioButton.Checked:=true;
    end;
    with AppPropsForm.ToolbarBkgCheckBox do Checked:=INI.ReadBool('ToolBar',
    'UseBkg',Checked);
    SetToolBarBkg;   // apply toolbar background image settings from skin file
    // statusbars
    C:=StatusBar.Color;
    doFontColor('StatusBar',StatusBar.Font,C);
    doFontColor('StatusBar',NotesForm.StatusBar.Font,C);
    doFontColor('StatusBar',ScriptingForm.StatusBar.Font,C);
    doFontColor('StatusBar',BrowserForm.StatusBar.Font,C);
    StatusBar.Color:=C;
    NotesForm.StatusBar.Color:=C;
    ScriptingForm.StatusBar.Color:=C;
    BrowserForm.StatusBar.Color:=C;
    // popups
    C:=NotesForm.Memo.Color;
    doFontColor('Popup',NotesForm.Memo.Font,C);
    doFontColor('Popup',ScriptingForm.Memo.Font,C);
    NotesForm.Memo.Color:=C;
    ScriptingForm.Memo.Color:=C;
    // main window
    Color:=INI.ReadInteger('Main','BkgColor',Color); // don't use doFontColor!
    MDIWallPaper.Mode:=TWallpaperMode(INI.ReadInteger('Main','BkgMode',
    integer(MainForm.MDIWallPaper.Mode)));
    case MDIWallPaper.Mode of
      wpTile: AppPropsForm.BkgTileRadioButton.Checked:=true;
      wpCenter: AppPropsForm.BkgCenterRadioButton.Checked:=true;
      wpStretch: AppPropsForm.BkgStretchRadioButton.Checked:=true;
    end;
    S:=INI.ReadString('Main','BkgFile','');
    if (S<>'') and (ExtractFilePath(S)='')    // correct file path if relative
    then S:=ExtractFilePath(AppPropsForm.SkinEdit.Text)+S;
    if S<>'' then AppPropsForm.BackgroundEdit.Text:=S;
    with AppPropsForm.BackgroundCheckBox do
    Checked:=INI.ReadBool('Main','UseBkg',Checked);
    if not AppPropsForm.BackgroundCheckBox.Checked
    then AppPropsForm.BackgroundCheckBoxClick(nil);
  finally
    INI.Free;
  end;
end;

procedure TMainForm.CheckPlotScale(P: TPlot; X, Y: TReal);
var d: TReal;
begin
  if not AppPropsForm.AutoScaleCheckBox.Checked then Exit;
  // X
  P.XAxis.AutoScale:=false;
  d:=P.XAxis.Max-P.XAxis.Min;
  if P.XAxis.Margins>0 then d:=d*P.XAxis.Margins else d:=d/P.XAxis.MajorTicks;
  if X<P.XAxis.Min then P.XAxis.Min:=X-d;
  if X>P.XAxis.Max then P.XAxis.Max:=X+d;
  // Y
  P.YAxis.AutoScale:=false;
  d:=P.YAxis.Max-P.YAxis.Min;
  if P.YAxis.Margins>0 then d:=d*P.YAxis.Margins else d:=d/P.YAxis.MajorTicks;
  if Y<P.YAxis.Min then P.YAxis.Min:=Y-d;
  if Y>P.YAxis.Max then P.YAxis.Max:=Y+d;
end;

//////////////// DOCKING SPECIAL WINDOWS SUPPORT /////////////////////////////

procedure TMainForm.ShowDockPanel(Pan: TPanel; Show: Boolean);
begin
  if not Show and (Pan.VisibleDockClientCount>1) then Exit;           // check
  // show/hide splitters
  if Pan=LeftDockPanel then LeftSplitter.Visible:=Show else
  if Pan=RightDockPanel then RightSplitter.Visible:=Show else
     BottomSplitter.Visible:=Show;
  if Show then                           // setup panels and arrange splitters
  begin
     if Pan=BottomDockPanel then Pan.Height:=ClientHeight div 3
     else Pan.Width:=ClientWidth div 3;
     if Pan=LeftDockPanel
     then LeftSplitter.Left:=Pan.Width+LeftSplitter.Width;
     if Pan=RightDockPanel
     then RightSplitter.Left:=ClientWidth-Pan.Width-RightSplitter.Width;
     if Pan=BottomDockPanel then
     begin Pan.Top:=5; BottomSplitter.Top:=0; end;
  end else if Pan=BottomDockPanel then Pan.Height:=0 else Pan.Width:=0;
end;

//////////////// Panel Handlers //////////////////////////////////////////////

procedure TMainForm.DockPanelDockOver(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer; State: TDragState;
  var Accept: Boolean);
var R: TRect;
begin
  Accept:=Source.Control is TForm;
  with (Sender as TPanel) do if Accept and (VisibleDockClientCount=0) then
  begin      // Modify the DockRect to preview dock area only for empty panel!
    if Sender=BottomDockPanel then
    begin
      R.TopLeft:=ClientToScreen(Point(0, -Self.ClientHeight div 3));
      R.BottomRight:=ClientToScreen(Point(Width, Height));
    end else
    if Sender=LeftDockPanel then
    begin
      R.TopLeft:=ClientToScreen(Point(0, 0));
      R.BottomRight:=ClientToScreen(Point(Self.ClientWidth div 3, Height));
    end;
    if Sender=RightDockPanel then
    begin
      R.TopLeft:=ClientToScreen(Point(-Self.ClientWidth div 3, 0));
      R.BottomRight:=ClientToScreen(Point(0, Height));
    end;
    Source.DockRect:=R;
  end;
end;

procedure TMainForm.DockPanelDockDrop(Sender: TObject;
  Source: TDragDockObject; X, Y: Integer);
begin
  if (Sender as TPanel).VisibleDockClientCount=1
  then ShowDockPanel(Sender as TPanel, true);
{ (Sender as TPanel).DockManager.ResetBounds(True);    // as in demo
  ^ corrupts dock client sizes and order!!!}
  // hide bars if any
  if Assigned(Source.Control.FindComponent('CoolBar'))
  then (Source.Control.FindComponent('CoolBar') as TCoolBar).Hide;
  if Assigned(Source.Control.FindComponent('StatusBar'))
  then (Source.Control.FindComponent('StatusBar') as TStatusBar).Hide;
end;

procedure TMainForm.DockPanelUnDock(Sender: TObject;
  Client: TControl; NewTarget: TWinControl; var Allow: Boolean);
begin
  if (Sender as TPanel).VisibleDockClientCount=1
  then ShowDockPanel(Sender as TPanel, false);
  // show bars if any
  if Assigned(Client.FindComponent('CoolBar'))
  then (Client.FindComponent('CoolBar') as TCoolBar).Show;
  if Assigned(Client.FindComponent('StatusBar'))
  then (Client.FindComponent('StatusBar') as TStatusBar).Show;
end;

{ Bugfix with bottom splitter (not fixed; really also need to
process mainform.OnResize! - and correct bottom dock height) }

procedure TMainForm.BottomSplitterCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin Accept:=NewSize<ClientHeight div 3; end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  if BottomDockPanel.Height>(ClientHeight-70) div 3
  then BottomDockPanel.Height:=(ClientHeight-70) div 3;
end;

//////////////// OFFICE-STYLE MDI CHILDREN ///////////////////////////////////

procedure TMainForm.MinimizeActionExecute(Sender: TObject);
begin
  // ActiveMDIChild.WindowState:=wsMinimized; BAD - NO SOUND!
  SendMessage(ActiveMDIChild.Handle,WM_SYSCOMMAND,SC_MINIMIZE,0);
end;

procedure TMainForm.MinimizeActionUpdate(Sender: TObject);
begin 
  MinimizeAction.Enabled:=Assigned(ActiveMDIChild)
  and (ActiveMDIChild.WindowState<>wsMinimized);
end;

procedure TMainForm.RestoreActionExecute(Sender: TObject);
begin
  SendMessage(ActiveMDIChild.Handle,WM_SYSCOMMAND,SC_RESTORE,0);
end;

procedure TMainForm.RestoreActionUpdate(Sender: TObject);
begin
  RestoreAction.Enabled:=Assigned(ActiveMDIChild)
  and (ActiveMDIChild.WindowState<>wsNormal);
end;

procedure TMainForm.NextActionExecute(Sender: TObject);
begin
  SendMessage(ActiveMDIChild.Handle,WM_SYSCOMMAND,SC_NEXTWINDOW,0);
end;

procedure TMainForm.SelectWindowActionExecute(Sender: TObject);
var I: integer;
begin                                   // code from CopyFunctionActionExecute
  InputStringForm:=TInputStringForm.Create(Application);
  try
    InputStringForm.Label1.Caption:=strSelectWindow;
    InputStringForm.ComboBox.Style:=csDropDownList;
    for I:=0 to MDIChildCount-1 do
      InputStringForm.ComboBox.Items.Add(GetContainerName((MDIChildren[I] as
        TDataForm).Container, false));
    if (InputStringForm.ShowModal<>mrOk) or                       // cancelled
       (InputStringForm.ComboBox.ItemIndex<0) then Exit;    // or not selected
    MDIChildren[InputStringForm.ComboBox.ItemIndex].Show;
  finally
    InputStringForm.Free;
  end;
end;

procedure TMainForm.MenuImageClick(Sender: TObject);
var P: TPoint;
begin
  P:=MenuPanel.ClientToScreen(Point(0,0)); MDIWindowPopupMenu.Popup(P.X,P.Y);
end;

procedure TMainForm.MDIWindowActionExecute(Sender: TObject);
begin
  if ((Sender as TAction).Tag<>0) then TForm((Sender as TAction).Tag).Show;
end;

procedure TMainForm.MDIWindowActionUpdate(Sender: TObject);
begin with (Sender as TAction) do Checked:=Tag=integer(ActiveMDIChild); end;

procedure TMainForm.UpdateMDIMenu;
var
  I,NC,NA: integer; WindowsMenu: TActionClientItem; A: TAction;
  F: TDataForm;
begin
  WindowsMenu:=nil;                                      // seek "Window" menu
  with ActionManager.ActionBars[0] do for I:=0 to Items.Count-1 do
  if Items[I].Caption='&Window' then WindowsMenu:=Items[I];
  // WindowsMenu:=ActionManager.ActionBars[0].Items[5]; hardcoded is not good!
  if not Assigned(WindowsMenu) then Exit;                    // menu removed?!
  I:=0;
  repeat                                             // delete MDI child items
    A:=WindowsMenu.Items[I].Action as TAction;
    if (Assigned(A) and
       ((A=SelectWindowAction) or (Copy(A.Name,0,15)='MDIWindowAction')))
       or not Assigned(A)
    then WindowsMenu.Items.Delete(I) else Inc(I);
  until I=WindowsMenu.Items.Count;
  NC:=MDIChildCount;
  if NC>0 then WindowsMenu.Items.Add.Caption:='-';            // add separator
  NA:=0;          // calculate number of WindowActions (must be named 0,1,...)
  while Assigned(FindComponent('MDIWindowAction'+IntToStr(NA))) do Inc(NA);
  for I:=0 to Min(NA,NC)-1 do                                   // add windows
  begin
    A:=FindComponent('MDIWindowAction'+IntToStr(I)) as TAction;
    F:=MDIChildren[I] as TDataForm;
    A.Caption:=F.Caption; A.Hint:=F.Container.FileName; A.Tag:=integer(F);
    WindowsMenu.Items.Add.Action:=A;
  end;
  if NC>NA then WindowsMenu.Items.Add.Action:=SelectWindowAction;  // add list
end;

function TMainForm.FindReopenMenu: TActionClientItem;
var N: integer; FileMenu: TActionClientItem;
begin
  FileMenu:=nil; Result:=nil;       // seek Reopen submenu (it may be moved?!)
  with ActionManager.ActionBars[0] do for n:=0 to Items.Count-1 do
  if Items[N].Caption='&File' then FileMenu:=Items[N];      //seek "File" menu
  if not Assigned(FileMenu) then Exit;                       // menu removed?!
  with FileMenu do for N:=0 to Items.Count-1 do       // seek "Reopen" submenu
  if Items[N].Caption='&Reopen' then Result:=Items[N];
end;

procedure TMainForm.AddToReopen(FN: string);
const CurrentItem: integer=0;
var ReopenMenu, Item: TActionClientItem; N,NA: integer; A: TAction;
begin
  NA:=0;          // calculate number of ReopenActions (must be named 0,1,...)
  while Assigned(FindComponent('ReopenAction'+IntToStr(NA))) do Inc(NA); // =4
  for N:=0 to NA-1 do                                 // test for duplications
  if TAction(FindComponent('ReopenAction'+IntToStr(N))).Hint=FN then Exit;
  ReopenMenu:=FindReopenMenu; if not Assigned(ReopenMenu) then Exit;
  N:=ReopenMenu.Items.Count;                                           // 0..3
  if N<NA then
  begin                                            // add new item and fill it
    A:=TAction(FindComponent('ReopenAction'+IntToStr(N)));
    A.Caption:=ExtractFileName(FN); A.Hint:=FN; A.ImageIndex:=GetReopenII(FN);
    with ReopenMenu.Items.Add do
    begin Action:=TContainedAction(A); UsageCount:=-1; end;
  end else
  begin                        // use added item and move current item pointer
    A:=TAction(FindComponent('ReopenAction'+IntToStr(CurrentItem)));
    Item:=ReopenMenu.Items[CurrentItem];
    Inc(CurrentItem); if CurrentItem>=NA then CurrentItem:=0;
    A.Caption:=ExtractFileName(FN); A.Hint:=FN; A.ImageIndex:=GetReopenII(FN);
    with Item do begin Action:=nil; Action:=A; end; // force update imageindex
  end;
end;

procedure TMainForm.OpenFile(FN: string);
begin
  case GetDMFileType(FN) of
    dmftDesktop: ReadDesktop(FN,false);
    dmftWebPage: BrowserForm.WebBrowser.Navigate(FN);
    dmftScript:  ScriptingForm.LoadFile(FN);
    dmftData:    LoadFile(FN);
    dmftNotes:   NotesForm.LoadFile(FN);
  end;
end;

//////////////// APPLICATION EVENTS HANDLERS /////////////////////////////////

procedure TMainForm.ApplicationEventsIdle(Sender: TObject; var Done: Boolean);
var S: string; B: boolean; I: integer;
const F: TForm=nil; ChildCount: integer=-1; ACT: TActiveCtrlType=actBad;
  procedure SetFrame(Frm: TForm; Focused: boolean);
    procedure doFrm(C: TColor);
    begin
      if Frm.Color<>C then
      begin Frm.Color:=C; Frm.BorderWidth:=0; Frm.BorderWidth:=1; end;
    end;
  begin
    if not Frm.Floating then
      if Focused then doFrm(clBlack) else doFrm(clBtnFace)
    else begin Frm.Color:=clBtnFace; Frm.BorderWidth:=0; end;
  end;
begin
  MenuBufControl:=Screen.ActiveControl;            // remember focused control
  if F<>ActiveMDIChild then                                 // and DATA window
  begin
    F:=ActiveMDIChild; UpdateSerieComboBox; UpdateSerieList;
    if Assigned(F) and Assigned (SerieMgrForm)
    then with SerieMgrForm.WindowListView do
    for I:=0 to Items.Count-1 do if Items[I].Data=F then
    begin ItemFocused:=Items[I]; Selected:=Items[I]; Break; end;
  end;
  B:=true;
// monitor ScriptingForm, BrowserForm and NotesForm statusbars
  with ScriptingForm do if Floating then
  begin
    with StatusBar.Panels[0] do
    if Memo.Modified then Text:=strModified else Text:='';
    UpdateCursorPosition(S); StatusBar.Panels[1].Text:=S;
    if Application.Hint='' then if ProcedureAction.Items.Count>0
    then StatusBar.Panels[2].Text:=strReady else StatusBar.Panels[2].Text:='';
  end else if Screen.ActiveControl=Memo then
  begin
    B:=false; MainForm.StatusBar.Panels[4].Text:=FFileName;
    with MainForm.StatusBar.Panels[0] do
    if Memo.Modified then Text:=strModified else Text:='';
    UpdateCursorPosition(S); MainForm.StatusBar.Panels[5].Text:=S;
    if Application.Hint='' then
    with MainForm.StatusBar.Panels[6] do if ProcedureAction.Items.Count>0
    then Text:=strReady else Text:='';
  end;
  with NotesForm do if Floating then
  begin
    with StatusBar.Panels[0] do
    if Memo.Modified then Text:=strModified else Text:='';
    UpdateCursorPosition(S); StatusBar.Panels[1].Text:=S;
  end else if Screen.ActiveControl=Memo then
  begin
    B:=false; MainForm.StatusBar.Panels[4].Text:=FFileName;
    with MainForm.StatusBar.Panels[0] do
    if Memo.Modified then Text:=strModified else Text:='';
    UpdateCursorPosition(S); MainForm.StatusBar.Panels[5].Text:=S;
  end;
  if (Screen.ActiveControl=BrowserForm.WebBrowser)
     and (not BrowserForm.Floating) then
  begin B:=false; MainForm.StatusBar.Panels[4].Text:=BrowserForm.Caption; end;
  if (not SerieMgrForm.Floating) and
     (Screen.ActiveControl=SerieMgrForm.SerieListView) then
  begin
    B:=false; StatusBar.Panels[4].Text:=SerieMgrForm.Caption;
    if Assigned(ActiveDataForm) then S:=Format(strNewSerie,
    [ActiveDataForm.Plot.SerieIndex]) else S:='';
    StatusBar.Panels[5].Text:=S;
  end;
// monitor memo, list and browser frames
  SetFrame(NotesForm, NotesForm.Memo.Focused);
  SetFrame(ScriptingForm, ScriptingForm.Memo.Focused);
  SetFrame(BrowserForm, Screen.ActiveControl=BrowserForm.WebBrowser);
  if not SerieMgrForm.Floating then
  begin
    with SerieMgrForm.WindowListView do
    if Focused or IsEditing
    then BorderStyle:=bsSingle else BorderStyle:=bsNone;
    with SerieMgrForm.SerieListView do
    if Focused or IsEditing
    then BorderStyle:=bsSingle else BorderStyle:=bsNone;
  end else
  begin
    SerieMgrForm.WindowListView.BorderStyle:=bsSingle;
    SerieMgrForm.SerieListView.BorderStyle:=bsSingle;
  end;
// other updates
  if Assigned(ActiveDataForm) then with SerieMgrForm.SerieListView do
  begin                                                       // Serie Manager
    ItemFocused:=Items[ActiveDataForm.Plot.SerieIndex];
    Selected:=Items[ActiveDataForm.Plot.SerieIndex];
  end;
  if GetActiveCtrlType<>ACT then                       // update control image
  begin ACT:=GetActiveCtrlType; StatusBar.Invalidate; end;
  ProgressBar.Visible:=false;             // normally ProgressBar is invisible
  if B then                                    // update container information
  begin      // only if statusbar not used by Notes, Browser or Script Window!
    S:='';
    if Assigned(ActiveDataForm) then
    begin
      if (GetActiveCtrlType=actPlot)
         and Assigned(ActiveDataForm.Plot.ThisSerie)
         and Assigned(ActiveDataForm.Plot.ThisSerie.Container)
      then S:=GetContainerName(ActiveDataForm.Plot.ThisSerie.Container,true);
      if (GetActiveCtrlType=actWks)
      then S:=GetContainerName(ActiveDataForm.Container,true);
      if (GetActiveCtrlType=actWks) then
      StatusBar.Panels[5].Text:=Format(strNotes,[ActiveDataForm.Worksheet.Row-
      ActiveDataForm.Worksheet.FixedRows, ActiveDataForm.Worksheet.Col]);
    end;
    StatusBar.Panels[4].Text:=S;
    if Assigned(ActiveDataForm) and ActiveDataForm.Container.Modified then
    Statusbar.Panels[0].Text:=strModified else Statusbar.Panels[0].Text:='';
  end;
  if Assigned(ActiveDataForm) and Assigned(ActiveDataForm.Plot.ThisSerie) and
     AppPropsForm.AutoNameAxisCheckBox.Checked then UpdateAxisTitles;
// monitor MDI controls
  if Assigned(ActiveMDIChild)
  and (ActiveMDIChild.WindowState=wsMaximized) then
  begin
    MenuImage.Visible:=true;
    ActionMainMenuBar.Left:=20;
    MinimizeSpeedButton.Visible:=true;                // buttons, NOT actions!
    RestoreSpeedButton.Visible:=true;
    CloseSpeedButton.Visible:=true;
  end else
  begin
    MenuImage.Visible:=false;
    ActionMainMenuBar.Left:=2;
    MinimizeSpeedButton.Visible:=false;
    RestoreSpeedButton.Visible:=false;
    CloseSpeedButton.Visible:=false;
  end;
// monitor actions that have no OnUpdate
  SaveAsAction.Enabled:=Assigned(ActiveMDIChild);
  if MDIChildCount<>ChildCount then                 // monitor MDI window menu
  begin ChildCount:=MDIChildCount; UpdateMDIMenu; UpdateWindowList; end;
{$ifdef SafeMemo}          // repair language combo if corrupted by docking...
  with ScriptingForm.LanguageComboBox do if Items.Text='' then
  begin Items.Text:='VBScript'#13#10'JScript'; ItemIndex:=0; end;
{$endif}
end;

procedure TMainForm.ApplicationEventsHint(Sender: TObject);
var FM: TForm; S: string;
begin
  FM:=Screen.ActiveForm;
  if Assigned(FM) and (biHelp in FM.BorderIcons) then Exit;
  // modal dialog box - hints displayed by HTMLHelp, [?] button
  if Application.Hint<>'' then StatusBar.SimplePanel:=false; // hide manually!
  if (GetActiveCtrlType in [actWks,actPlot]) and
     (Application.Hint=GetLongHint(UndoAction.Hint))
  then S:=Application.Hint+ActiveDataForm.UndoHint else S:=Application.Hint;
  // WARNING: Undo hint in notes and data windows MUST DIFFER!!!
  if Assigned(FM) and Assigned(FM.FindComponent('StatusBar')) then
  with FM.FindComponent('StatusBar') as TStatusBar do
  Panels[Panels.Count-1].Text:=S
  else with StatusBar do Panels[Panels.Count-1].Text:=S;
end;

procedure TMainForm.ApplicationEventsException(Sender: TObject; E: Exception);
begin Application.ShowException(E); end;

procedure TMainForm.ApplicationEventsShowHint(var HintStr: String;
  var CanShow: Boolean; var HintInfo: THintInfo);
begin              // we don't use plot hints because they are not convenient!
  if (HintInfo.HintControl=SerieComboBox) and Assigned(ActiveDataForm)
     and Assigned(ActiveDataForm.Plot.ThisSerie) then
  begin
    with ActiveDataForm.Plot.ThisSerie do if not Empty then HintInfo.HintStr:=
    Format(strSerieProperties,[
      char(XColumn+byte('A')-1)+' ['+ActiveDataForm.Labels[XColumn],
      char(YColumn+byte('A')-1)+' ['+ActiveDataForm.Labels[YColumn],Firstline,
      Lastline,GetContainerName(Container,false),XExpression,YExpression])
    else if IsFunction then HintInfo.HintStr:=YExpression
         else HintInfo.HintStr:=strEmpty;
    HintInfo.HideTimeout:=Application.HintHidePause*10;
  end;
end;

procedure TMainForm.ApplicationEventsMinimize(Sender: TObject);
begin if UseTaskBar then ShowWindow(Application.Handle, SW_SHOW); end;

procedure TMainForm.ApplicationEventsRestore(Sender: TObject);
begin if UseTaskBar then ShowWindow(Application.Handle, SW_HIDE); end;

function TMainForm.ApplicationEventsHelp(Command: Word; Data: Integer;
  var CallHelp: Boolean): Boolean;
const P: TPoint=(X: 0; Y: 0);
var HFile: array[0..MAX_PATH] of char; Qry: THHFtsQuery;
begin
  CallHelp:=false; Result:=true;                // Default WinHelp not called!
  case Command of
    HELP_SETPOPUP_POS: P:=SmallPointToPoint(TSmallPoint(Data));
    HELP_CONTEXTPOPUP: HelpCtx(P, Data);
    HELP_FINDER:                                 // invoked by HelpTopicSearch
    begin
      FillChar(Qry,SizeOf(Qry),0);
      Qry.cbStruct:=SizeOf(Qry);
      Qry.fUniCodeStrings:=false;
      Qry.pszSearchQuery:=nil;
      Qry.iProximity:=HH_FTS_DEFAULT_PROXIMITY;
      Qry.fStemmedSearch:=false;
      Qry.fTitleOnly:=false;
      Qry.fExecute:=false;
      Qry.pszWindow:=nil;
      StrPLCopy(HFile,
        ExtractFilePath(Application.ExeName)+Application.HelpFile,MAX_PATH-1);
      HtmlHelp(0,HFile,HH_DISPLAY_SEARCH,DWORD(@Qry));
    end;
  else Result:=false;
  end;
end;

procedure TMainForm.ApplicationEventsMessage(var Msg: tagMSG;
  var Handled: Boolean);
begin       // used instead of OnClick to set focus (code moved from UpdateUI)
  if (Msg.message=WM_LBUTTONDOWN)
    and (BrowserForm.ComponentState<>[csDestroying])
    and BrowserForm.Visible
    and (Screen.ActiveControl<>BrowserForm.WebBrowser)
    and (not BrowserForm.Floating)
    and (BrowserForm.ControlAtPos(BrowserForm.ScreenToClient(Mouse.CursorPos),
      false,true)=BrowserForm.WebBrowser)
  then BrowserForm.WebBrowser.SetFocus;
end;

//////////////// MAINFORM EVENT HANDLERS /////////////////////////////////////

procedure TMainForm.FormCreate(Sender: TObject);
const
  RegKey='Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders';
  AutoSaveName='AUTOSAVE.DMW';
  ToolBarsName='TOOLBARS.BIN';
var ADF: string;
begin
  PictureBitmap:=TBitmap.Create;
  PictureBitmap.LoadFromResourceName(hInstance,'picture');
  DragAcceptFiles(Handle, true);         {enable drag&drop from file managers}
  Screen.Cursors[crFrame]:=LoadCursor(HInstance, PChar(crFrame));
  Screen.Cursors[crTarget]:=LoadCursor(HInstance, PChar(crTarget));
  Screen.Cursors[crSelect]:=LoadCursor(HInstance, PChar(crSelect));
  Screen.Cursors[crEdit]:=LoadCursor(HInstance, PChar(crEdit));
  ProgressBar.Top:=StatusBar.Top+2;             // correct menu height changes
  AutoSaveFN:=ExtractFilePath(Application.EXEName)+AutoSaveName;    // default
  ToolbarsFN:=ExtractFilePath(Application.EXEName)+ToolBarsName;
  with TRegistry.Create do  // try to use shell folder instead of installation
  try
    if OpenKeyReadOnly(RegKey) and (ReadString('AppData')<>'') then
    begin
      ADF:=ReadString('AppData')+'\RRR\DM2000';
      if DirectoryExists(ADF) then
      begin
        AutoSaveFN:=ADF+'\'+AutoSaveName; ToolbarsFN:=ADF+'\'+ToolBarsName;
      end;
    end;
  finally
    Free;
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  PictureBitmap.Free;
  DragAcceptFiles(Handle, false);
  MainForm:=nil;     // if not cleared, crash may be in TDMExternalApp.Destroy
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var I,W,Count: integer; V,B,F: boolean; N: string[63]; S: TMemoryStream;
begin                    // may be called from Automation prior to termination
  Timer.Enabled:=false;  // prevent browser onunload crash (& m.b. some other)
  try // under some circumstances this code may raise exception and block exit
    BrowserForm.WebBrowser.Navigate('about:blank');
  except
    on E: Exception do ShowMessage(E.Message);
  end;
  ActionManager.SaveToFile(ToolbarsFN);     // always save (usage statistics!)
  if not AppPropsForm.SaveOnExitCheckBox.Checked then Exit;
  WriteRegistry;                  // settins & window layout - only if checked
  S:=TMemoryStream.Create;                   // note: they are interdependent!
  try
    // save dockhosts layout
    LeftDockPanel.DockManager.SaveToStream(S);
    S.WriteBuffer(LeftDockPanel.Width,SizeOf(integer));
    RightDockPanel.DockManager.SaveToStream(S);
    S.WriteBuffer(RightDockPanel.Width,SizeOf(integer));
    BottomDockPanel.DockManager.SaveToStream(S);
    S.WriteBuffer(BottomDockPanel.Height,SizeOf(integer));
    // save CoolBar layout
    Count:=CoolBar.Bands.Count; S.WriteBuffer(Count,SizeOf(Count));
    for I:=0 to Count-1 do with CoolBar.Bands[I] do
    begin
      V:=Visible; S.WriteBuffer(V,SizeOf(V));
      B:=Break; S.WriteBuffer(B,SizeOf(B));
      F:=FixedSize; S.WriteBuffer(F,SizeOf(F));
      W:=Width; S.WriteBuffer(W,SizeOf(W));
      N:=Control.Name; S.WriteBuffer(N,SizeOf(N));
    end;
    with TRegistry.Create do
    try
      OpenKey(DataMasterRegKey, true);
      if S.Size<10000 then WriteBinaryData('Layout',S.Memory^,S.Size);
      CloseKey;
    finally
      Free;
    end;
  finally
    S.Free;
  end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin        // if text modified, ask user to save. Not in registry (too big!)
  if ScriptingForm.Memo.Modified then
  case MessageDlg(Format(strCloseQuery,[ScriptingForm.FCaptionBuf]),
    mtConfirmation,mbYesNoCancel,0) of
    mrYes: ScriptingForm.SaveToolButton.Click;
    mrCancel: CanClose:=false;
  end;     // also note that it's impossible to place this code in these forms
  if NotesForm.Memo.Modified then
  case MessageDlg(Format(strCloseQuery,[NotesForm.FCaptionBuf]),
    mtConfirmation,mbYesNoCancel,0) of
    mrYes: NotesForm.SaveToolButton.Click;
    mrCancel: CanClose:=false;
  end;
end;

//////////////// COMPONENT EVENTS ////////////////////////////////////////////

procedure TMainForm.ActionToolBarGetControlClass(
  Sender: TCustomActionBar; AnItem: TActionClient;
  var ControlClass: TCustomActionControlClass);
begin
// see original (inherited) implementation of this method
// in TCustomActionToolBar.CreateControl (ActnCtrls.pas, line 1107)
  ControlClass:=TCustomButtonControl;
  if (AnItem is TActionClientItem)
     and ((AnItem as TActionClientItem).Action=SeparatorAction) then
  begin
    (AnItem as TActionClientItem).Action:=nil;
    (AnItem as TActionClientItem).Caption:='-';
  end;
  if (AnItem is TActionClientItem) and Assigned(ScriptingForm) then
  with (AnItem as TActionClientItem) do
  begin
    if Action=ScriptingForm.ProcedureAction
    then ControlClass:=TCustomComboControl;
    if Action=ScriptingForm.CompileAction then
    begin
      ControlClass:=TCustomDropDownButton;
      if Items.Count=0 then
      begin
        Items.Add.Action:=ScriptingForm.CompileVBSAction;
        Items.Add.Action:=ScriptingForm.CompileJSAction;
        Items.HideUnused:=false;
      end;
    end;
  end;
end;

procedure TMainForm.ContainerProgress(Sender: TObject; P: Integer);
begin
  if LoadingFile then
    if (P mod 5)=0 then              {else indication will slow file opening!}
    begin
      StatusBar.Panels[0].Text:=Format(strLoadingLine,[P]); StatusBar.Update;
    end else
  else
  begin
    if not ProgressBar.Visible then ProgressBar.Show;               {autoshow}
    if StepProgress then ProgressBar.StepIt else ProgressBar.Position:=P;
  end;
end;

procedure TMainForm.TimerTimer(Sender: TObject);
var I: cardinal;
const LastAutoSave: DWORD=0;
begin
  if GetTickCount-MessageTick>cardinal(StatusBar.Tag)
  then StatusBar.SimplePanel:=false; // ^ holds DisplayMessage() time delay!!!
  I:=Random(9); if I>2 then I:=0; UpdatePicture(I);      // animate (Idx=0..2)
  with AppPropsForm.AutoSaveSpinEdit do if (Value=0) or (LastAutoSave=0) then
  LastAutoSave:=GetTickCount else
  if GetTickCount-LastAutoSave>DWORD(Value*60000) then
  begin LastAutoSave:=GetTickCount; SaveDesktopActionAccept(Sender); end;
end;

procedure TMainForm.DdeServerConvClose(Sender: TObject);
begin DisplayHint(strDDEConnectionClose); DdeServerConv.Tag:=0; end;

procedure TMainForm.DdeServerConvOpen(Sender: TObject);
begin DisplayHint(strDDEConnectionOpen); DdeServerConv.Tag:=1; end;

procedure TMainForm.DdeServerConvExecuteMacro(Sender: TObject; Msg: TStrings);
var I,J: integer; R: TRealArray;
begin
  if Msg.Names[0]='Open' then LoadFile(Msg.Values['Open']);       // open file
  if UpperCase(Msg.Names[0])=strMessage then                 // server message
  MessageDlg(Format(strServerMessage, [Msg.Values[strMessage]]),
    mtInformation,[mbOk],0);
  if UpperCase(Msg.Names[0])=strExpSettings then        // experiment settings
  begin Msg.Delete(0); MainForm.ExpSettings:=Msg.Text; end;
  if UpperCase(Msg.Names[0])=strData then                      // process DATA
  begin
    if StrToIntDef(Msg.Values[strData],$FFF)<>Msg.Count-1 then // check format
    begin DisplayMessage(strInvalidData); Exit; end;
    Msg.Delete(0); J:=0;
    for I:=0 to Msg.Count-1 do if I<MaxCols then
    begin
      R[I+1]:=StrToFloat(Msg.Values[Msg.Names[I]]);
      Msg[I]:=Msg.Names[I]; Inc(J);
    end;
    RecordPoint(J,R,Msg);
  end;  
end;

procedure TMainForm.PicturePaintBoxPaint(Sender: TObject);
begin
  SelectPalette(PicturePaintBox.Canvas.Handle, PictureBitmap.Palette, false);
  RealizePalette(PicturePaintBox.Canvas.Handle); // NEED for 256 color mode!!!
  with PicturePaintBox do Canvas.CopyRect(Rect(0,0,Width-1,Height-1),
  PictureBitmap.Canvas,Rect(Width*Tag,0,Width*(Tag+1)-1,Height-1));
end;

procedure TMainForm.StatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
var I,X,Y: integer;
begin       // draw status icon: tag=0 means no icon, 1 - 1st image and so on.
  if Panel.Index=1 then with StatusImageList do if Tag>0
  then Draw(StatusBar.Canvas, Rect.Left+1, Rect.Top+1, Tag-1) else
  if Assigned(DMApplication) or MonitorForm.Connected or (DdeServerConv.Tag=1)
  then Draw(StatusBar.Canvas, Rect.Left+1, Rect.Top+1, 5);
  if Panel.Index=4 then                      // draw active object information
  begin
    with StatusBar do
    begin Canvas.Brush.Color:=Color; Canvas.FillRect(Rect); end;
    Y:=(StatusBar.Height-StatusBar.Canvas.TextHeight('H')-4) div 2; X:=18;
    with StatusBar do Canvas.Pen.Color:=Font.Color;
    StatusBar.Canvas.TextRect(Rect, Rect.Left+X, Rect.Top+Y,
    StatusBar.Panels[4].Text);
    I:=-1;
    case GetActiveCtrlType of
      actWks: I:=11;
      actPlot: I:=12;
      actNotes: I:=9;
      actScript: I:=7;
      actBrowser: I:=10;
      actSerieMgr: I:=13;
    end;
    if I<>-1 then StatusImageList.Draw(StatusBar.Canvas,
    Rect.Left+1, Rect.Top+1 ,I);
  end;
end;

procedure TMainForm.SerieComboBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var S: TSerie; LL,LR,SS: integer;
begin
  if not (SerieComboBox.Items.Objects[Index] is TSerie) then Exit       // ???
  else S:=SerieComboBox.Items.Objects[Index] as TSerie;
  with {SerieComboBox}Control as TComboBox do
  begin                          // note that combo's Objects point to Series!
    Canvas.FillRect(Rect); LL:=Rect.Left+StatusImageList.Width*2;
    LR:=LL+Rect.Left+(Rect.Bottom-Rect.Top)*2;    // calculate legend position
    if S.Collection=nil then Exit; // sometimes AV was observed at this point!
    Canvas.TextOut(LR,Rect.Top+1,S.Text);
    Canvas.TextOut(Rect.Left,Rect.Top+1,IntToStr(Index{+1!!! from zero!}));
    if S.Empty then if S.IsFunction then SS:=8 else SS:=3
    else if ((S.Collection as TSeries).Plot.Owner
       as TDataForm).IsRecordingSerie[Index] then Ss:=4 else SS:=2;
    StatusImageList.Draw(Canvas,Rect.Left+StatusImageList.Width, Rect.Top,SS);
    Canvas.Pen.Assign(S.Pen); Canvas.Brush.Assign(S.Brush);
    if S.LineVisible then
    Canvas.PolyLine([Point(LL,(Rect.Top+Rect.Bottom) div 2),
      Point(LR,(Rect.Top+Rect.Bottom) div 2)]);
    if S.PointVisible then (S.Collection as TSeries).Plot.PaintPoint(
    (LL+LR)div 2,(Rect.Top+Rect.Bottom) div 2,S.PointType,S.PointSize,Canvas);
  end;
end;

procedure TMainForm.SerieComboBoxChange(Sender: TObject);
begin
  if Assigned(ActiveDataForm)
  then ActiveDataForm.Plot.SerieIndex:=SerieComboBox.ItemIndex;
end;

procedure TMainForm.SerieUpDownChangingEx(Sender: TObject;
  var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
begin                                  // changes only SerieComboBox.ItemIndex
  if (Direction=updUp) and
  (SerieComboBox.ItemIndex<ActiveDataForm.Plot.Series.Count-1)
  then SerieComboBox.ItemIndex:=SerieComboBox.ItemIndex+1
  else AllowChange:=false;
  if (Direction=updDown) and (SerieComboBox.ItemIndex>0)
  then SerieComboBox.ItemIndex:=SerieComboBox.ItemIndex-1
  else AllowChange:=false;
  SerieComboBoxChange(Sender);              // doesn't called automatically!!!
end;

procedure TMainForm.PlotPopupMenuPopup(Sender: TObject);
begin
  PlotPropertiesItem.Default:=true;     // the same action invoked by dblclick
  case ActiveDataForm.Plot.ClickedAt of
    claPlot: begin                              // correct action and fontface
      PlotPropertiesItem.Action:=SeriePropertiesAction;
      PlotPropertiesItem.Default:=ActiveDataForm.Plot.MouseMode=pmNone;
    end;
    claXAxis: PlotPropertiesItem.Action:=XAxisPropertiesAction;
    claYAxis: PlotPropertiesItem.Action:=YAxisPropertiesAction;
  end;
  PlotPropertiesItem.ImageIndex:=31;
end;

{WARNING! the only purpose of this handler is to repair focus corruption BUG!}
{SEE ALSO: MenuBufControl field AND remarks in TMainForm.GetActiveCtrlType}
procedure TMainForm.ActionManagerExecute(Action: TBasicAction;
  var Handled: Boolean);
begin                         // restore focused control corrupted by mainmenu
  Handled:=false; if not Assigned(MenuBufControl) then Exit;    // may be nil!
  if MenuBufControl.Owner is TDataForm
  then Windows.SetFocus(MainForm.ClientHandle);
  try
    MenuBufControl.SetFocus;             // if seriecombo focused and disabled
  except                                 // this line fires exception! because
  end;                                   // this is noncritical we just ignore
end;

//////////////// ACTION HANDLERS /////////////////////////////////////////////

procedure TMainForm.ActionExecuteStub(Sender: TObject);
begin ShowMessage('Not implemented!'); end;

//////////// OPTIONS

procedure TMainForm.ApplicationActionExecute(Sender: TObject);
begin AppPropsForm.Execute; end;

procedure TMainForm.NotesActionExecute(Sender: TObject);
begin NotesForm.Show;{Visible:=not NotesForm.Visible;} end;

procedure TMainForm.NotesActionUpdate(Sender: TObject);
begin NotesAction.Checked:=NotesForm.Visible; end;

procedure TMainForm.ScriptActionExecute(Sender: TObject);
begin ScriptingForm.Show;{Visible:=not ScriptingForm.Visible;} end;

procedure TMainForm.ScriptActionUpdate(Sender: TObject);
begin ScriptAction.Checked:=ScriptingForm.Visible; end;

procedure TMainForm.BrowserActionExecute(Sender: TObject);
begin BrowserForm.Show;{Visible:=not BrowserForm.Visible;} end;

procedure TMainForm.BrowserActionUpdate(Sender: TObject);
begin BrowserAction.Checked:=BrowserForm.Visible; end;

procedure TMainForm.CalculatorActionExecute(Sender: TObject);
begin with CalculatorForm do {Visible:=not Visible;}ShowModal;{!!!} end;

procedure TMainForm.CalculatorActionUpdate(Sender: TObject);
begin CalculatorAction.Checked:=CalculatorForm.Visible; end;

procedure TMainForm.SpeedTestActionExecute(Sender: TObject);
begin { ShowSpeedTest; }
  with TSpeedTestForm.Create(Application) do
  try
    HelpBitBtn.OnClick:=HelpButtonClick;
    ShowModal;
  finally
    Free;
  end;
end;

procedure TMainForm.CalTableActionExecute(Sender: TObject);    // for xTable()
begin           // note that worksheet MUST BE sorted by X column (ascending)!
  Container.Assign(ActiveDataForm.Container);              // ALL DATA COPIED!
  Container.Tag:=ActiveDataForm.XColumn;
  Container.FileName:=ActiveDataForm.Container.FileName;
end;

procedure TMainForm.MonitorActionExecute(Sender: TObject);
begin MonitorForm.Show; end;

procedure TMainForm.MonitorActionUpdate(Sender: TObject);
begin MonitorAction.Checked:=MonitorForm.Visible; end;

procedure TMainForm.CustomizeActionBarsActionExecute(Sender: TObject);
begin CustomizeDlg.Show; end;

procedure TMainForm.SerieMgrActionExecute(Sender: TObject);
begin SerieMgrForm.Show; end;

procedure TMainForm.SerieMgrActionUpdate(Sender: TObject);
begin SerieMgrAction.Checked:=SerieMgrForm.Visible; end;

procedure TMainForm.SetupActionExecute(Sender: TObject);
begin
  with TSetupForm.Create(Application) do
  try
    HelpBitBtn.OnClick:=HelpButtonClick;
    ShowModal;
  finally
    Free;
  end;
end;

//////////// WINDOW

procedure TMainForm.RenameActionExecute(Sender: TObject);     // only caption!
begin
  with ActiveDataForm do Caption:=InputBox(strEnter, strRename, Caption);
  UpdateMDIMenu; UpdateWindowList; UpdateSerieList;
end;                     // update menu item and serie manager (BOTH lists!!!)

procedure TMainForm.CloseAllActionExecute(Sender: TObject);
var I: integer; b: boolean;
begin             // this code process only mdi children, not script window!!!
  b:=true; for I:=0 to MDIChildCount-1 do b:=b and MDIChildren[I].CloseQuery;
  if b then for I:=0 to MDIChildCount-1 do MDIChildren[I].Release;
end;

procedure TMainForm.DuplicateActionExecute(Sender: TObject);
var SF,DF: TDataForm; I: integer;
begin
  StatusImageList.Tag:=8; DisplayHint(strWorking);
  try
    SF:=ActiveDataForm; DF:=TDataForm.Create(Self);
    InitParser(DF.Plot.Parser);
    DF.Container.FileName:=Format(strNoname,[MDIChildCount]);
    // copy form properties
    SF.XColumn:=DF.XColumn; SF.YColumn:=DF.YColumn;
    DF.DataFormat:=SF.DataFormat; DF.ViewState:=SF.ViewState;
    // copy worksheet properties
    DF.Worksheet.Color:=SF.Worksheet.Color;
    DF.Worksheet.FixedColor:=SF.Worksheet.FixedColor;
    DF.Worksheet.BlockColorB:=SF.Worksheet.BlockColorB;
    DF.Worksheet.BlockColorF:=SF.Worksheet.BlockColorF;
    DF.Worksheet.Header:=SF.Worksheet.Header;
    DF.Worksheet.Font:=SF.Worksheet.Font;
    DF.Worksheet.AlignRight:=SF.Worksheet.AlignRight;
    DF.Worksheet.Header.Assign(SF.Worksheet.Header);
    // container
    DF.Container.Assign(SF.Container);
    // plot
    DF.Plot.XAxis:=SF.Plot.XAxis; DF.Plot.YAxis:=SF.Plot.YAxis;
    DF.PlotPanel.Color:=SF.PlotPanel.Color;
    while DF.Plot.Series.Count<SF.Plot.Series.Count do
    begin DF.Plot.Series.Add; DF.DMDocument.AddSerieObject; end;
    UpdateSerieComboBox; UpdateSerieList;
    for I:=0 to DF.Plot.Series.Count-1 do
    begin
      DF.Plot.Series[I].Assign(SF.Plot.Series[I]);
      if DF.Plot.Series[I].Container=SF.Container
      then DF.Plot.Series[I].Container:=DF.Container;
    end;
  finally
    StatusImageList.Tag:=0; Progressbar.Hide; DisplayHint('');
  end;
end;

//////////// HELP

procedure TMainForm.WebHomepageActionExecute(Sender: TObject);
begin ShellOpenFile(AppPropsForm.HomepageEdit.Text); end;

procedure TMainForm.HowToActionExecute(Sender: TObject);
begin HelpCmd(HH_DISPLAY_TOPIC,'::/WWW/usrguide.htm#howto'); end;

procedure TMainForm.HelpContentsActionExecute(Sender: TObject);
begin
  HelpCmd(HH_DISPLAY_TOC,nil); HelpCmd(HH_DISPLAY_TOPIC,'::/contents.htm');
end;

procedure TMainForm.AboutActionExecute(Sender: TObject);
begin
  with Application do
  begin
    NormalizeTopMosts;
    ShellAboutBox(Title, Exename, Self{!!!}.Handle, Icon.Handle, true);
    RestoreTopMosts;
  end;
end;

procedure TMainForm.CheckUpdatesActionExecute(Sender: TObject);
var N: IXMLNode; S1,S2,Res: string;
begin
  StatusImageList.Tag:=11; Screen.Cursor:=crHourGlass;
  DisplayHint(Format(strLoadingFile,[XMLDocument.FileName]));
  try
    XMLDocument.Active:=true;
    N:=XMLDocument.ChildNodes.FindNode('XML_DIZ_INFO');
    if Assigned(N) then N:=N.ChildNodes.FindNode('Program_Info');
    if Assigned(N) then N:=N.ChildNodes.FindNode('Program_Version');
    if Assigned(N) then
    begin
      S1:=Trim(N.NodeValue);
      S2:=Trim(GetVersionString(VersionStringKeys[vskFileVersion],
      Application.Exename));
      if S1=S2 then Res:=strXMLNoDiff
      else Res:=Format(strXMLDifferent,[S2,S1]);
    end else Res:=strXMLBadFile;
    XMLDocument.Active:=false;
  finally
    StatusImageList.Tag:=0; DisplayHint(''); Screen.Cursor:=crDefault;
  end;
  MessageDlg(Res, mtInformation, [mbOk], 0);
end;

//////////// FILE

procedure TMainForm.NewActionExecute(Sender: TObject);
begin
  CreateDataForm.Container.FileName:=Format(strNoname,[MDIChildCount]);
end;

procedure TMainForm.OpenActionBeforeExecute(Sender: TObject);
begin OpenAction.Dialog.FileName:=''; end;

procedure TMainForm.OpenActionAccept(Sender: TObject);
begin
  AddToReopen(OpenAction.Dialog.FileName);
  OpenFile(OpenAction.Dialog.FileName);
end;

procedure TMainForm.ReopenActionExecute(Sender: TObject);
begin OpenFile((Sender as TAction).Hint); end;

procedure TMainForm.SaveActionExecute(Sender: TObject);
begin
  if (Screen.ActiveForm=Self) and (Screen.ActiveControl is TMemo)
     and (Sender=SaveAction) then         // note: also called by SaveAsAction
  ((Screen.ActiveControl as TMemo).Owner as TNotesForm).SaveAsAction.Execute 
  else with ActiveDataForm.Container do
  try
    StatusImageList.Tag:=2; DisplayHint(Format(strSavingFile,[FileName]));
    SaveToFile(AppPropsForm.BackupCheckBox.Checked);
  finally
    StatusImageList.Tag:=0; DisplayHint('');
  end;
end;

procedure TMainForm.SaveActionUpdate(Sender: TObject);
begin
  case GetActiveCtrlType of
    actNotes,actScript: SaveAction.Enabled:=true;
    actWks,actPlot: SaveAction.Enabled:=ActiveDataForm.Container.Modified;
  else SaveAction.Enabled:=false;
  end;
end;

procedure TMainForm.SaveAsActionBeforeExecute(Sender: TObject);
begin
  if not Assigned(ActiveDataForm) then Abort else
  SaveAsAction.Dialog.FileName:=ActiveDataForm.Container.FileName;
end;

procedure TMainForm.SaveAsActionAccept(Sender: TObject);
begin
  if not Assigned(ActiveDataForm) then Exit;
  ActiveDataForm.Container.FileName:=SaveAsAction.Dialog.FileName;
  SaveActionExecute(Sender); UpdateMDIMenu; UpdateWindowList;
  // note: UpdateSerieList() called indirectly from from ContainerChanged!!!!!
end;

procedure TMainForm.SaveDesktopActionAccept(Sender: TObject);
var
  Stm: TFileStream; I,J,K,N,TL: longint; ID: TDateTime; Wr: TWriter;
  TagBufLen: longint; TagBuf: PChar; VS: TDataFormView; B: boolean;
  procedure WriteSize(Fm: TForm);           {remembers window position & size}
  var WS: TWindowState; I: smallint;
  begin
    WS:=Fm.WindowState; Wr.Write(WS, SizeOf(WS));
    if Fm.WindowState=wsNormal then
    begin
      I:=Fm.Left; Wr.Write(I, Sizeof(I));
      I:=Fm.Top; Wr.Write(I, Sizeof(I));
      I:=Fm.Width; Wr.Write(I, Sizeof(I));
      I:=Fm.Height; Wr.Write(I, Sizeof(I));
    end;
  end;
begin
  TL:=0;
  if Sender=Timer then
  begin                                               {if called for autosave}
    N:=0; for I:=0 to MDIChildCount-1 do
    if (MDIChildren[I] as TDataForm).Container.Modified then
    begin                   {count modified windows and total number of lines}
      Inc(N); Inc(TL,(MDIChildren[I] as TDataForm).Container.Items.Count);
    end;
    if N=0 then Exit;                           {no modified - nothing to do!}
    Stm:=TFileStream.Create(AutoSaveFN,fmCreate);   {else create autosave.dmw}
  end else
  begin                                                  {if called from menu}
    N:=MDIChildCount; for I:=0 to MDIChildCount-1 do
    Inc(TL,(MDIChildren[I] as TDataForm).Container.Items.Count);
    Stm:=TFileStream.Create(SaveDesktopAction.Dialog.FileName, fmCreate);
  end;
  try
    Wr:=TWriter.Create(Stm,1024); StatusImageList.Tag:=2; StepProgress:=true;
    try
      Wr.Write(DSK10Sign, SizeOf(DSK10Sign));                {write signature}
      TagBuf:=NotesForm.Memo.Lines.GetText;            {get text from strings}
      try
        TagBufLen:=StrLen(TagBuf);                      {calculate its length}
        Wr.Write(TagBufLen, SizeOf(TagBufLen));      {write tag buffer length}
        if TagBufLen>0 then Wr.Write(TagBuf^, TagBufLen);  {and buffer itself}
      finally
        StrDispose(TagBuf);                                      {free buffer}
        NotesForm.Memo.Modified:=false;     {clear modif. flag as in dataform}
      end;
      WriteSize(Self);                                   {write self size/pos}
      Wr.Write(N,SizeOf(N));                         {write number of windows}
      Wr.Write(TL,SizeOf(TL));                   {write total number of lines}
      with ProgressBar do begin Position:=0; Max:=TL; end;    {initialize...}
      for I:=MDIChildCount-1 downto 0 do                  {write MDI children}
      if (Sender<>Timer) or
         (MDIChildren[I] as TDataForm).Container.Modified then
      begin                                             {note: inverse order!}
        DisplayHint(Format(strSavingFile,                       {hint writing}
        [GetContainerName((MDIChildren[I] as TDataForm).Container,false)]));
        (MDIChildren[I] as TDataForm).UndoContainer.Clear;  {no need to save!}
        Wr.WriteRootComponent(MDIChildren[I]);
        WriteSize(MDIChildren[I]);             {form writes this incorrectly!}
        with MDIChildren[I] as TDataForm do              {write public fields}
        begin
          Wr.Write(XColumn, SizeOf(XColumn));
          Wr.Write(YColumn, SizeOf(YColumn));
          Wr.Write(DataFormat, SizeOf(DataFormat));
          Wr.Write(FormID, SizeOf(FormID));
          VS:=ViewState; Wr.Write(VS, SizeOf(VS));
        end;
        for J:=0 to (MDIChildren[I] as TDataForm).Plot.Series.Count-1 do
        begin                                            {remember series IDs}
          ID:=0;                                     {0 means "not assigned!"}
          for K:=0 to MDIChildCount-1 do
          if (MDIChildren[I] as TDataForm).Plot.Series[J].Container=
          (MDIChildren[K] as TDataForm).Container then
          begin ID:=(MDIChildren[K] as TDataForm).FormID; Break; end; {Found!}
          Wr.Write(ID,SizeOf(ID));
          B:=(MDIChildren[I] as TDataForm).IsRecordingSerie[J];
          Wr.Write(B,SizeOf(B));            {remember serie "recording" state}
        end;
      end;// for I:=0 ... (children write cycle)
      DisplayHint(strSavingTable); Wr.WriteRootComponent(Container);
    finally
      Wr.Free;StatusImageList.Tag:=0;ProgressBar.Max:=100;StepProgress:=false;
    end;
  finally
    Stm.Free; DisplayHint('');
  end;
end;

procedure TMainForm.FilePropertiesActionExecute(Sender: TObject);
var psp: TPropSheetPage; TitleBuf,Cols,CapBuf: array[0..MAX_PATH] of char;
    punk: IUnknown; pspse: IShellPropSheetExt; pdmfps: IDMFilePropSheet;
    I: integer; S: string; Connected: boolean;
begin
  // check disc file presence
  if not FileExists(ActiveDataForm.Container.FileName) then
  begin
    MessageDlg(Format(strPropPageNoFile,[ActiveDataForm.Container.FileName]),
    mtError,[mbCancel],0); Exit;
  end;
  // init parameters
  StrPCopy(FileName,ActiveDataForm.Container.FileName);    // global FileName!
  StrPCopy(CapBuf,Format(strPropPageCaption,[ExtractFileName(FileName)]));
  S:=''; for I:=1 to MaxCol{!?} do S:=S+ActiveDataForm.Labels[I]+' '+CRLF;
  StrPCopy(Cols,S); StrPCopy(TitleBuf,strPropPageTitle);
  if Assigned(DMApplication)              // try to read automation controller
  then DMApplication.Command(strExpSettings);
  MonitorForm.GetExpSettings;                 // try to read experiment server
  Connected:=true;//Assigned(DMApplication) or MonitorForm.Connected; !!!!!!!!
  // init header
  psh.dwSize:=SizeOf(psh);
  psh.dwFlags:=0;
  psh.hwndParent:=Handle;                                    // form's handle!
  psh.hInstance:=hInstance;
  psh.pszIcon:=nil;
  psh.pszCaption:=CapBuf;
  psh.nStartPage:=1;                 // show description page, as in MSOffice!
  psh.nPages:=0;
  psh.ppsp:=@hPageA;
  psh.pfnCallback:=nil;
  // init 1st page psp
  psp.dwSize:=SizeOf(psp);
  psp.dwFlags:=PSP_USETITLE;
  psp.hInstance:=hInstance;
  psp.pszTemplate:=MAKEINTRESOURCE(GeneralDlg);
  psp.pszIcon:=nil;
  psp.pfnDlgProc:=@DataPropertySheetDlgProc;
  psp.pszTitle:=TitleBuf;
  psp.lParam:=0;
  psp.pfnCallback:=nil;
  // add 1st page
  hPageA[1]:=CreatePropertySheetPage(psp); Inc(psh.nPages);
  // get interfaces
  punk:=CreateComObject({StringToGUID(}Class_DataPropertySheet{)});
  // Initialize object
  pdmfps:=punk as IDMFilePropSheet;
  if not AppPropsForm.ClearDescriptionCheckBox.Checked
  then pdmfps.Initialize(@ExpSettingsBuf,
     SizeOf(ExpSettingsBuf),Connected,FileName,Cols,ExpSettingsCB)
  else pdmfps.Initialize(nil,0,Connected,FileName,Cols,ExpSettingsCB);
  pspse:=punk as IShellPropSheetExt;                // implicit QueryInterface
  // add other pages
  pspse.AddPages(AddPages, 0);
  // fire dialog!
  PropertySheet(psh);
end;

procedure TMainForm.DataFormActionUpdate(Sender: TObject);  // shared handler!
begin (Sender as TAction).Enabled:=Assigned(ActiveMDIChild); end;

procedure TMainForm.PageSetupActionExecute(Sender: TObject);
begin PageSetupForm.Execute; end;

procedure TMainForm.PrintActionExecute(Sender: TObject);
var Org: TPoint; S: string;
begin
  S:=Format(strPrinting,[ActiveMDIChild.Caption]);
  StatusImageList.Tag:=7; DisplayHint(S); Printer.Title:=S;
  try
    Printer.BeginDoc;
    SetViewPortOrgEx(Printer.Handle,PageSetupForm.Xo,PageSetupForm.Yo,@Org);
    (ActiveMDIChild as TDataForm).Plot.Print(
      PageSetupForm.PlotWidth,PageSetupForm.PlotHeight);
    SetViewPortOrgEx(Printer.Handle,Org.X,Org.Y,nil);
    Printer.EndDoc;
  finally
    StatusImageList.Tag:=0; DisplayHint('');
  end;
end;

procedure TMainForm.PrintActionUpdate(Sender: TObject);
begin
  PrintAction.Enabled:=Assigned(ActiveDataForm) and
  (GetActiveCtrlType=actPlot) and (Printer.Printers.Count>0);
end;

//////////// EDIT

procedure TMainForm.InsDelActionExecute(Sender: TObject);
begin              // note: this handler called from DeleteAction.Execute()!!!
  ActiveDataForm.SaveUndoInfo(Sender);
  StatusImageList.Tag:=8; DisplayHint(strWorking);
  try
    if Sender=InsertAction then
    ActiveDataForm.Worksheet.PasteFromClipboard(true, not Insert);
    if Sender=DeleteAction then
    ActiveDataForm.Worksheet.Delete;
  finally
    StatusImageList.Tag:=0; DisplayHint('');
  end;
end;

procedure TMainForm.WorksheetActionUpdate(Sender: TObject); // shared handler!
begin                     // used to enable operations specific for worksheets
  (Sender as TAction).Enabled:=(GetActiveCtrlType=actWks) and
  (ActiveDataForm.Container.Items.Count>0);
end;

procedure TMainForm.PlotToolActionExecute(Sender: TObject); // shared handler!
var M: TPlotMouseMode; I: integer;
begin
  M:=pmNone;                                                  // avoid warning
  if Sender=AutoZoomAction then M:=pmAutoZoom;
  if Sender=TranslationAction then M:=pmTranslate;
  if Sender=ZoomAction then M:=pmZoom;
  if Sender=UnZoomAction then M:=pmUnZoom;
  if Sender=DeletePointAction then M:=pmPointDelete;
  if Sender=MovePointAction then M:=pmPointEdit;
  if Sender=RulerAction then M:=pmRuler;
  if Sender=PlotSelectAction then M:=pmSelect;
  if (Sender=ScrollerAction) or (Sender=PlotCalculatorAction)
  then M:=pmPointClick;   // we use Plot.Tag to distinguish between above two!
  I:=0; if Sender=ScrollerAction then I:=1;
  if Sender=PlotCalculatorAction then I:=2;
  with ActiveDataForm.Plot do
  begin
    if (MouseMode<>M) or ((M=pmPointClick) and (Tag<>I)) then MouseMode:=M
    else MouseMode:=pmNone;                                     // switch mode
    if MouseMode=pmPointClick then Tag:=I else Tag:=0;
    case MouseMode of                                        // correct cursor
      pmZoom, pmUnZoom, pmAutoZoom: Cursor:=crCross;
      pmPointDelete: Cursor:=crTarget;
      pmPointEdit: Cursor:=crEdit;
      pmRuler: Cursor:=crHandPoint;
      pmSelect: Cursor:=crSelect;
      pmPointClick: Cursor:=crFrame;
      pmTranslate: Cursor:=crArrow;
    else Cursor:=crArrow;
    end;
    ActiveDataForm.Plot.SelectionVisible:=
    (MouseMode=pmSelect) or (MouseMode=pmTranslate);
  end;
end;

procedure TMainForm.PlotToolActionUpdate(Sender: TObject);  // shared handler!
  procedure DoIt(A: TAction; M: TPlotMouseMode);
  begin A.Checked:=M=ActiveDataForm.Plot.MouseMode; end;
begin
  if Sender<>PlotCalculatorAction then
     (Sender as TAction).Enabled:=GetActiveCtrlType=actPlot
  else PlotCalculatorAction.Enabled:=(GetActiveCtrlType=actPlot) and
     (CalculatorForm.ExpressionComboBox.Text<>'');
  //(Sender as TAction).Checked:=false;  <= this cause problems !!!
  if not Assigned(ActiveDataForm) then Exit;   // cannot analyze window state!
  DoIt(ZoomAction,pmZoom);
  DoIt(UnZoomAction,pmUnZoom);
  DoIt(DeletePointAction,pmPointDelete);
  DoIt(MovePointAction,pmPointEdit);
  DoIt(RulerAction,pmRuler);
  DoIt(PlotSelectAction,pmSelect);
  AutoZoomAction.Checked:=ActiveDataForm.Plot.MouseMode=pmAutoZoom;
  TranslationAction.Checked:=ActiveDataForm.Plot.MouseMode=pmTranslate;
  // next two correspond with the same Option => processing differs!
  ScrollerAction.Checked:=(pmPointClick=ActiveDataForm.Plot.MouseMode)
  and (ActiveDataForm.Plot.Tag=1);
  PlotCalculatorAction.Checked:=(pmPointClick=ActiveDataForm.Plot.MouseMode)
  and (ActiveDataForm.Plot.Tag=2);
end;

procedure TMainForm.DeletePoints;
begin
  with ActiveDataForm do if not Plot.ThisSerie.Empty then
  (Plot.ThisSerie.Container.Owner as
  TDataForm).SaveUndoInfo(DeleteAction);
  StatusImageList.Tag:=8; DisplayHint(strWorking);
  try
    ActiveDataForm.Plot.Delete;
  finally
    StatusImageList.Tag:=0; DisplayHint('');
  end;
end;

procedure TMainForm.DeleteActionExecute(Sender: TObject);
begin
  case GetActiveCtrlType of
    actNotes: NotesForm.Memo.ClearSelection;
    actScript: ScriptingForm.Memo.ClearSelection;
    actBrowser: BrowserForm.WebBrowser.ExecWB(OLECMDID_DELETE,0);
    actWks: InsDelActionExecute(DeleteAction);
    actPlot: DeletePoints;
    actSerieMgr: SerieMgrForm.ClearAction.Execute;
  end;
end;

procedure TMainForm.CopyDeleteCutActionUpdate(Sender: TObject);     // shared!
var C: TOleEnum;
begin
  case GetActiveCtrlType of
    actNotes: (Sender as TAction).Enabled:=NotesForm.Memo.SelLength>0;
    actScript: (Sender as TAction).Enabled:=ScriptingForm.Memo.SelLength>0;
    actBrowser: begin
      C:=0;
      if Sender=CopyAction then C:=OLECMDID_COPY;
      if Sender=DeleteAction then C:=OLECMDID_DELETE;
      if Sender=CutAction then C:=OLECMDID_CUT;
      if C<>0 then (Sender as TAction).Enabled:=
         (BrowserForm.WebBrowser.QueryStatusWB(C) and OLECMDF_ENABLED)<>0
      else (Sender as TAction).Enabled:=false;
    end;
    actWks: (Sender as TAction).Enabled:=
      ActiveDataForm.Container.Items.Count>0;
    actPlot: (Sender as TAction).Enabled:=(Sender=CopyAction) or
      (not ActiveDataForm.Plot.ThisSerie.Empty);
    actSerieMgr: SerieMgrForm.CopyClearCutRenameActionUpdate(Sender);
  else (Sender as TAction).Enabled:=false;
  end;
end;

procedure TMainForm.CopyWorksheet;
var S: TSerie;
begin
  StatusImageList.Tag:=8; DisplayHint(strWorking); S:=TSerie.Create(nil);
  try
    ActiveDataForm.Worksheet.CopyToClipBoard(
    AppPropsForm.UseTabsCheckBox.Checked);
    //    S.Assign(ActiveDataForm.Plot.ThisSerie);
    S.Container:=ActiveDataForm.Container;
    S.XColumn:=ActiveDataForm.XColumn;
    S.YColumn:=ActiveDataForm.YColumn;
    with ActiveDataForm.Worksheet do
    begin
      S.FirstLine:=Selection.Top-FixedRows;
      S.LastLine:=Selection.Bottom-FixedRows;
    end;
    if AppPropsForm.AutoNameSerieCheckBox.Checked
    then S.Text:=ActiveDataForm.Labels[ActiveDataForm.YColumn] else
    S.Text:=GetContainerName(ActiveDataForm.Container,true);
    S.CopyToClipboard(false);
  finally
    S.Free; StatusImageList.Tag:=0; DisplayHint('');
  end;
end;

procedure TMainForm.PlotActionUpdate(Sender: TObject);      // shared handler!
begin (Sender as TAction).Enabled:=GetActiveCtrlType=actPlot; end;

procedure TMainForm.CopyPoints(AllData: boolean);
var Mode: TPlotCopyMode;
begin
  StatusImageList.Tag:=8; DisplayHint(strWorking);
  try
    if AllData then Mode:=pcmItems else Mode:=pcmPoints;
    ActiveDataForm.Plot.CopyToClipBoard(Mode,
    AppPropsForm.UseTabsCheckBox.Checked);
  finally
    StatusImageList.Tag:=0; DisplayHint('');
  end;
end;

procedure TMainForm.CopyActionExecute(Sender: TObject);
begin
  case GetActiveCtrlType of
    actNotes: NotesForm.Memo.CopyToClipboard;
    actScript: ScriptingForm.Memo.CopyToClipboard;
    actBrowser: BrowserForm.WebBrowser.ExecWB(OLECMDID_COPY,0);
    actWks: CopyWorksheet;
    actPlot: if not ActiveDataForm.Plot.ThisSerie.Empty then
             case Select(strCopyPlotQueryTitle,
                         strCopyPlotQuery1+CRLF+strCopyPlotQuery2) of
               0: CopyPoints(false);
               1: CopyPoints(true);
               2: ActiveDataForm.Plot.CopyToClipboard(pcmPage,false);
               3: SerieMgrForm.CopyAction.Execute;
             end else
             case Select(strCopyPlotQueryTitle,strCopyPlotQuery2) of
               0: ActiveDataForm.Plot.CopyToClipboard(pcmPage,false);
               1: SerieMgrForm.CopyAction.Execute;
             end;
    actSerieMgr: SerieMgrForm.CopyAction.Execute;
  end;
end;

procedure TMainForm.PasteActionExecute(Sender: TObject);
begin
  case GetActiveCtrlType of
    actNotes: NotesForm.Memo.PasteFromClipboard;
    actScript: ScriptingForm.Memo.PasteFromClipboard;
    actBrowser: BrowserForm.WebBrowser.ExecWB(OLECMDID_PASTE,0);
    actWks: begin
      ActiveDataForm.SaveUndoInfo(Sender);
      StatusImageList.Tag:=8; DisplayHint(strWorking);
      try
        ActiveDataForm.Worksheet.PasteFromClipboard(false, not Insert);
      finally
        StatusImageList.Tag:=0; DisplayHint('');
      end;{try}
    end;{begin}
    actSerieMgr,actPlot: SerieMgrForm.PasteAction.Execute;
  end;{case}
end;

procedure TMainForm.PasteActionUpdate(Sender: TObject);
begin
  case GetActiveCtrlType of
    actNotes,actScript,actWks: PasteAction.Enabled:=
      Clipboard.HasFormat(CF_TEXT);
    actBrowser: PasteAction.Enabled:=(BrowserForm.WebBrowser.QueryStatusWB(
      OLECMDID_PASTE) and OLECMDF_ENABLED)<>0;
    actSerieMgr,actPlot: SerieMgrForm.PasteActionUpdate(PasteAction);
  else PasteAction.Enabled:=false;
  end;
end;

procedure TMainForm.InsertActionUpdate(Sender: TObject);
begin
  InsertAction.Enabled:=Clipboard.HasFormat(CF_TEXT)
  and (GetActiveCtrlType=actWks);
end;

procedure TMainForm.CutActionExecute(Sender: TObject);
begin
  case GetActiveCtrlType of
    actNotes: NotesForm.Memo.CutToClipboard;
    actScript: ScriptingForm.Memo.CutToClipboard;
    actBrowser: BrowserForm.WebBrowser.ExecWB(OLECMDID_CUT,0);
    actWks: begin CopyWorksheet; InsDelActionExecute(DeleteAction); end;
    actPlot: begin CopyPoints(true); DeletePoints; end;
    actSerieMgr: SerieMgrForm.CutAction.Execute;
  end;
end;

procedure TMainForm.SelectAllActionExecute(Sender: TObject);
  procedure SelectPlot;
  begin
    with ActiveDataForm.Plot do
    begin
      SelectionLeft:=XAxis.Min; SelectionRight:=XAxis.Max;
      SelectionTop:=YAxis.Max; SelectionBottom:=YAxis.Min;
      SelectionVisible:=true;
    end;
  end;
begin
  case GetActiveCtrlType of
    actNotes: NotesForm.Memo.SelectAll;
    actScript: ScriptingForm.Memo.SelectAll;
    actBrowser: BrowserForm.WebBrowser.ExecWB(OLECMDID_SELECTALL,0);
    actWks: ActiveDataForm.Worksheet.SelectAll;
    actPlot: SelectPlot;
  end; // main case
end;

procedure TMainForm.SelectAllActionUpdate(Sender: TObject);
begin SelectAllAction.Enabled:=GetActiveCtrlType in [actWks..actBrowser]; end;

procedure TMainForm.SortActionExecute(Sender: TObject);
var Dir: boolean; Fm: TDataForm; X,B,E: integer;
begin
  Fm:=ActiveDataForm;
  if GetActiveCtrlType=actPlot then
  begin
    B:=Fm.Plot.ThisSerie.FirstLine;
    E:=Fm.Plot.ThisSerie.LastLine;
    X:=Fm.Plot.ThisSerie.XColumn;
    Fm:=Fm.Plot.ThisSerie.Container.Owner as TDataForm;
    Fm.XColumn:=X;                      // need to change - Sort uses XColumn!
  end else
  begin
    E:=Fm.Worksheet.Selection.Bottom;
    if E=Fm.Worksheet.RowCount-1 then E:=Fm.Worksheet.RowCount-2;
    E:=E-Fm.Worksheet.FixedRows;
    B:=Fm.Worksheet.Selection.Top-Fm.Worksheet.FixedRows;
  end;
  // WARNING: dialog box changes GetActiveCtrlType !!!
  case Select(strSortTitle,strSortOrder) of 
    0: Dir:=true;
    1: Dir:=false;
  else Exit;
  end;
  Fm.SaveUndoInfo(SortAction);
  StatusImageList.Tag:=8; DisplayHint(strWorking);
  try
    Fm.Container.Sort(B,E,Dir);
  finally
    StatusImageList.Tag:=0; DisplayHint('');
  end;
end;

procedure TMainForm.ProcessActionUpdate(Sender: TObject);   // shared handler!
begin
  (Sender as TAction).Enabled:=(((GetActiveCtrlType=actWks) and
  (ActiveDataForm.Worksheet.Selection.Bottom-
  ActiveDataForm.Worksheet.Selection.Top>=(Sender as TAction).Tag) and
  (ActiveDataForm.Container.Items.Count>0)) or
  ((GetActiveCtrlType=actPlot) and not ActiveDataForm.Plot.ThisSerie.Empty));
end;

procedure TMainForm.SwapActionExecute(Sender: TObject);
var S: string;
begin
  with TSwapColumns.Create(ActiveDataForm,SwapAction) do
  try
    Execute;
  finally
    Free;
  end;
  if MessageDlg(strSwapLabels,mtConfirmation,[mbYes,mbNo],0)=mrYes then
  with ActiveDataForm do begin
    S:=Labels[XColumn]; Labels[XColumn]:=Labels[YColumn]; Labels[YColumn]:=S;
  end;
end;

procedure TMainForm.InplaceEditorActionExecute(Sender: TObject);
begin
  with ActiveDataForm.Worksheet do
  begin
    if goEditing in Options
    then Options:=Options-[goEditing] else Options:=Options+[goEditing];
    if (goEditing in Options) then Cursor:=crIBeam else Cursor:=crArrow;
  end;
end;

procedure TMainForm.InplaceEditorActionUpdate(Sender: TObject);
begin
  InplaceEditorAction.Checked:=Assigned(ActiveDataForm) and
  (goEditing in ActiveDataForm.Worksheet.Options);
end;

procedure TMainForm.UndoActionExecute(Sender: TObject);
begin
  case GetActiveCtrlType of
    actNotes,actScript: (Screen.ActiveControl as TMemo).Undo;
    actWks,actPlot: ActiveDataForm.Undo;
    actBrowser: BrowserForm.WebBrowser.ExecWB(OLECMDID_UNDO,0);
  end;
end;

procedure TMainForm.UndoActionUpdate(Sender: TObject);
begin
  case GetActiveCtrlType of
    actNotes,actScript: UndoAction.Enabled:=
    (Screen.ActiveControl as TMemo).CanUndo;
    actWks,actPlot: UndoAction.Enabled:=ActiveDataForm.CanUndo;
    actBrowser: UndoAction.Enabled:=(BrowserForm.WebBrowser.QueryStatusWB(
      OLECMDID_UNDO) and OLECMDF_ENABLED)<>0;
  else UndoAction.Enabled:=false;
  end;
end;

//////////// PROCESS

procedure TMainForm.DifferentiationActionExecute(Sender: TObject);
begin
  case Select(strDiffMethod,strDiffMethods) of
    0: with TDifferentiation.Create(ActiveDataForm,DifferentiationAction) do
       try
         Execute;
       finally
         Free;
       end;
    1: with TSmooth.Create(ActiveDataForm,DifferentiationAction) do
       try
         HW:=3; if not InputInteger(strHalfWidth, 3, 100, 1, HW) then Exit;
         Derive:=true; Execute;
       finally
         Free;
       end;
  end;{case}
end;

procedure TMainForm.IntegrationActionExecute(Sender: TObject);
begin
  with TIntegration.Create(ActiveDataForm,IntegrationAction) do
  try
    Execute;
  finally
    Free;
  end;
end;

procedure TMainForm.SmoothActionExecute(Sender: TObject);
begin
  with TSmooth.Create(ActiveDataForm,SmoothAction) do
  try
    HW:=3; if not InputInteger(strHalfWidth, 3, 100, 1, HW) then Exit;
    Derive:=false; Execute;
  finally
    Free;
  end;
end;

procedure TMainForm.InterpolationActionExecute(Sender: TObject);
var S: string;
begin
  S:='1.0'; if not InputQuery(strEnter,strXStep,S) then Exit;
  with TInterpolation.Create(ActiveDataForm,InterpolationAction) do
  try
    Step:=StrToFloat(S);
    if Step=0 then
    begin MessageDlg(strZeroStep,mtError,[mbCancel],0); Exit; end;    // check
    Execute;
  finally
    Free;
  end;
end;

procedure TMainForm.CalculationActionExecute(Sender: TObject);
begin
  with TParse.Create(ActiveDataForm,CalculationAction) do
  try
    if not InputString('', CalculatorForm.ExpressionComboBox.Items,
    Macro, true) then Exit;
    Execute;
  finally
    Free;
  end;
end;

procedure TMainForm.CopyFunctionActionExecute(Sender: TObject);
begin CopyFunction; end;
(*   OLD version; NOTE! action OnUpdate handler was WorksheetActionUpdate!
var
  srcB,srcE,srcX,srcY,dstB,dstE,dstX,{dstY,}srcPos,dstPos,I: integer;
  D1,D2,D3: TRealData; X1,X2,X3,Y1,Y2: TReal; dstForm: TDataForm;
begin
  srcX:=ActiveDataForm.XColumn; srcY:=ActiveDataForm.YColumn;   // source data
  with ActiveDataForm.Worksheet do
  begin
    srcB:=Selection.Top-FixedRows; srcE:=Selection.Bottom-FixedRows;
    if Selection.Bottom=RowCount-1 then Dec(srcE);        // correct selection
    if srcE-srcB<2 then Exit;                             // insufficient data
  end;
  if MessageDlg(strCopyFunction,mtWarning,[mbOk,mbCancel],0)<>mrOk then Exit;
  InputStringForm:=TInputStringForm.Create(Application);
  try
    InputStringForm.Label1.Caption:=strSelectWorksheet;
    InputStringForm.ComboBox.Style:=csDropDownList;
    for I:=0 to MDIChildCount-1 do
      InputStringForm.ComboBox.Items.Add(GetContainerName((MDIChildren[I] as
        TDataForm).Container, false));
    if (InputStringForm.ShowModal<>mrOk) or                       // cancelled
       (InputStringForm.ComboBox.ItemIndex<0) then Exit;    // or not selected
    dstForm:=MDIChildren[InputStringForm.ComboBox.ItemIndex] as TDataForm;
  finally
    InputStringForm.Free;
  end;
  dstX:=dstForm.XColumn; {dstY:=dstForm.YColumn;}          // destination data
  with dstForm.Worksheet do
  begin
    dstB:=Selection.Top-FixedRows; dstE:=Selection.Bottom-FixedRows;
    if Selection.Bottom=RowCount-1 then Dec(dstE); if dstE-dstB<2 then Exit;
  end;
  try // start processing...
    dstForm.SaveUndoInfo(CopyFunctionAction);
    StatusImageList.Tag:=8; DisplayHint(strWorking); dstPos:=dstB;
    for srcPos:=srcB to srcE-1{!} do
    begin
      ActiveDataForm.Container.ShowProgress(Round(
        (srcPos-srcB)/(srcE-srcB)*100));
      D1:=ActiveDataForm.Container.Items[srcPos];  {fix source interval X1-X2}
      D2:=ActiveDataForm.Container.Items[srcPos+1];
      X1:=D1.RData[srcX]; X2:=D2.RData[srcX];
      Y1:=D1.RData[srcY]; Y2:=D2.RData[srcY];
      repeat
        D3:=dstForm.Container.Items[dstPos]; X3:=D3.RData[dstX]; Inc(dstPos);
        if (X3>=X1) and (X3<=X2) then        {if destpos.x within interval...}
        D3.InsItem(LineInterpolate(X1,X2,Y1,Y2,X3));
      until (X3>X2) or (dstPos>dstE);
      if X3>=X2 then Dec(dstPos);                            {correct destpos}
      if dstPos>dstE then Break;             {stop FOR cycle on dest.endline!}
    end;
  finally
    StatusImageList.Tag:=0; DisplayHint(''); dstForm.Container.Modified:=true;
  end;
end; *)

procedure TMainForm.TransformationActionExecute(Sender: TObject);
begin Transform; end;

procedure TMainForm.SerieActionUpdate(Sender: TObject);     // shared handler!
begin
 (Sender as TAction).Enabled:=(GetActiveCtrlType=actPlot) and
 Assigned(ActiveDataForm.Plot.ThisSerie) and
 (not (ActiveDataForm.Plot.ThisSerie.Empty));
end;

procedure TMainForm.BaseLineActionExecute(Sender: TObject);
begin
  if not Assigned(BaseLineForm)
  then BaseLineForm:=TBaseLineForm.Create(Application);
  BaseLineForm.HelpBtn.OnClick:=HelpButtonClick;
  if BaseLineForm.Execute(ActiveDataForm.Plot) then
  begin
    ActiveDataForm.SaveUndoInfo(BaseLineAction);
    BaseLineForm.CopyData;
  end;
end;

procedure TMainForm.DigitizeActionExecute(Sender: TObject);
begin
  if not Assigned(DigitizerForm) // create form only if needed (and keep data)
  then DigitizerForm:=TDigitizerForm.Create(Application);
  DigitizerForm.HelpBtn.OnClick:=HelpButtonClick;
  if DigitizerForm.Execute then
  begin
    ActiveDataForm.SaveUndoInfo(DigitizeAction);
    DigitizerForm.CopyData(ActiveDataForm.Container);
  end;
end;

procedure TMainForm.LinearFittingActionExecute(Sender: TObject);
begin
  if not Assigned(LinearFitForm)
  then LinearFitForm:=TLinearFitForm.Create(Application);
  LinearFitForm.HelpBtn.OnClick:=HelpButtonClick;
  with LinearFitForm do
  begin
    PresetControls;
    Plot.Series[1].LastLine:=NLSFOptionsForm.NumPointsSpinEdit.Value;
    CleanFit;
    doExec;
  end;
  UpdateSerieList;
end;

procedure TMainForm.LMFittingActionExecute(Sender: TObject);
begin
  if not Assigned(NLSFForm)
  then NLSFForm:=TNLSFForm.Create(Application);
  NLSFForm.HelpBtn.OnClick:=HelpButtonClick;
  with NLSFForm do
  begin
    PresetControls;
    CleanFit; FitBitBtn.Enabled:=false; UpdateBitBtn.Enabled:=false;
    Plot.Series[1].LastLine:=NLSFOptionsForm.NumPointsSpinEdit.Value;
    NLSFForm.FunctionBitBtn.Enabled:=true; doExec;
  end;
  UpdateSerieList;
end;

{Y - lorentzian; Y=A*B/[(X-Xo)^2+B^2] + D; Params: A=A1; Xo=A1; B=A3; D=A4.  }
function LorFu(X: TReal; A : FitArray; NParam: Integer): TReal;
begin                          {Return LorFu evaluated at X with parameters A}
  Result:=A[1]*A[3]/(sqr(X-A[2])+sqr(A[3])) + A[4];
end;

procedure LorFuDeriv(X: TReal; A,SigA: FitArray; Nparam: Integer;
  var Deriv: FitArray);
var pA,pB,pXo: Real;
begin      {Evaluate partial derivatives of LorFu w.r.t. parameters A at X[i]}
  pA:=A[1]; pXo:=A[2]; pB:=A[3];
  Deriv[1]:=pB/(sqr(X-pXo)+sqr(pB));
  Deriv[2]:=-2*(pXo-X)*pA*pB/sqr(sqr(X-pXo)+sqr(pB));
  Deriv[3]:=pA* (sqr(X-pXo)-sqr(pB)) /sqr(sqr(X-pXo)+sqr(pB));
  Deriv[4]:=1.0;
end;

procedure TMainForm.LorentzFittingActionExecute(Sender: TObject);
var I,N: integer; YMax,XMax,XX1,XX2,XX,YY,YAver: TReal;
begin
  if not Assigned(NLSFForm)               // create fitter if still not exists
  then NLSFForm:=TNLSFForm.Create(Application);
  NLSFForm.HelpBtn.OnClick:=HelpButtonClick;
  with NLSFForm do       // initialize controls like in FunctionBitBtn.Click()
  begin
    Plot.Series[1].LastLine:=NLSFOptionsForm.NumPointsSpinEdit.Value;
    PresetControls; CleanFit;
    FunctionBitBtn.Enabled:=false; FitBitBtn.Enabled:=true;
    UpdateBitBtn.Enabled:=true;
    Func:=LorFu; Deriv:=LorFuDeriv; NParam:=4;
    Expression:='p1*p3/((cx-p2)^2+p3^2)+p4';
    ResultPanel.Visible:=true;
    Plot.YAxis.Title:=Format(strLMFitAxisTitle,[Expression]);
    for I:=1 to NParam do with ParametersListView.Items.Add do
    begin SubItems.Add('p'+IntToStr(I)); SubItems.Add(' '); end;
  end;
  Screen.Cursor:=crHourGlass; StatusImageList.Tag:=8; DisplayHint(strWorking);
  try                                     // find initial values of parameters
    YAver:=0; N:=0;                         // 1st scan: find D - just as <Y>!
    with NLSFForm.Plot.Series[0] do for I:=FirstLine to LastLine do
    begin
      NLSFForm.Plot.GetDataPoint(TData(Container.Items[I]),
      XColumn,YColumn,XExpression,YExpression,XX,YY);
      if ((XX>=NLSFForm.Plot.SelectionLeft) and
         (XX<=NLSFForm.Plot.SelectionRight) and
         (YY>=NLSFForm.Plot.SelectionBottom) and
         (YY<=NLSFForm.Plot.SelectionTop)) or
         (not NLSFForm.Plot.SelectionVisible) then  // process selection only!
      begin YAver:=YAver+YY; Inc(N); end;
    end;
    if N>0 then YAver:=YAver/N;
    NLSFForm.ParametersListView.Items[3].Caption:=
    FloatToStrF(YAver,ffGeneral,7,4);
    YMax:=0; XMax:=0;                  // 2nd scan: find Xo as X|(Max Y-YAver)
    with NLSFForm.Plot.Series[0] do for I:=FirstLine to LastLine do
    begin
      NLSFForm.Plot.GetDataPoint(TData(Container.Items[I]),
      XColumn,YColumn,XExpression,YExpression,XX,YY);
      if ((XX>=NLSFForm.Plot.SelectionLeft) and
         (XX<=NLSFForm.Plot.SelectionRight) and
         (YY>=NLSFForm.Plot.SelectionBottom) and
         (YY<=NLSFForm.Plot.SelectionTop)) or
         (not NLSFForm.Plot.SelectionVisible) then
      if Abs(YY-YAver)>=Abs(YMax) then begin YMax:=YY-YAver; XMax:=XX; end;
    end;
    NLSFForm.ParametersListView.Items[1].Caption:=
      FloatToStrF(XMax,ffGeneral,7,4);
    XX1:=0; XX2:=0;     // 3d scan: find halfwidth (B) as X|( Max(Y-Yaver)/2 )
    with NLSFForm.Plot.Series[0] do for I:=FirstLine to LastLine do
    begin
      NLSFForm.Plot.GetDataPoint(TData(Container.Items[I]),
      XColumn,YColumn,XExpression,YExpression,XX,YY);
      if ((XX>=NLSFForm.Plot.SelectionLeft) and
         (XX<=NLSFForm.Plot.SelectionRight) and
         (YY>=NLSFForm.Plot.SelectionBottom) and
         (YY<=NLSFForm.Plot.SelectionTop)) or
         (not NLSFForm.Plot.SelectionVisible) then
      begin
        if (Abs(YY-YAver)>=Abs(YMax)/2) and (XX1=0) then XX1:=XX;
        if (Abs(YY-YAver)<=Abs(YMax)/2) and (XX2=0) and (XX1<>0)
        and (Abs(XX-XX1)>Abs(XMax-XX1)) then XX2:=XX;
      end;
    end;
    NLSFForm.ParametersListView.Items[2].Caption:=                     // B!!!
      FloatToStrF(Abs(XX2-XX1)/2,ffGeneral,7,4);
    NLSFForm.ParametersListView.Items[0].Caption:=                 // A=YMax*B
      FloatToStrF(Abs(XX2-XX1)*YMax/2,ffGeneral,7,4);
  finally
    Screen.Cursor:=crDefault; StatusImageList.Tag:=0; DisplayHint('');
  end;
  NLSFForm.doExec;                                           // execute fitter
  UpdateSerieList;
end;

//////////// VIEW

procedure TMainForm.ViewStateActionExecute(Sender: TObject);
begin
  if Sender=WorksheetAction then ActiveDataForm.ViewState:=dfvWorksheet;
  if Sender=PlotAction then ActiveDataForm.ViewState:=dfvPlot;
  if Sender=BothAction then ActiveDataForm.ViewState:=dfvBoth;
end;

procedure TMainForm.ViewStateActionUpdate(Sender: TObject);
begin
  WorksheetAction.Enabled:=Assigned(ActiveDataForm);
  PlotAction.Enabled:=Assigned(ActiveDataForm);
  BothAction.Enabled:=Assigned(ActiveDataForm);
  WorksheetAction.Checked:=Assigned(ActiveDataForm)
    and (ActiveDataForm.ViewState=dfvWorksheet);
  PlotAction.Checked:=Assigned(ActiveDataForm)
    and (ActiveDataForm.ViewState=dfvPlot);
  BothAction.Checked:=Assigned(ActiveDataForm)
    and (ActiveDataForm.ViewState=dfvBoth);
end;

procedure TMainForm.PlotLinesActionExecute(Sender: TObject);
var FM: TDataForm;
begin
  if Assigned(ActiveDataForm.Plot.ThisSerie.Container) then
  FM:=ActiveDataForm.Plot.ThisSerie.Container.Owner as TDataForm else FM:=nil;
  if (not Assigned(FM)) or (FM.Worksheet.Selection.Bottom-
  FM.Worksheet.Selection.Top<1) then SeriePropertiesAction.Execute else
  begin
    with ActiveDataForm.Plot.ThisSerie do if IsFunction
    then begin IsFunction:=false; YExpression:=''; end;
    ActiveDataForm.Plot.ThisSerie.XColumn:=FM.XColumn;
    ActiveDataForm.Plot.ThisSerie.YColumn:=FM.YColumn;
    if AppPropsForm.AutoNameSerieCheckBox.Checked
    then ActiveDataForm.Plot.ThisSerie.Text:=FM.Labels[FM.YColumn];
    with FM.Worksheet do
    begin
      ActiveDataForm.Plot.ThisSerie.FirstLine:=Selection.Top-FixedRows;
      ActiveDataForm.Plot.ThisSerie.LastLine:=Selection.Bottom-FixedRows;
    end;
    if FM.Recording then
    with ActiveDataForm do IsRecordingSerie[Plot.SerieIndex]:=true;
    SerieComboBox.Refresh;                 // serie name and state may change!
    UpdateSerieList;
  end;
end;

procedure TMainForm.SelectLinesActionExecute(Sender: TObject);
var R: TGridRect; I: integer;
begin
  for I:=0 to MainForm.MDIChildCount-1 do                 // search for window
  if (MDIChildren[I] as TDataForm).Container=
  ActiveDataForm.Plot.ThisSerie.Container then
  with (MDIChildren[I] as TDataForm).Worksheet do
  begin
    R.Top:=ActiveDataForm.Plot.ThisSerie.FirstLine+FixedRows;
    R.Bottom:=ActiveDataForm.Plot.ThisSerie.LastLine+FixedRows;
    R.Left:=FixedCols; R.Right:=ColCount; Selection:=R;
    (MDIChildren[I] as TDataForm).XColumn:=
    ActiveDataForm.Plot.ThisSerie.XColumn;
    (MDIChildren[I] as TDataForm).YColumn:=
    ActiveDataForm.Plot.ThisSerie.YColumn;
    with MDIChildren[I] do                  // activate and show if minimized!
    begin Show; if WindowState=wsMinimized then WindowState:=wsNormal; end;
    Break;
  end;
end;

procedure TMainForm.ClearSerieSelectLinesActionUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled:=((GetActiveCtrlType=actPlot) or
  (GetActiveCtrlType=actSerieMgr) or (Screen.ActiveForm=SerieMgrForm))
  and Assigned(ActiveDataForm) and  Assigned(ActiveDataForm.Plot.ThisSerie)
  and (not (ActiveDataForm.Plot.ThisSerie.Empty));
end;

procedure TMainForm.ClearSerieActionExecute(Sender: TObject);
begin
  with ActiveDataForm.Plot.ThisSerie do
  begin ClearBlock; IsFunction:=false; end;
  SerieComboBox.Refresh; UpdateSerieList;
end;

procedure TMainForm.GotoLineActionExecute(Sender: TObject);
var where: integer;
begin
  where:=0; with ActiveDataForm do
  if (Container.Items.Count>1) and
      InputInteger(strGoto, 0, Container.Items.Count-1, 1, where)
  then Scroll(where);
end;

procedure TMainForm.WorksheetCalculatorActionExecute(Sender: TObject);
var R: TRealArray; X,Y,N: integer;
begin
  with ActiveDataForm.Worksheet do
  N:=TRealData(Container.Items[Row-FixedRows]).GetRData(R);
  X:=ActiveDataForm.XColumn; if X>N then X:=N; // check for bad values of R[X]
  Y:=ActiveDataForm.YColumn; if Y>N then Y:=N;                     // and R[Y]
  Evaluate(R,N,R[X],R[Y]);
end;

procedure TMainForm.WorksheetCalculatorActionUpdate(Sender: TObject);
begin
  if Assigned(ActiveDataForm) then with ActiveDataForm.Worksheet do
  WorksheetCalculatorAction.Enabled:=(Selection.Top=Selection.Bottom)
  and (Row<Container.Items.Count+FixedRows)
  and (CalculatorForm.ExpressionComboBox.Text<>'')
  else WorksheetCalculatorAction.Enabled:=false;
end;

procedure TMainForm.PlotColorActionExecute(Sender: TObject);
begin
  ColorDialog.Color:=ActiveDataForm.PlotPanel.Color;
  if ColorDialog.Execute then
  ActiveDataForm.PlotPanel.Color:=ColorDialog.Color;
end;

procedure TMainForm.AddSerieActionExecute(Sender: TObject);
begin
  with ActiveDataForm.Plot.Series.Add do
  begin
    Container:=ActiveDataForm.Container; Text:=Format(strNewSerie,
    [ActiveDataForm.Plot.Series.Count-1]);
  end;
  UpdateSerieComboBox; UpdateSerieList;                        // add new item
  ActiveDataForm.DMDocument.AddSerieObject;              // add new COM object
end;

procedure TMainForm.AddSerieActionUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled:=(GetActiveCtrlType=actPlot) or
  (((GetActiveCtrlType=actSerieMgr) or (Screen.ActiveForm=SerieMgrForm))
  and Assigned(ActiveDataForm));
end;

procedure TMainForm.NewPlotActionExecute(Sender: TObject);
var Fo,F: TDataForm;
begin
  Fo:=ActiveDataForm; F:=CreateDataForm; F.ViewState:=dfvPlot;
  F.Caption:=Format(strNewPlot,[Fo.Labels[Fo.YColumn]+
    '('+char(byte('A')+Fo.YColumn-1)+')', Fo.Labels[Fo.XColumn]+
    '('+char(byte('A')+Fo.XColumn-1)+')']);
  F.Plot.Series[0].Container:=Fo.Container;
  F.Plot.Series[0].XColumn:=Fo.XColumn;
  F.Plot.Series[0].YColumn:=Fo.YColumn;
  with Fo.Worksheet do
  begin
    F.Plot.Series[0].FirstLine:=Selection.Top-FixedRows;
    F.Plot.Series[0].LastLine:=Selection.Bottom-FixedRows;
  end;
  if AppPropsForm.AutoNameSerieCheckBox.Checked
  then F.Plot.Series[0].Text:=Fo.Labels[Fo.YColumn];
  if Fo.Recording then F.IsRecordingSerie[0]:=true;
  SerieComboBox.Refresh;
end;

procedure TMainForm.NewPlotActionUpdate(Sender: TObject);
begin
  NewPlotAction.Enabled:=(GetActiveCtrlType=actWks) and
  (ActiveDataForm.Worksheet.Selection.Bottom-
  ActiveDataForm.Worksheet.Selection.Top>=1);        // block must be selected
end;

procedure TMainForm.AxisPropertiesActionExecute(Sender: TObject);   // shared!
begin
  AxisPropsForm.ExpressionComboBox.Items.Assign(CalculatorForm.
  ExpressionComboBox.Items);                        // copy expression history
  if Sender=XAxisPropertiesAction then
  begin
    AxisPropsForm.Caption:=strXAxis;
    AxisPropsForm.Execute(ActiveDataForm.Plot.XAxis);
  end else
  begin
    AxisPropsForm.Caption:=strYAxis;
    AxisPropsForm.Execute(ActiveDataForm.Plot.YAxis);
  end;
  CalculatorForm.ExpressionComboBox.Items.Assign(AxisPropsForm.
  ExpressionComboBox.Items);     // save history (changed only if pressed OK!)
end;

procedure TMainForm.SeriePropertiesActionExecute(Sender: TObject);
var I,J: integer;
begin
  with SeriePropsForm do // initialize column, worksheet and Expression combos
  begin
    XExpressionComboBox.Items.Assign(CalculatorForm.ExpressionComboBox.Items);
    YExpressionComboBox.Items.Assign(CalculatorForm.ExpressionComboBox.Items);
    if Assigned(ActiveDataForm.Plot.ThisSerie.Container) then   // copy labels
   XColumnComboBox.Items.Assign((ActiveDataForm.Plot.ThisSerie.Container.Owner
     as TDataForm).Worksheet.Header)                  // from TARGET window!!!
    else XColumnComboBox.Items.Assign(ActiveDataForm.Worksheet.Header);
    with XColumnComboBox do for I:=0 to Items.Count-1 do   // add numbers A..Z
    Items[I]:='['+char(byte('A')+I)+']: '+XColumnComboBox.Items[I];
    YColumnComboBox.Items.Assign(XColumnComboBox.Items);
    Caption:=Format(strSerie,[ActiveDataForm.Plot.SerieIndex{+1 from zero!}]);
    WorksheetComboBox.Clear;
  end;
  J:=-1;
  for I:=0 to MDIChildCount-1 do with (MDIChildren[I] as TDataForm) do
  begin          // for unsaved (temp) windows use caption instead of filename
    SeriePropsForm.WorksheetComboBox.Items.AddObject(
      GetContainerName(Container, false), Container);
    if Container=ActiveDataForm.Plot.ThisSerie.Container then J:=I;//itemindex
  end;
  SeriePropsForm.WorksheetComboBox.ItemIndex:=J;
  if SeriePropsForm.Execute(ActiveDataForm.Plot.ThisSerie) then
  begin                                        // may change Serie attributes!
    SerieComboBox.Refresh; StatusBar.Refresh; UpdateSerieList;
    CalculatorForm.ExpressionComboBox.Items.Assign(SeriePropsForm.
    XExpressionComboBox.Items);   // changes saved only in XExpressionComboBox
  end;
end;

procedure TMainForm.WorksheetPropertiesActionExecute(Sender: TObject);
begin WorksheetPropsForm.Execute(ActiveMDIChild as TDataForm); end;

procedure TMainForm.ScaleXYActionExecute(Sender: TObject);
type ToDo=(zin,zout,shift); var T: ToDo;
  procedure DoScale(A: TAxis; Down: boolean; What: ToDo);
  var D: extended; Incr: integer;                  {called by "Scale" buttons}
  begin
    if ChangeTicksAction.Checked then Incr:=1 else Incr:=0;  // tick increment
    D:=(A.Max-A.Min)/A.MajorTicks; A.AutoScale:=false;
    if What=shift                                                      {shift}
    then begin if Down then D:=-D; A.Max:=A.Max+D; A.Min:=A.Min+D; end else
    begin                                                 {expand or collapse}
      if What=zout
      then begin D:=-D; A.MajorTicks:=A.MajorTicks-Incr; end
      else A.MajorTicks:=A.MajorTicks+Incr;
      if Down then A.Min:=A.Min-D else A.Max:=A.Max+D;
    end;
  end;
begin
  T:=shift; if UnZoomAction.Checked then T:=zin;              // what to do???
  if ZoomAction.Checked then T:=zout;
  if (Sender=ScaleX1Action) or (Sender=ScaleX2Action) then
  DoScale(ActiveDataForm.Plot.XAxis, Sender=ScaleX1Action, T);
  if (Sender=ScaleY1Action) or (Sender=ScaleY2Action) then
  DoScale(ActiveDataForm.Plot.YAxis, Sender=ScaleY1Action, T);
end;

procedure TMainForm.UndoZoomActionExecute(Sender: TObject);
begin ActiveDataForm.Plot.UndoZoom; end;

procedure TMainForm.UndoZoomActionUpdate(Sender: TObject);
begin
  UndoZoomAction.Enabled:=(GetActiveCtrlType=actPlot)
  and ActiveDataForm.Plot.CanUnZoom;
end;

procedure TMainForm.RescaleActionExecute(Sender: TObject);
begin
  with ActiveDataForm.Plot do
  begin XAxis.Autoscale:=true; YAxis.Autoscale:=true; end;
end;

procedure TMainForm.RescaleXActionExecute(Sender: TObject);
begin ActiveDataForm.Plot.XAxis.Autoscale:=true; end;

procedure TMainForm.RescaleYActionExecute(Sender: TObject);
begin ActiveDataForm.Plot.YAxis.Autoscale:=true; end;

procedure TMainForm.ChangeTicksActionExecute(Sender: TObject);
begin with ChangeTicksAction do Checked:=not Checked; end;

procedure TMainForm.ShowToolbarActionExecute(Sender: TObject);
var Bar: TControl;                 // hide/show toolbars - docked OR floating!
begin
  Bar:=nil;
  if Sender=ShowWindowToolbarAction then Bar:=WindowActionToolbar;
  if Sender=ShowScaleToolbarAction then Bar:=ScaleActionToolbar;
  if Sender=ShowPlotToolbarAction then Bar:=PlotActionToolbar;
  if Sender=ShowScaleToolBarAction then Bar:=ScaleActionToolBar;
  if Sender=ShowEditToolBarAction then Bar:=EditActionToolBar;
  if Sender=ShowSerieToolbarAction then Bar:=SeriePanel;
  if Sender=ShowPictureAction then Bar:=PicturePanel;
  (Sender as TAction).Checked:=not (Sender as TAction).Checked;
  if Bar.Floating then Bar.HostDockSite.Visible:=(Sender as TAction).Checked
  else CoolBar.Bands.FindBand(Bar).Visible:=(Sender as TAction).Checked;
  // Note!!! we change Visible property of Band, NOT of toolbar ITSELF!
end;

procedure TMainForm.ShowToolbarActionUpdate(Sender: TObject);
var Bar: TControl;   // floating toolbars may be hidden with window [x] button
begin
  Bar:=nil;
  if Sender=ShowWindowToolbarAction then Bar:=WindowActionToolbar;
  if Sender=ShowScaleToolbarAction then Bar:=ScaleActionToolbar;
  if Sender=ShowPlotToolbarAction then Bar:=PlotActionToolbar;
  if Sender=ShowScaleToolBarAction then Bar:=ScaleActionToolBar;
  if Sender=ShowEditToolBarAction then Bar:=EditActionToolBar;
  if Sender=ShowSerieToolbarAction then Bar:=SeriePanel;
  if Sender=ShowPictureAction then Bar:=PicturePanel;
  if Assigned(Bar) then (Sender as TAction).Checked:=Bar.Visible;
end;

procedure TMainForm.AppPropsActionExecute(Sender: TObject);
begin
  (Sender as TAction).Checked:=not (Sender as TAction).Checked;
  Coolbar.Visible:=ShowCoolbarAction.Checked;
  StatusBar.Visible:=ShowStatusBarAction.Checked;
  Application.ShowHint:=ShowHintsAction.Checked;
end;

procedure TMainForm.SelectSerieActionExecute(Sender: TObject);
var I: integer;
begin
  I:=ActiveDataForm.Plot.SerieIndex;
  if InputInteger(SelectSerieAction.Hint,0,ActiveDataForm.Plot.Series.Count-1,
  1,I) then begin SerieComboBox.ItemIndex:=I; SerieComboBoxChange(nil); end;
end;

end.




