{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit SerieWnd;
{$B-}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, ToolWin, ActnList, Menus, ImgList;

type
  TSerieMgrForm = class(TForm)
    CoolBar: TCoolBar;
    WindowListView: TListView;
    Splitter: TSplitter;
    SerieListView: TListView;
    WindowPopupMenu: TPopupMenu;
    SeriePopupMenu: TPopupMenu;
    ToolBar: TToolBar;
    CopyToolButton: TToolButton;
    PasteToolButton: TToolButton;
    CutToolButton: TToolButton;
    ClearToolButton: TToolButton;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    CutItem: TMenuItem;
    ClearItem: TMenuItem;
    ToolButton1: TToolButton;
    N1: TMenuItem;
    AddSerieItem: TMenuItem;
    N2: TMenuItem;
    SeriePropertiesItem: TMenuItem;
    MinimizeItem: TMenuItem;
    RestoreItem: TMenuItem;
    CloseItem: TMenuItem;
    N3: TMenuItem;
    DuplicateItem: TMenuItem;
    RenameWindowItem: TMenuItem;
    WindowImageList: TImageList;
    TileVerticalItem: TMenuItem;
    TileHorizontalItem: TMenuItem;
    CascadeItem: TMenuItem;
    N4: TMenuItem;
    SerieImageList: TImageList;
    ActionList: TActionList;
    CopyAction: TAction;
    PasteAction: TAction;
    CutAction: TAction;
    ClearAction: TAction;
    RenameWindowAction: TAction;
    PlotLinesToolButton: TToolButton;
    SeriePropertiesToolButton: TToolButton;
    RenameSerieAction: TAction;
    RenameSerieItem: TMenuItem;
    N5: TMenuItem;
    WindowListItem: TMenuItem;
    PasteDataItem: TMenuItem;
    MoveUpAction: TAction;
    MoveDownAction: TAction;
    DeleteAction: TAction;
    MoveUpItem: TMenuItem;
    MoveDownItem: TMenuItem;
    DeleteSerieItem: TMenuItem;
    MoveUpToolButton: TToolButton;
    MoveDownToolButton: TToolButton;
    procedure WindowListViewEdited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure WindowListViewSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure RenameWindowActionExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SerieListViewSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure SerieListViewEdited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure RenameWindowActionUpdate(Sender: TObject);
    procedure RenameSerieActionExecute(Sender: TObject);
    procedure SerieListViewDblClick(Sender: TObject);
    procedure CopyClearCutRenameActionUpdate(Sender: TObject);
    procedure PasteActionUpdate(Sender: TObject);
    procedure ClearActionExecute(Sender: TObject);
    procedure CopyActionExecute(Sender: TObject);
    procedure PasteActionExecute(Sender: TObject);
    procedure CutActionExecute(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure WindowListItemClick(Sender: TObject);
    procedure MoveUpActionExecute(Sender: TObject);
    procedure MoveDownActionExecute(Sender: TObject);
    procedure DeleteActionExecute(Sender: TObject);
    procedure MoveUpActionUpdate(Sender: TObject);
    procedure MoveDownActionUpdate(Sender: TObject);
    procedure DeleteActionUpdate(Sender: TObject);
  protected
    { Protected declarations }
    procedure CreateParams(var Params: TCreateParams); override;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var SerieMgrForm: TSerieMgrForm;

implementation

uses MainWnd, Plot, Clipbrd;

{$R *.dfm}

procedure TSerieMgrForm.CreateParams(var Params: TCreateParams);
begin
  if UseTaskBar then FormStyle:=fsNormal; inherited;  
  if UseTaskBar then Params.ExStyle:=Params.ExStyle or WS_EX_APPWINDOW;
end;

procedure TSerieMgrForm.FormCreate(Sender: TObject);
begin
  CloseItem.ImageIndex:=2;                    // overwrite values from actions
  MinimizeItem.ImageIndex:=0; RestoreItem.ImageIndex:=1;
  SeriePropertiesToolButton.ImageIndex:=31;SeriePropertiesItem.ImageIndex:=31;
end;

//////// listviews events /////////
procedure TSerieMgrForm.WindowListViewEdited(Sender: TObject;
  Item: TListItem; var S: String);
begin
  TForm(Item.Data).Caption:=S; MainForm.UpdateMDIMenu; 
  MainForm.UpdateSerieList;                         // update Worksheet column
end;

procedure TSerieMgrForm.WindowListViewSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin if Selected then TForm(Item.Data).Show; end;

procedure TSerieMgrForm.SerieListViewSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if Selected then
  if Assigned(MainForm) then with MainForm do  // need to check!!!!!!!????????
  if Assigned(ActiveDataForm) and Assigned(SerieComboBox) then
  begin SerieComboBox.ItemIndex:=Item.Index; SerieComboBoxChange(nil); end;
end;

procedure TSerieMgrForm.SerieListViewEdited(Sender: TObject;
  Item: TListItem; var S: String);
begin TSerie(Item.Data).Text:=S; MainForm.SerieComboBox.Refresh; end;

procedure TSerieMgrForm.SerieListViewDblClick(Sender: TObject);
begin if Assigned(SerieListView.Selected) then SeriePropertiesItem.Click; end;

//////// DOCKING SUPPORT ///////////

procedure TSerieMgrForm.FormHide(Sender: TObject);
begin
  if (Parent is TPanel) and (Parent.VisibleDockClientCount=0)
  then MainForm.ShowDockPanel(Parent as TPanel, false);
end;

procedure TSerieMgrForm.FormShow(Sender: TObject);
begin
  if (Parent is TPanel) and (Parent.VisibleDockClientCount=1) and
  MainForm.DocksLoaded then MainForm.ShowDockPanel(Parent as TPanel, true);
end;

//////// Action handlers /////////

procedure TSerieMgrForm.RenameWindowActionExecute(Sender: TObject);
begin
  if Assigned(WindowListView.Selected)
  then WindowListView.Selected.EditCaption;
end;

procedure TSerieMgrForm.RenameWindowActionUpdate(Sender: TObject);
begin (Sender as TAction).Enabled:=Assigned(WindowListView.Selected); end;

procedure TSerieMgrForm.RenameSerieActionExecute(Sender: TObject);
begin
  if Assigned(SerieListView.Selected) then SerieListView.Selected.EditCaption;
end;

procedure TSerieMgrForm.CopyClearCutRenameActionUpdate(Sender: TObject);
begin (Sender as TAction).Enabled:=Assigned(SerieListView.Selected); end;

procedure TSerieMgrForm.PasteActionUpdate(Sender: TObject);
begin                             // note: shared with MainForm.PasteAction!!!
  (Sender as TAction).Enabled:=Assigned(SerieListView.Selected) and
  Clipboard.HasFormat(TSerie.GetClipboardFormat);
end;

procedure TSerieMgrForm.PasteActionExecute(Sender: TObject);
begin
  if not TSerie(SerieListView.Selected.Data).PasteFromClipboard(PasteDataItem.
  Checked) then MessageBeep($FFFFFFFF);
  MainForm.UpdateSerieList; MainForm.SerieComboBox.Refresh;
end;

procedure TSerieMgrForm.ClearActionExecute(Sender: TObject);
begin MainForm.ClearSerieAction.Execute; end;

procedure TSerieMgrForm.CopyActionExecute(Sender: TObject);
begin TSerie(SerieListView.Selected.Data).CopyToClipboard; end;

procedure TSerieMgrForm.CutActionExecute(Sender: TObject);
begin CopyAction.Execute; ClearAction.Execute; end;

procedure TSerieMgrForm.WindowListItemClick(Sender: TObject);
begin
  Splitter.Visible:=WindowListItem.Checked;
  WindowListView.Visible:=WindowListItem.Checked;
end;

procedure TSerieMgrForm.MoveUpActionExecute(Sender: TObject);
var I: integer;
begin
  I:=SerieListView.Selected.Index;
  TSerie(SerieListView.Selected.Data).Index:=I-1;
  MainForm.ActiveDataForm.DMDocument.SwapSerieObjects(I,I-1);
  MainForm.UpdateSerieList; MainForm.UpdateSerieComboBox;
end;

procedure TSerieMgrForm.MoveUpActionUpdate(Sender: TObject);
begin
  MoveUpAction.Enabled:=Assigned(SerieListView.Selected) and
  (SerieListView.Selected.Index>0);
end;

procedure TSerieMgrForm.MoveDownActionExecute(Sender: TObject);
var I: integer;
begin
  I:=SerieListView.Selected.Index;
  TSerie(SerieListView.Selected.Data).Index:=I+1;
  MainForm.ActiveDataForm.DMDocument.SwapSerieObjects(I,I+1);
  MainForm.UpdateSerieList; MainForm.UpdateSerieComboBox;
end;

procedure TSerieMgrForm.MoveDownActionUpdate(Sender: TObject);
begin
  MoveDownAction.Enabled:=Assigned(SerieListView.Selected) and
  (SerieListView.Selected.Index<SerieListView.Items.Count-1);
end;

procedure TSerieMgrForm.DeleteActionExecute(Sender: TObject);
begin
  MainForm.ActiveDataForm.DMDocument.DeleteSerieObject(
    SerieListView.Selected.Index);
  TSerie(SerieListView.Selected.Data).Free;
  MainForm.UpdateSerieList; MainForm.UpdateSerieComboBox;
end;

procedure TSerieMgrForm.DeleteActionUpdate(Sender: TObject);
begin
  DeleteAction.Enabled:=Assigned(SerieListView.Selected) and
  (SerieListView.Items.Count>1);     // we need to have at least 1 serie since
end; // large pieces of code (mostly in MainWnd.pas) assume that # of series>0 

end.
