{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit Splash;
{$B-,X+}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, MMSystem, jpeg;

type
  TSplashForm = class(TForm)
    Image: TImage;
    BuildLabel: TLabel;
    ProgressLabel: TLabel;
    Timer: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    VersionLabel: TLabel;
    CopyrightLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  end;

var SplashForm: TSplashForm;

procedure SplashProgress(S: string);
procedure MakeForm(C: TComponentClass; var F);

implementation

uses About, Strings;

{$R *.DFM}

procedure MakeForm(C: TComponentClass; var F);
begin
  SplashProgress(Format(strCreateForm,[C.ClassName]));
  Application.CreateForm(C,F);
end;

procedure SplashProgress(S: string);
begin
  if Assigned(SplashForm) then with SplashForm do
  begin ProgressLabel.Caption:=S; ProgressLabel.Refresh; end;
end;

procedure TSplashForm.FormCreate(Sender: TObject);
const NStep=20; OrgSizeFactor=3; TotalTime=500;         {for explosion effect}
var Dc: HDc;  {drawing vars}
    OldPen, NewPen: HPen;
    OldBrush, NewBrush: HBrush;
    OldROP: Integer;
    I{,J},W,H: longint;
begin
  {$ifdef STARTSOUND}
  PlaySound('start',hInstance,SND_ASYNC or SND_RESOURCE);
  {$endif}
  BuildLabel.Caption:=Format(BuildLabel.Caption,
    [GetVersionString('FileVersion', Application.EXEName)]);
  VersionLabel.Caption:=VersionLabel.Caption+
    GetVersionString('ProductVersion', Application.EXEName);
  CopyrightLabel.Caption:=
    GetVersionString('LegalCopyright', Application.EXEName);
  if IsPreRelease then
  begin    // to show labels, set "Pre-release" module flag in Project|Options
    Label1.Visible:=true; Label2.Visible:=true;
    Label3.Visible:=true; Label4.Visible:=true;
  end;
  Screen.Cursor:=crHourglass; Dc:=GetDc(0); NewPen:=GetStockObject(BLACK_PEN);
  NewBrush:=GetStockObject(NULL_BRUSH);  OldPen:=SelectObject(Dc,NewPen);
  OldBrush:=SelectObject(Dc,NewBrush); OldROP:=SetROP2(Dc,R2_NOTXORPEN);
  try
    for I:=1 to NStep do
    begin
    //  J:=GetTickCount;
      W:=round(Width*(I/NStep+1/OrgSizeFactor*(1-I/NStep)));
      H:=round(Height*(I/NStep+1/OrgSizeFactor*(1-I/NStep)));
      DrawFocusRect(DC,Rect((Screen.Width-W) div 2,(Screen.Height-H) div 2,
                   (Screen.Width+W) div 2,(Screen.Height+H) div 2));
    //  while GetTickCount<J+(TotalTime div NStep) do J:=J;
      GDIFlush; Sleep(TotalTime div NStep);
    end;
  finally
    SelectObject(Dc,OldPen); SelectObject(Dc,OldBrush); SetRop2(Dc,OldRop);
    ReleaseDC(0,Dc); Show; Refresh;
  end;
end;

procedure TSplashForm.TimerTimer(Sender: TObject);
begin
  if Timer.Interval<>100 then begin Refresh;{!!!} Timer.Interval:=100; end;
  AlphaBlendValue:=AlphaBlendValue-12; if AlphaBlendValue>5 then Exit;
  Timer.Enabled:=false; Hide; Screen.Cursor:=crDefault; Close;
end;

procedure TSplashForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin SplashForm:=nil; Action:=caFree; end;

end.
