{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit StrDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TInputStringForm = class(TForm)
    OkBitBtn: TBitBtn;
    CancelBitBtn: TBitBtn;
    Label1: TLabel;
    ComboBox: TComboBox;
    TextSpeedButton: TSpeedButton;
    procedure TextSpeedButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var InputStringForm: TInputStringForm;

function InputString(Title: string; List: TStrings; var Res: string;
  ShowTextButton: boolean=false): boolean;

implementation

uses TextDlg;

{$R *.DFM}

function InputString(Title: string; List: TStrings; var Res: string;
  ShowTextButton: boolean=false): boolean;
begin
  InputStringForm:=TInputStringForm.Create(Application);
  try
    if Title<>'' then InputStringForm.Label1.Caption:=Title;
    InputStringForm.TextSpeedButton.Visible:=ShowTextButton;
    if not ShowTextButton then InputStringForm.ComboBox.Width:=
    InputStringForm.ComboBox.Width+InputStringForm.TextSpeedButton.Width;
    if Assigned(List) then InputStringForm.ComboBox.Items.Assign(List);
    InputStringForm.ComboBox.Text:=Res;
    Result:=InputStringForm.ShowModal=mrOk; if not Result then Exit;
    Res:=InputStringForm.ComboBox.Text;
    with InputStringForm.ComboBox do
    if (Text<>'') and (Items.IndexOf(Text)=-1) then Items.Insert(0, Text);
    if Assigned(List) then List.Assign(InputStringForm.ComboBox.Items);
  finally
    InputStringForm.Free;
  end;
end;

procedure TInputStringForm.TextSpeedButtonClick(Sender: TObject);
var S: string;
begin
  S:=ComboBox.Text; if InputText(S,ComboBox) then ComboBox.Text:=S;
end;

end.
 