{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit TestDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Buttons, ExtCtrls, Plot, Data, Gauges;

type
  TSpeedTestForm = class(TForm)
    Plot: TPlot;
    Container: TContainer;
    Panel: TPanel;
    Label1: TLabel;
    OkBitBtn: TBitBtn;
    RunBitBtn: TBitBtn;
    HelpBitBtn: TBitBtn;
    SpinEdit: TSpinEdit;
    ProcessorRadioButton: TRadioButton;
    VideoRadioButton: TRadioButton;
    ResultPanel: TPanel;
    Gauge: TGauge;
    Label3: TLabel;
    Label2: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    ResultEdit: TEdit;
    procedure RunBitBtnClick(Sender: TObject);
    procedure ModeRadioButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure ShowSpeedTest;

implementation

const P120=24.0;

{$R *.DFM}

procedure ShowSpeedTest;
begin
  with TSpeedTestForm.Create(Application) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TSpeedTestForm.RunBitBtnClick(Sender: TObject);
var I,J: dword; R: double;
begin                          // note: ResultXXX display MUST be TWinControl!
  J:=GetTickCount;
  for I:=1 to SpinEdit.Value do
  begin
    ResultEdit.Text:='Cycle '+IntToStr(I); ResultEdit.Refresh; Plot.Refresh;
  end;
  R:=SpinEdit.Value*1000/(GetTickCount-J);
  ResultEdit.Text:=FloatToStrF(R,ffFixed,5,1)+' cycles/s';
  with Gauge do Progress:=Round(R*MaxValue/P120/(1+R/P120));
  ResultPanel.Visible:=true;
end;

procedure TSpeedTestForm.ModeRadioButtonClick(Sender: TObject);
begin
  ResultPanel.Visible:=false;
  Plot.Series[0].IsFunction:=ProcessorRadioButton.Checked;
  if VideoRadioButton.Checked then Plot.Series[1].XColumn:=1
  else Plot.Series[1].XColumn:=0;
end;

end.
